###########################################################################
## Talk System Data Base
###########################################################################

# Bad translations by me. Good ones by Jacen 8)



import Talk


###########################################################################
## Standard Dialogs
###########################################################################


## Alone: The player says these texts when there is not nobody faced
##-------------------------------------------------------------------------

TSDB.Alone = [" Hay alguien ah !",
	      "No me gusta como se est poniendo esto...",
	      " Espera !... Creo que he escuchado algo",
	      "Este lugar parece desierto"]

              
## Alone: The player says these texts when the faced character doesn't
## have assigned any dialogue.
##-------------------------------------------------------------------------
              
TSDB.Ignore = ["Estas muy callado, amigo.",
               "Me ignora.... seguro",
               " Ests SORDO ?",
               " Hola !"]              
               
               
###########################################################################
## Customized dialogs for each character
###########################################################################

## Dlg Database:
## Format:
##    TSDB.Dlg [pers.Name]={
##           'dlgId': {
##              'Text':
##                """Texto libre""",
##               'Answers': ['ansId1',...'ansIdn']
##              'OtherKey': value
##           }
##    }
##
## * Text: The text will be formatted for TS.
## * Answer: List of answers (ansId). If the list is null [] the
##   conversation is stopped.
##  Please read the documentation to know the details
##
##-------------------------------------------------------------------------

###########################################################################
## Player Answers
###########################################################################

## Answers Database:
## Format:
##   TSDB.Ans [pers.Name]={
##	'ansId': {
##	    'Text':
##	     """Texto""",
##	    'NextDlg': 'ansId',
##	    'Enabled':1
##          'OtherKey': value
##       }
##    }
## * Text: The text will be formatted for TS.
## * NextDlg: The identifier of the next dialogue (dlgId). To stop a  
##   conversation: None.
##  Please reads the documentation to know the details
##-------------------------------------------------------------------------
##########################################################################################################################
####   Henry the InnKeeper     ###########################################################################################
##########################################################################################################################


TSDB.Dlg ["Henry"]={
	'whogoesthere': {
	   'Text':
	     """Eh t! Qu te trae a este lugar solitario? """,
           'Answers': ['friend'],
           'CallBack':'LookAtMeWhenImTalkingToYou', 
           'NewDlg': None
        },
	'comein': {
	    'Text':
	     """Eres bienvenido %PlayerName. Ven dentro y calintate. Debes estar helado! """\
	     """Eres la primera cara amistosa que he visto en mucho tiempo.""",
            'Answers': [],
            'CallBack':'ComenceAttack',
            'NewDlg': None
        },
	'thereisdanger': {
	    'Text':
	     """Eres bienvenido a todo lo que puedas encontrar en mi humilde casa, pero ten cuidado ! """\
	     """Hay peligro. Hay muchos Orcos peligrosos acampados cerca de las rocas.  Aproximadamente por la noche ellos """\
	     """me hacen una visita. Me temo que tengo poco que ofrecerte como refresco. """\
	     """Esos Orcos me han cogido todos mis suministros. """,
            'Answers': ['icanhelp'],
            'CallBack':'LookAtMeWhenImTalkingToYou', 
            'NewDlg': None
        },
	'ihearthemcoming': {
	    'Text':
	     """Hablas como un Guerrero! Pero escucha! ...Creo que les oigo venir. """,
	    'Answers': ['illsortthemout'],
            'NewDlg': None
        },
        'thatsthelot': {
	    'Text':
	     """Creo que estn todos, pero estoy seguro que hay unos poco ms en las """\
	     """rocas por la parte de atrs de la casa. Nosotros los destruiremos para bien? """,
	    'CallBack':'ResetTalkstate', 
            'Answers': ['letsgo'],
            'NewDlg': None
        },
        'finished': {
	    'Text':
	     """Dioses! ...Ese era el Jefe Orco. Ahora, con l muerto, no tendr ms problemas. """\
	     """Debemos buscar en las rocas. Los Orcos tienen un campamento por all. Puede haber todava algo de mi """\
	     """comida que an no se hayan comido. Estoy seguro que ambos podramos hacer una buena comida. """,	
	    'CallBack':'ResetTalkstate',     
            'Answers': ['imfit','imverytired'],
            'NewDlg': None
        },
        'finished2': {
	    'Text':
	     """Dioses! ...Ese era el Jefe Orco. Ahora, con l muerto, no tendr ms problemas. """\
	     """Los Orcos tienen un campamento por las rocas. Puede haber todava algo de mi comida all"""\
	     """Pero me he pegado un palizn y no tengo fuerzas para subir.""",
	    'CallBack':'ResetTalkstate', 	    
            'Answers': ['waitdownhere'],
            'NewDlg': None
        },
        'thatsthelot2': {
	    'Text':
	     """Creo que estn todos %PlayerName,  pero yo no vi al Jefe Orco. Debe haber ms de ellos escondidos """\
	     """en las rocas, en la parte de atrs de la casa. Echar una mirada alrededor. """\ 
	     """Ves dentro y mira si puedes encontrar algunas pociones para tus heridas. """,
	    'CallBack':'SetReturnTrigger', 	   	    
            'Answers': ['willdo'],
            'NewDlg': None
        },
        'getmyclub': {
	    'Text':
	     """Est demasiado callado ah fuera. Estoy seguro que hay todava algunos Orcos acechando. Debo conseguir mi maza GRANDE. """,
            'Answers': ['illhavealook'],
            'CallBack':'HenryHasSpoken2', 
            'NewDlg': None
        },
        'sneakround': {
	    'Text':
	     """Ten cuidado %PlayerName. no te apresures. Yo saldr furtivamente, rodeando por el otro camino. """,
            'Answers': [],
            'CallBack':'HenryHasSpoken2', 
            'NewDlg': None
        },
        'fightingtalk': {
	    'Text':
	     """Por los Dioses! ... eso son palabras de guerrero! Hace muchos aos desde que yo hice tajos con un hacha en la ltima  ... """\
	     """Gran Guerra de la Espada. Pero escucha! Creo que oigo que ellos se acercan......  """,
            'Answers': ['illsortthemout'],
            'NewDlg': None
        },
        'bloodsup': {
	    'Text':
	     """Ha! Bien dicho %PlayerName .... tengo ganas de luchar ahora. """,
	    'CallBack':'HenryHasSpoken1', 
            'Answers': [],
            'NewDlg': None
        },
        'illwaithere': {
	    'Text':
	     """Bien %PlayerName..... esperar aqu hasta que vuelvas. """,
            'Answers': [],
            'NewDlg': None
        },
        'illwaithere2': {
	    'Text':
	     """Bien %PlayerName...  esperar aqu. Ten cuidado. """,
            'Answers': [],
            'NewDlg': None
        },
        'oldbones': {
	    'Text':
	     """Ay! ... temo que yo no estoy tan en forma como antes. Estos viejos huesos me estn crujiendo mucho. """\
	     """T ve primero y echa una mirada y yo ver si puedo subir despus de ti. """,
            'Answers': [],
            'NewDlg': None
        },
        'getsomesleep': {
	    'Text':
	     """ se era un mal momento %PlayerName! Pero ve, hay algunas cajas de comida y tres barriles de cerveza que no han sido """\
	     """tocados. Pero pareces cansado. Ve dentro y descansa. yo conseguir la comida y preparar un buen desayuno """\
	     """para cuando te levantes. """,
	    'CallBack':'ResetTalkstate', 
            'Answers': ['yesimknackered'],
            'NewDlg': None
        },
        'gnight': {
	    'Text':
	     """Puedes dormir bien %PlayerName, te lo has ganado! """,
	    'Answers': [],
	    'HideDelay':7, 
	    'CallBack':'ToBed', 
            'NewDlg': None
        },
        'itsagoodjob': {
	    'Text':
	     """se era un Troll de piedra? Ests bien? Lo siento, no he podido levantarme para ayudarte. """\    
	     """Malditas sean mis piernas viejas! """,
	    'Answers': ['noprob'],
	    'CallBack':'LookAtMeWhenImTalkingToYou', 
            'NewDlg': None
        },
        'manage': {
	    'Text':
	     """Ha! sa es una buena noticia! Yo siento que mi fuerza vuelve. Ya has hecho ms que bastante esta noche. """\
	     """Vaya dentro y descansa. Yo recuperar los suministros y preparar el desayuno para cuando te levantes. """,
	    'Answers': ['advice'],
            'NewDlg': None
        },
        'ugohavealook': {
	    'Text':
	     """Bien! Echa una mirada en la parte de atrs de la casa y mira si hay alguien. Yo conseguir mi """\
	     """vieja maza y saldr furtivamente rodeando por el otro lado. Ten cuidado. """,
	    'Answers': [],
	    'CallBack':'HenryHasSpoken2', 
            'NewDlg': None
        },
        'thatsthelot3': {
	    'Text':
	     """Pienso que eran todos por ahora, deben haber ms escondidos por arriba de las rocas detrs de la casa. Pero """\
	     """%PlayerName ests gravemente herido. yo tengo unas pociones escondidas. Mira si puedes encontrar algunas. Cuando """\
	     """ests con buena salud, nosotros cojeremos al ltimo de los Orcos. Entretanto yo saldr furtivamente alrededor y ver si yo """\
	     """puedo ver acechando a alguien. """,
	    'CallBack':'ResetTalkstate', 
	    'Answers': ['iamwounded'],
            'NewDlg': None
        },
        'lookforpotions': {
	    'Text':
	    """No puedo recordar exactamente donde escond las pociones, as que tendrs que buscarlas. """\  
	    """Yo conseguir mi maza GRANDE.. """,
	    'Answers': [],
	    'CallBack':'HenryHasSpoken2', 
            'NewDlg': None
        },
        'goodmorning': {
	    'Text':
	     """Buenos das, Has dormido bien %PlayerName? El desayuno est esperndote en el piso inferior.""",
	    'Answers': ['yesthankx'],
            'NewDlg': None
        },
        'leasticando': {
	    'Text':
	     """T eres ms que bienvenido! Qudate cuanto quieras, estar encantado de tener compaa. """\
	     """Yo haba tenido una buena bsqueda alrededor del campamento de Orcos mientras estabas durmiendo. """\
	     """La mayora de sus armas eran muy inferiores. Yo las vender para pagar toda la cerveza que ellos se han bebido. """\
	     """Encontr una armadura decente y una arco bueno. Puedes hacer uso de ellos. """, 
	    'CallBack':'BreakfastReady', 
	    #'HideDelay':25, 
	    'Answers': ['surecan'],
            'NewDlg': None
        },
        'plans': {
	    'Text':
	     """ Cuales son ahora tus planes %PlayerName?   """,
	    'CallBack':'ResetTalkstate', 
	    'Answers': ['journeyon'],
            'NewDlg': None
        },
        'heardofthem': {
	    'Text':
	     """Hmmmm... .he odo cuentos de esos malditos perros. Algunos dicen que ellos sirven al Hechicero, Dal Gurak. """,
	    'Answers': ['directions'],
            'NewDlg': None
        },
        'key': {
	    'Text':
	     """Quieres decir el Monasterio viejo. No queda demasiado lejos, al oeste. Yo no he estado all hace"""\
	     """un ao largo. La entrada al final del camino lleva encima de un gran puente y a travs de una garganta. """,  
	     """ste es el camino que debes tomar. """,
	    'Answers': ['opengate'],
            'NewDlg': None
        },
        'cellar': {
	    'Text':
	     """La verja ha estado cerrada durante muchos aos, pero yo tengo la llave. Est en el stano. """\
	     """Pero yo rehuyo bajar all. Hace algunos aos un amigo mo entr all y nunca  """\ 
             """ha salido. Temo que el lugar est infectado de algo muy desagradable. """,
	    'Answers': ['iwillsortitout'],
            'NewDlg': None
        },
        'brave': {
	    'Text':
	     """Bien %PlayerName, sal por la puerta trasera y abajo de las escaleras a la derecha. Lleva una antorcha contigo. """\
	     """Las criaturas que viven en la oscuridad a veces tienen miedo del fuego. """,
	    'Answers': ['iwillsortitout'],
	    'CallBack':'OpenCellar', 
            'NewDlg': None
        },
        'haveyougotit': {
	    'Text':
	     """Qu pas %PlayerName? La puerta se ha solidificado! """,
	    'CallBack':'ResetTalkstate', 
	    'Answers': ['gotkey'],
            'NewDlg': None
        },
        'good': {
	    'Text':
	     """Eso parece una buena idea. Yo ir y conseguir algunas clavos! """,
	    'Answers': [],
	    'CallBack':'DropHammer1', 
            'NewDlg': None
        },
        'byeee': {
	    'Text':
	     """Siento verte marchar %PlayerName. Descanso asegurado, con tal de que haya un fuego rugiendo """\    
	     """habr un lugar para t al lado. """,
	    'Answers': ['moveon'],
            'NewDlg': None
        },
        'gift': {
	    'Text':
	     """Antes de que te vayas, tengo algo para t. Toma este amuleto. Me lo dieron hace muchos aos, """\   
	     """en mis das de luchador. Yo nunca tuve razones para usar su poder. salo sabiamente. Podra salvarte la """\
	     """piel en una situacin desesperada. """,
	    'CallBack':'PassAmulet1', 
	    'Answers': ['whoknows'],
            'NewDlg': None
        },
        'mendfire': {
	    'Text':
	     """Un placer, %PlayerName. Oh mira!... el fuego est casi fuera. """,
	    'CallBack':'HenryMendFire', 
	    'Answers': [],
            'NewDlg': None
        }
}


TSDB.Ans ["Henry"]={
	'friend': {
	    'Text':
	     """No temas al Posadero, yo soy un amigo. Yo he viajado lejos por """\
	     """estas montaas y dara la bienvenida a una cama caliente para la noche y alguna comida. """\
	     """Mi nombre es %PlayerName. """,
	    'NextDlg': 'comein',
	    'Enabled':1
	},	
	'illsortthemout': {
	    'Text':
	     """No te preocupes! Si ellos vienen cerca, ellos sentirn el toque de mi %wep. """,
	    'NextDlg': 'bloodsup',
	    'Enabled':1
        },	
	'letsgo': {
	    'Text':
	     """S!... vamos ve y acaba cone ellos mientras yo estoy en el humor!  """,
	    'NextDlg': 'ugohavealook',
	    'Enabled':1
        },
	'imverytired': {
	    'Text':
	     """Yo estoy muy cansado de toda esta lucha y mis heridas estn graves. Ver si puedo """\ 
	     """encontrar ms pociones antes de que nos aventuremos. Quin sabe lo que puede estar acechando a all. """,
	    'NextDlg': 'illwaithere',
	    'Enabled':1
	},
	'imfit': {
	    'Text':
	     """Yo me encuentro bien. Y t? Ests en forma para subir las rocas? """,
	    'NextDlg': 'oldbones',
	    'Enabled':1
        },
	'willdo': {
	    'Text':
	     """S, yo lo har, pero ten cuidado... y di si necesitas ayuda. """,
	    'NextDlg': None,
	    'Enabled':1
	}, 
	'illhavealook': {
	   'Text':
	    """Yo ir a echar una mirada. Si oyes ruido de acero, ven corriendo. """,
	  
	   'NextDlg': None,
	   'Enabled':1
	}, 
	'icanhelp': {
	   'Text':
	    """Los Orcos no son mis amigos en ningn caso! Si ellos muestran sus feas caras esta noche, nosotros debemos ser capaces """\
	    """de derrotarlos juntos. """,
	   'NextDlg': 'fightingtalk',
	   'Enabled':1
	}, 
	'yesimknackered': {
	   'Text':
	    """se fue un buen trabajo nocturno Henry! Pienso que tomar tu consejo. Nosotros hablaremos de nuevo por la maana. """,
	   'NextDlg': 'gnight',
	   'Enabled':1
	}, 
	'noprob': {
	   'Text':
	    """No te preocupes Henry. Yo he visto monstruos ms grandes en mis viajes. Pero celebrmoslo. All """\  
	    """hay ms comida y tres barriles de cerveza. """,
	   'NextDlg': 'manage',
	   'Enabled':1
	}, 
	'advice': {
	   'Text':
	    """Bien Henry. Yo tomar tu consejo. Nosotros hablaremos de nuevo por la maana. """,
	   'NextDlg': 'gnight',
	   'Enabled':1
	}, 
	'iamwounded': {
	   'Text':
	    """Me han hecho varias heridas y estoy muy cansado. No pienso que pueda sobrevivir a otra lucha. """\
	    """Encontrar las pociones y me encontrar contigo en el campo. No intentes atacarlos hasta que yo llegue all. """,
	   'NextDlg': 'lookforpotions',
	   'Enabled':1
	}, 
	'seeyouroundthere': {
	   'Text':
	    """Estar bien si puedo encontrar unas pociones. """\
	    """Si ves Orcos, no los ataques hasta que yo llegue all. """,
	   'NextDlg': 'None',
	   'CallBack':'HenryHasSpoken2', 
	   'Enabled':1
	}, 
	'illwaithere2': {
	   'Text':
	    """Espera aqu abajo Henry. Yo echar una mirada. """,
	   'NextDlg': None,
	   'Enabled':1
	}, 
	'waitdownhere': {
	   'Text':
	    """Pareces un poco cansado Henry. Qudate aqu, yo echar una mirada. """,
	   'NextDlg': None,
	   'Enabled':1
	}, 
	'yesthankx': {
	   'Text':
	    """S, gracias Henry. Tengo mucha hambre. """,
	   'NextDlg': 'leasticando',
	   'Enabled':1
	}, 
	'journeyon': {
	   'Text':
	    """Me gustara quedarme aqu un rato contigo Henry, pero temo traer slo problema a tu casa. """\
	    """La Guardia Negra est buscndome. Yo consegu eludir sus emboscadas y escap por estas montaas, pero ellos son muy """\
	    """tenaces. Estn seguros de alcanzarme ms pronto o ms tarde.""", 
	   'NextDlg': 'heardofthem',
	   'Enabled':1
	}, 
	'directions': {
	   'Text':
	    """S, es correcto. Hace algunos aos yo me atrev a desafiarlo, pero sa es otra historia. Yo o que en alguna parte """\
	    """en estas montaas hay un santuario, ms all del alcance de su rgimen malvado.""",
	   'NextDlg': 'key',
	   'Enabled':1
	}, 
	'opengate': {
	   'Text':
	    """Yo vi la entrada anoche, tienes la llave? """,
	   'NextDlg': 'cellar',
	   'Enabled':1
	}, 
	'iwillsortitout': {
	   'Text':
	    """Oh bien, yo tengo una pequea opcin para intentar.""",
	   'NextDlg': 'brave',
	   'Enabled':1
	}, 
	'gotkey': {
	   'Text':
	    """Creme Henry, no quieras saber. Si yo fuera t, cerrara la puerta """\    
	    """y nunca entrara all de nuevo. Consegu la llave aunque.....""",
	   'NextDlg': 'good',
	   'Enabled':1
	}, 
	'moveon': {
	   'Text':
	    """Gracias Henry, Pero yo debo continuar adelante. Sera arriesgado para los dos si yo me quedara. """,
	   'NextDlg': 'gift',
	   'Enabled':1
	}, 
	'whoknows': {
	   'Text':
	    """Gracias de nuevo. Quin sabe qu peligros habr delante en el camino. """,
	   'NextDlg': 'None',
	   'CallBack':'CamBack2Player', 
	   'Enabled':1
	}, 
	'surecan': {
	   'Text':
	    """Puedo ver que has estado muy ocupado Henry. """,
	   'NextDlg': 'mendfire',
	   'Enabled':1
        }
}

##########################################################################################################################
######################################## Harold ##########################################################################
##########################################################################################################################         

TSDB.Dlg ["Harold"]={
	'hellothere': {
	    'Text':
	     """Hola ! """,
	   'CallBack':'ResetTalkstate', 
           'Answers': ['whatshappening'],
           'NewDlg': None
        },
	'stuck': {
	    'Text':
	     """Ay! Temo que estamos en tiempos difciles. Mis compaeros y yo estbamos en el Monasterio, """\
	     """ pero una fuerza malvada ha invadido el lugar. Nosotros tenamos que huir para salvar nuestras vidas! Entonces algunos monstruos peludos """\
	     """enormes cayeron sobre nosotros. Afortunadamente eran demasiado grandes para entrar por el hueco de las grandes puertas. """,
            'Answers': ['passable'],
            'NewDlg': None
        },
	'yousure': {
	    'Text':
	     """El viejo Henry!...Todava est vivo? Seremos bienvenidos en su hogar. Pero temo que no podrs viajar ms all. """\
	     """Las bestias han bloqueado el camino con las piedras grandes. Nosotros pusimos una caja grande de plvora para intentar destruir """\
	     """la barrera, pero nos marchamos antes de que pudiramos encenderla. La mitad de nuestro grupo muri en el intento. """,
            'Answers': ['maybenot'],
            'NewDlg': None
        },
	'arrows': {
	    'Text':
	     """Nosotros tenamos una aljaba de flechas de fuego, pero las perdimos en la batalla. Nosotros no nos atrevemos a intentar """\
	     """ recuperarlas. Si puedes encontrarlas tal vez tengas una oportunidad........ Pero dispara desde tan lejos como puedas, """\
	     """la explosin ser muy poderosa! """,
            'Answers': ['haveago'],
            'NewDlg': None
        }
}           
           
           
TSDB.Ans ["Harold"]={
	'whatshappening': {
	    'Text':
	     """Saludos! No esperaba encontrarme a nadir en este camino desamparado. """,
	    'NextDlg': 'stuck',
	    'Enabled':1
	}, 
	'passable': {
	   'Text':
	    """Mi intencin es continuar el viaje hacia el Monasterio. Pero ahora la Verja del Dragn est """\
	    """abierta, puedes buscar resguardo con Henry el Posadero. Yo seguir y ver si tus monstruos peludos quieren lucha! """,
	   'NextDlg': 'yousure',
	   'Enabled':1    
	}, 
	'maybenot': {
	   'Text':
	    """Cmo estaba planeado detonar el explosivo? """,
	   'NextDlg': 'arrows',
	   'CallBack':'SetUpMinos', 
	   'Enabled':1    
	}, 
	'haveago': {
	   'Text':
	    """Bien, yo lo intentar. Ninguna bestia me bloquear el camino. No me preocupa cmo de grande y peluda pueda ser! """,
	   'NextDlg': None,
	   'Enabled':1    
        }
}           
           
############################################################################################################################
########################### Hector #########################################################################################
############################################################################################################################


TSDB.Dlg ["Hector"]={
	'letmeout': {
	    'Text':
	     """Dme ! qu ests haciendo en este lugar infernal? 
	   'CallBack':'ResetTalkstate', 
           'Answers': ['sanctuary'],
           'NewDlg': None
        },
	'changed': {
	    'Text':
	     """Ay mi amigo, los tiempos han cambiado y no para bien. La sombra de mal ha cado en este lugar bendito. """\
	     """ Algunos de nosotros planeamos escapar, pero alguno de mi clan y yo fuimos tirados a estos calabozos sucios. """\
	     """Incluso algunos Orcos fueron encarcelados. """,
	    'CallBack':'SetGolem', 
            'Answers': ['getout'],
            'NewDlg': None
        },
	'wearefree': {
	    'Text':
	     """Ha!.... los monstruos grandes de metal no son ningn reto para un Enano con una maza grande. """,
            'Answers': ['gofurther'],
            'NewDlg': None
        },
	'metalmonster': {
	    'Text':
	     """Mira la puerta grande a tu derecha. Ms all de ella hay un gran monstruo de metal. Yo pienso que las """\
	     """puertas se controlan desde alguna parte de all. El monstruo es poderoso pero lento. Si puedes apaartelas para """\
	     """ abrir las celdas, nosotros podemos ayudarte a matarlo. """,
            'Answers': ['dooropen'],
            'NewDlg': None
        },
	'dontreleasetheorks': {
	    'Text':
	     """Gracias %PlayerName. Estate listo para una lucha dura. Intenta no soltar Orcos! Ellos no han sido alimentados durante das. """,
            'Answers': [],
            'NewDlg': None
        }
}           
           
           
TSDB.Ans ["Hector"]={
	'sanctuary': {
	    'Text':
	     """Yo me llamo %PlayerName. He viajado desde muy lejos para buscar el santuario dentro de estas paredes, """\    
	     """pero hasta ahora slo he encontrado peligros. """,
	    'NextDlg': 'changed',
	    'Enabled':1
	}, 
	'gofurther': {
	   'Text':
	    """Tienes mucha razn Hctor. Me pregunto qu ms estar acechando el lugar.  """,
	   'NextDlg': None,
	   'Enabled':1    
	}, 
	'getout': {
	   'Text':
	    """Cmo puedo ayudarte? Yo entr desde fuera a travs de un gran agujero, pero t no puedes salir as. """,
	   'NextDlg': 'metalmonster',
	   'Enabled':1   
	}, 
	'dooropen': {
	   'Text':
	    """Ver si puedo abrir la puerta. Unos buenos golpes deben llamar la atencin del monstruo. """,
	   'NextDlg': 'dontreleasetheorks',
	   'Enabled':1             
        }
}    

#############################################################################################################################
##################### Tom ###################################################################################################
#############################################################################################################################

TSDB.Dlg ["Tom"]={
	'tominst1': {
	    'Text':
	     """Saludos amigo! Has llegado en el momento justo. Ay, las cosas estn lejos de ir bien! """\    
	     """Una maldicin ha cado en este lugar! La muerte se ha levantado de sus eternos letargos y camina por fuera."""\     
	     """Ellos estn en mi cocina mientras nosotros hablamos, pero yo cerr la puerta con llave. Yo no he pegado un bocado durante das. """\    
	     """Yo tambin tena una cacerola de estofado en el fuego ......... """,
	    'CallBack':'LookAtMeWhenImTalkingToYou', 
            'Answers': ['canihelp'],
            'NewDlg': None
        },
	'tominst2': {
	    'Text':
	     """No s, pero tienes la mirada de un luchador experimentado. Busca a Colin. l es el ms sabio en nuestra """\      
	     """ orden. l se ha encerrado con llave en el Scriptorium. Tendrs que dar un golpe en la puerta para ganar su atencin. """\    
	     """Si alguien sabe lo que puede hacerse, es l. """,
            'Answers': ['illdothat'],
            'NewDlg': None
        },
	'tominst3': {
	    'Text':
	     """Temo que no ser fcil. La mayora de las puertas se han cerrado con llave para intentar contener """\  
	     """los espritus de los no-muertos. """\  
	     """Puede haber un camino a travs del Acuario. Sube la escalera y sal por el corredorr a su derecha. El camino """\  
	     """todava pueda ser transitable. Cuida tu espalda. """,
            'Answers': ['illhaveago'],
            'NewDlg': None
        },
	'sayhi1': {
	    'Text':
	     """Hola de nuevo. Tienes algn problema? Debes estar en el siguiente piso para localizar El Scriptorium. """,
	    'CallBack':'ResetTalkstate', 
            'Answers': ['oright1'],
            'NewDlg': None
        },
	'sayhi2': {
	    'Text':
	     """Hola de nuevo. Tienes algn problema? Yo no he visto ningn zombi ms desde la ltima vez que nosotros nos encontramos. """,
	    'CallBack':'ResetTalkstate', 
            'Answers': ['oright2'],
            'NewDlg': None
        },
	'sayhi3': {
	    'Text':
	     """Bien! Has vaciado todos los zombi de mi cocina. Toma toda la comida y pociones, pero """\    
	     """Yo evitara el estofado. """,
	    'CallBack':'ResetTalkstate', 
            'Answers': ['oright3'],
            'NewDlg': None
        },
	'sayhi4': {
	    'Text':
	     """Ah! Por fin yo puedo volver a mi cocina. Cmo te va, amigo? """,
	    'CallBack':'ResetTalkstate', 
            'Answers': ['oright4'],
            'NewDlg': None
        },
	'haveadrink': {
	    'Text':
	     """Yo he encontrado una pocin. Slo es una pocin pequea pero podras tenerla tambin. """,
	    'CallBack':'TomPot1', 
            'Answers': ['thanx1'],
            'NewDlg': None
        },
        'goodluckmate': {
	    'Text':
	     """Buena Suerte %PlayerName. Si fuera ochenta aos ms joven, vendra con usted. """, 
            'Answers': [],
            'NewDlg': None
        }
}           
           
           
TSDB.Ans ["Tom"]={
	'canihelp': {
	    'Text':
	     """De hecho! sta no es la recepcin que yo haba esperado. Puedo ser de alguna ayuda? """,
	    'NextDlg': 'tominst2',
	    'Enabled':1
	}, 
	'illdothat': {
	   'Text':
	    """Muy bien. Pero cmo encuentras ese lugar?  """,
	   'NextDlg': 'tominst3',
	   'Enabled':1    
	}, 
	'illhaveago': {
	   'Text':
	    """No temas. Volver. """,
	   'CallBack':'SetDemons', 
	   'NextDlg': None,
	   'Enabled':1
	}, 
	'oright1': {
	   'Text':
	    """ Ya veo.....Volver a subir por el ascensor. """,
	   'NextDlg': 'haveadrink',
	   'Enabled':1
	}, 
	'oright2': {
	   'Text':
	    """He hablado a Colin. l y algunos compaeros estn seguros en el Scriptorium. """,
	   'NextDlg': 'haveadrink',
	   'Enabled':1
	}, 
	'oright3': {
	   'Text':
	    """S! Parece como si estuviera demasiado cocido. Ni siquiera los zombi lo han tocado. """,
	   'NextDlg': None,
	   'Enabled':1
	}, 
	'oright4': {
	   'Text':
	    """Buenas noticias. Yo he restaurado las estatuas sagradas al santuario. Ianna sonre una vez ms en nosotros! """\  
	    """Voy a matar al Demonio en su cubil. """,
	   'NextDlg': 'goodluckmate',
	   'Enabled':1
	}, 
	'thanx1': {
	   'Text':
	    """ Gracias. Estoy muy sediento.....""",
	   'NextDlg': None,
	   'Enabled':1
        }
}    

###########################################################################################################################
################# Colin ###################################################################################################
###########################################################################################################################

TSDB.Dlg ["Colin"]={
	'whosthatknockin': {
	    'Text':
	     """Mrchate con tus malditos amigos! Nunca entrars en mi Biblioteca! """,
           'Answers': ['onlyme'],
           'NewDlg': None
        },
	'colinopendoor': {
	    'Text':
	     """Por los Dioses! Ayuda por fin. Yo haba abandonado casi toda esperanza. """,
	    'CallBack':'OpenLibraryDoor', 
            'Answers': [],
            'NewDlg': None
        },
	'plzcomein': {
	    'Text':
	     """Entra amigo. Yo soy Colin el Bibliotecario. Qu est pasando ah fuera? """,
	    'CallBack':'ColinCam', 
            'Answers': ['lotsofspooks'],
            'NewDlg': None
        },
	'plzcomein2': {
	    'Text':
	     """Entra amigo. Yo soy Colin el Bibliotecario. Qu est pasando ah fuera? """,
	    'CallBack':'ColinCam', 
            'Answers': ['lotsofspooks2'],
            'NewDlg': None
        },
	'digging': {
	    'Text':
	     """Ay! Es una historia triste. Nosotros estbamos excavando un nuevo stano de vino cuando irrumpimos en una gran caverna. """\  
	     """Un demonio asqueroso estaba viviendo all. Toda clase de criaturas malvadas vino e invadi el monasterio. """\   
	     """Ellos saquearon el Santuario de Ianna. Nosotros planeamos quitar las sagradas estatuas antes de que ellas """\  
	     """puedieran caer en malas manos, pero ellas deben restaurarse al Altar si queremos tener alguna """\  
	     """oportunidad de destruir la amenaza. """,
            'Answers': ['wherearethey'],
            'NewDlg': None
        },
	'digging2': {
	    'Text':
	      """Ay! Es una historia triste. Nosotros estbamos excavando un nuevo stano de vino cuando nosotros irrumpimos en una gran caverna. """\  
	     """Un demonio asqueroso estaba viviendo all. Toda clase de criaturas malvadas vino e invadi el monasterio. """\   
	     """Ellos saquearon el Santuario de Ianna. Nosotros planeamos quitar las sagradas estatuas antes de que ellas """\  
	     """puedieran caer en malas manos, pero ellas deben restaurarse al Altar si nosotros queremos tener alguna """\  
	     """oportunidad de destruir la amenaza. """,
            'Answers': ['wherearethey2'],
            'NewDlg': None
        },
	'nonot': {
	    'Text':
	     """Ah! tienes un corazn valiente, pero yo estoy seguro de que el Demonio no puede derrotarse por cualquier mano mortal. """\
	     """Haba un Caballero que estaba aqu cuando el problema empez. l fue a luchar contra la bestia. Descendi hace das """\
	     """ por los tneles y no se le ha visto de nuevo. Temo que l se haya encontrado un final terrible. La nica esperanza es  """\   
	     """restaurar el poder del Santuario. Entonces nosotros podremos llamar a Ianna para ayudarnos en esta hora oscura. """,
            'Answers': ['wherefound'],
            'NewDlg': None
        },
	'nonot2': {
	    'Text':
	     """Ay, yo no s. Yo pienso que vi a George el campanero con la estatua del Halcn. l todava debe de estar vivo. """\    
	     """He odo el gran ruido de la campana. Podras buscarlo cerca de las torres de la campana. """\     
	     """Quiz l vio qu destino tuvieron el resto de las estatuas. """,
            'Answers': ['leaveittome'],
            'NewDlg': None
        },
	'no2not2': {
	    'Text':
	     """Ah! tienes un corazn valiente, pero yo estoy seguro de que el Demonio no puede derrotarse por cualquier mano mortal. """\
	     """Haba un Caballero que estaba aqu cuando el problema empez. l fue a luchar contra la bestia. l descendi hace das por """\
	     """ los tneles y no se le ha visto de nuevo. Yo temo que l haya encontrado un final terrible. La nica esperanza es """\   
	     """restaurar el poder del Santuario. Entonces nosotros podremos llamar a Ianna para ayudarnos en esta hora oscura. """,
            'Answers': ['wherefound2'],
            'NewDlg': None
        },
	'potionsabout': {
	    'Text':
	     """Echa una mirada alrededor de la Biblioteca antes de irte. Puede haber cosas que puedan serte tiles. """\    
	     """Buena Suerte. 
	    'CallBack':'SetHallTrigger', 
            'Answers': [],
            'NewDlg': None
        },
	'goodbye': {
	    'Text':
	     """Nosotros no podemos agradecerte bastante %PlayerName. La sombra oscura se va y la paz de Karaz-Ankor se restaura. """\
	     """Estars ahora seguro aqu ahora que Vinculanus est muerto.  No te quedars? """,
	     'ExtraDlg': ['Crazydwarf',
	    	         """S! Qudate. Necesitar ayuda para excavar fuera todo ese queso."""],
            'Answers': ['keepgoing'],
            'NewDlg': None
        },
	'safetrip': {
	    'Text':
	     """Ay, tienes razn mi amigo. George ha abierto la Verja Oriental. Siga la huella """\  
	     """hasta que alcances la Atalaya vieja. Ms all hay un camino a las tierras bajas en el Este. """\  
	     """Adis. """,
            'Answers': ['returnagain'],
            'NewDlg': None
        }
}           
           
TSDB.Ans ["Colin"]={
	'onlyme': {
	    'Text':
	     """No temas porque yo no soy ninguno muerto anadante. Mi nombre es %PlayerName. Por favor abre la puerta. """,
	    'NextDlg': 'colinopendoor',
	    'Enabled':1
	}, 
	'lotsofspooks': {
	   'Text':
	    """El lugar entero est infestado por las criaturas no-muertas. Todava algunos de sus hermanos han sobrevivido y """\  
	    """est escondiendo donde ellos pueden. Pero qu pas para provocar este evento infortunado? """,
	   'NextDlg': 'digging',
	   'Enabled':1    
	}, 
	'lotsofspooks2': {
	   'Text':
	    """El lugar entero se infesta por las criaturas del un-muerto. Todava algunos de tus hermanos han sobrevivido y """\  
	    """est escondidos donde pueden. Pero qu pas para provocar este evento infortunado? """,
	   'NextDlg': 'digging2',
	   'Enabled':1    
	}, 
	'wherefound': {
	   'Text':
	    """Dnde podran encontrarse estos artefactos sagrados? """,
	   'NextDlg': 'nonot2',
	   'Enabled':1
	}, 
	'wherefound2': {
	   'Text':
	    """Yo me he encontrado a este Caballero. l est daado pero vivo. l est seguro por el momento. """\
	    """Dnde podran encontrarse estos artefactos sagrados? """,
	   'NextDlg': 'nonot2',
	   'Enabled':1
	}, 
	'wherearethey': {
	   'Text':
	    """Yo har lo que pueda. Yo he tenido experiencias tratando con tales criaturas. Yo estoy deseoso de encarar """\    
	    """al monstruo en su guarida y llevarlo de vuelta al hoyo asqueroso de donde sali. """,
	   'NextDlg': 'nonot',
	   'Enabled':1
	}, 
	'wherearethey2': {
	   'Text':
	    """Yo har lo que pueda. Yo he tenido experiencias tratando con tales criaturas. Yo estoy deseoso de encarar """\    
	    """al monstruo en su guarida y llevarlo de vuelta al hoyo asqueroso de donde sali. """,
	   'NextDlg': 'no2not2',
	   'Enabled':1
	}, 
	'leaveittome': {
	   'Text':
	    """Yo echar una mirada alrededor. Cierra la puerta detrs de m. """,
	   'NextDlg': 'potionsabout',
	   'Enabled':1   
	}, 
	'keepgoing': {
	   'Text':
	    """sa es una oferta ms atractiva, pero yo debo guardar de moverme. Temo que Vinculanus no est muerto. l us el poder """\
	    """de su amo para evitar ese destino. An ahora, su espritu oscuro vuela de vuelta """\    
	    """a La Torre oscura. Es slo cuestin de tiempo antes de que l vuelva. """,
	   'NextDlg': 'safetrip',
	   'Enabled':1   
	}, 
	'returnagain': {
	   'Text':
	    """Yo volver algn da. Adis a todos.  """,
	   'NextDlg': None,
	   'Enabled':1                      
        }
}    

###########################################################################################################################
################## Roifur #################################################################################################
###########################################################################################################################

TSDB.Dlg ["Roifur"]={
	'saveelephant': {
	    'Text':
	     """Arggh! Mi fuerza me ha fallado... ..me temo que mis heridas son mortales. Salva el Elefante """\      
	     """Sagrado te pido. Ten cuidado all, hay algunos...... """,
           'Answers': ['somewhat'],
           'NewDlg': None
        }
}           
           
           
TSDB.Ans ["Roifur"]={
	'somewhat': {
	    'Text':
	     """No te preocupes viejo. Yo conseguir ayuda.... """,
	    'NextDlg': None,
	    'Enabled':1
        }
}    

###########################################################################################################################
################## Acolyte #################################################################################################
###########################################################################################################################

######################
TSDB.Dlg ["Lucidya"]={
	'hail': {
	    'Text':
	     """Hola %PlayerName! no tengas miedo. Yo soy Lucidya, Aclita de la Diosa Ianna. Mi Divina Seora """\    
	     """es bien conocida por sus hazaas y me ha enviado que d ayuda en su lucha contra la """\    
	     """Oscuridad que ha perturbado la tranquilidad de Karaz-Ankor. """,
           'Answers': ['demon'],
           'NewDlg': None
        },
        'hail2': {
	    'Text':
	     """Dices la verdad %PlayerName. Pero yo te ayudar tanto como me es posible. """,
           'Answers': ['cheers'],
           'NewDlg': None
        },
        'weapon': {
	    'Text':
	     """Toma esta %wep. tiene un gran poder. sala bien. """,
	   'CallBack':'InvokeSword', 
           'Answers': ['gonow'],
           'NewDlg': None
        },
        'crown': {
	    'Text':
	     """Tienes un gran valor %PlayerName, pero la %wep no te salvar de la respiracin abrasadora """\      
	     """de las criaturas en el Submundo. Aqu hay un trinket pequeo que te dar proteccin. """\      
	     """salo con el cuidado. """,
	   'CallBack':'InvokeCrown', 
           'Answers': ['gonow2'],
           'NewDlg': None
        },
        'depart': {
	    'Text':
	     """Te deseo buena fortuna %PlayerName. debo partir ahora. Adis....... """,
	   'CallBack':'AcolyteDeparts', 
           'Answers': [],
           'NewDlg': None
        }
}           
           
           ##################
TSDB.Ans ["Lucidya"]={
	'demon': {
	    'Text':
	     """Me honras profundamente! Pero me han dicho que el mal emana de un demonio que habita en una """\    
	     """ gran cueva, profunda bajo el Monasterio. Est bien protegida por una horda de aprendices menores. Ningn mortal """\    
	     """pueda prevalecer contra su poder...... """,
	    'NextDlg': 'hail2',
	    'Enabled':1
	},
	'cheers': {
	    'Text':
	     """Muchas gracias, Mi Seora. Yo necesitar toda la ayude que pueda conseguir. """,
	    'NextDlg': 'weapon',
	    'Enabled':1
	},
	'gonow': {
	    'Text':
	     """Yo confo que en demostrarme digno de tal arma excelente. Yo descender en la oscuridad y matar a la Bestia """,
	    'NextDlg': 'crown',
	    'Enabled':1
	},
	'gonow2': {
	    'Text':
	     """Gracias de nuevo. """,
	    'NextDlg': 'depart',
	    'Enabled':1
        }
}    

###########################################################################################################################
############################ George the Bellringer ########################################################################
###########################################################################################################################


TSDB.Dlg ["George"]={
	'thoughtbaddie': {
	    'Text':
	     """Perdname amigo. Yo te tom por una de esas criaturas asquerosas. Por favor, te ruego """\    
	     """que tomes el halcn sagrado y lo guardes en lugar seguro. """,
           'Answers': ['geowilldo'],
           'NewDlg': None
        },
	'overyonder': {
	    'Text':
	     """No estoy totalemente seguro. Creo que vi al viejo Roifur escapar a travs del Observatorio. Haba """\    
	     """mucha confusin, pero creo que l tena la estatua del elefante. Aqu est la llave de la verja...... """,
	    'CallBack':'GeorgeLookAndPoint', 
            'Answers': ['iwilllookupthere'],
            'NewDlg': None
        },
	'imhiding': {
	    'Text':
	     """Hola de nuevo. Yo no he visto ms fantasmas. """,
            'Answers': ['lielow'],
            'NewDlg': None
        },
	'justamo': {
	    'Text':
	     """Que tengas un buen viaje %PlayerName. Busca a Asgeirr en la Atalaya. l vive all """\   
	     """la mayora del tiempo con slo Wyverns como compaa. Por favor dle recuerdos. """,
	    'CallBack':'HectorApproach', 
            'Answers': ['surewill'],
            'NewDlg': None
        },
	'times': {
	    'Text':
	     """Espero que volvers a nosotros un da... ...Ah! Aqu est Hctor.  """,
	     'ExtraDlg': ['Hector',
	    	         """Yo he paseado por el camino hasta la Tumba de Skorageirr. Todo est desierto."""],
            'Answers': ['imoff'],
            'NewDlg': None
        }
}           
           
           
TSDB.Ans ["George"]={
	'geowilldo': {
	    'Text':
	     """Yo lo guardar con mi vida. Pero entiendo que hay tres estatuas sagradas ms. Dime """\  
	     """dnde podra encontrarlas? """,
	    'NextDlg': 'overyonder',
	    'Enabled':1
	}, 
	'iwilllookupthere': {
	   'Text':
	    """Yo echar una mirada por all. Habas encontrado otro buen escondite en caso de ms enemigos """\  
	    """estn rondando. """,
	   'NextDlg': None,
	   'Enabled':1    
	}, 
	'lielow': {
	   'Text':
	    """Yo he matado unos pocos, pero permanecen escondidos. Puede haber tambin algunos perdidos. """,
	   'NextDlg': None,
	   'Enabled':1
	}, 
	'surewill': {
	   'Text':
	    """Claro. Ahora yo debo de irme antes de que ms secuaes de Dal Gurak puede encontrar mi rastro. """,
	   'NextDlg': 'times',
	   'Enabled':1
	}, 
	'imoff': {
	   'Text':
	    """Gracias Hctor. Ahora yo partir......  """,
	   'NextDlg': None,
	   'Enabled':1
        }
}    

########################################################################################################################
########################################################## Crazydwarf ##################################################
########################################################################################################################

TSDB.Dlg ["CrazyDwarf"]={
	'hellomate1': {
	    'Text':
	     """Por qu, l es mi viejo amigo %PlayerName. Qu estas haciendo abajo en este agujero? """,
           'Answers': ['askyou1'],
           'NewDlg': None
        },
	'hellomateihavealreadyseenyou': {
	    'Text':
	     """Ah, %PlayerName. Cmo lo consiguiste? Esta pared era mucho ms dura de lo que yo """\    
	     """pensaba. He estado martilleandola durante dcadas. Es ms, el tnel se derrumb """\     
	     """detrs de m y no poda volver por el camino por el que entr. """,
            'Answers': ['thrucave'],
            'NewDlg': None
        },
	'hellomate3': {
	    'Text':
	     """Arrrgh! Me has dado miedo! Por qu, l es mi viejo amigo %PlayerName. Qu ests haciendo aqu? """,
            'Answers': ['askyou2'],
            'NewDlg': None
        },
	'getout1': {
	    'Text':
	     """Yo he estado encerrado con llave en una clda, amigo. Pero no se ha construido prisin que puede encerrar a Crazydwarf!  """,
            'Answers': ['wheretherock'],
            'NewDlg': None
        },
	'getout2': {
	    'Text':
	     """Yo vine a este lugar por vacaciones, pero poco despus de que yo lleguara todo el infierno estall y """\      
	     """y mis compaeros y yo nos acorral un Golem gigante y fuimos tirados a una celda. Pero todava tiene que ser """\     
	     """construida la prisin que pueda encerrar a Crazydwarf. Pens que escavara un tunel hacia fuera. """,
            'Answers': ['wheretherock2'],
            'NewDlg': None
        },
	'anotherhole': {
	    'Text':
	     """Ah! Debes saber que nosotros los Enanos somos expertos en minas. La respuesta es simple mi """\     
	     """ amigo. yo excav otro tnel y los guard a todos en l """,
            'Answers': ['neverthought'],
            'NewDlg': None
        },
	'anotherhole2': {
	    'Text':
	     """Ah! Debes saber que nosotros los Enanos somos expertos en minas. La respuesta es simple mi """\   
	     """amigo. yo excav otro tnel y los guard a todos en l. """,
            'Answers': ['neverthought2'],
            'NewDlg': None
        },
	'ogoody': {
	    'Text':
	     """Una mina de queso dices? Los dioses sean alabados! Yo he investigado toda mi vida para tal maravilla. """\     
	     """Pero nosotros parecemos estar en alguna clase de stano subterrneo. Mira si hay un camino ascendente a la superficie. Yo investigar el queso. """, 
            'Answers': ['ok1'],
            'NewDlg': None
        },
	'perhaps': {
	    'Text':
	     """S, quizs sa sea una buena idea. Pero yo lo intentar un poco ms para atravesar esta pared. """\     
	     """Quin sabe qu riquezas quedan ms all """,
            'Answers': [],
            'NewDlg': None
        },
	'imhiding': {
	    'Text':
	     """Hola de nuevo. Yo no he visto ms fantasmas. """,
            'Answers': ['lielow'],
            'NewDlg': None
        },
	'stophere': {
	    'Text':
	     """No voy a permitir que una pared me derrote. Yo romper a travs de si yo sigo cortando lejos mucho tiempo bastante. """,
            'Answers': ['catchtalater'],
            'NewDlg': None
        }
}           
           
           
TSDB.Ans ["CrazyDwarf"]={
	'askyou1': {
	    'Text':
	     """Por los Dioses! Es Crazydwarf ese que veo? Qu ests intentando hacer en la tierra? """,
	    'NextDlg': 'getout1',
	    'Enabled':1
	},
	'askyou2': {
	    'Text':
	     """Por los Dioses! Eres t, Crazydwarf? Qu ests intentando hacer en la tierra? """,
	    'NextDlg': 'getout2',
	    'Enabled':1
	}, 
	'wheretherock': {
	   'Text':
	    """Un poco ms all y habras socavado la guarida de un enorme """\    
	    """demonio. Pero no te preocuques, yo he matado a la bestia. Sin embargo, dnde has puesto toda la piedra que """\   
	    """has excavado? """,
	   'NextDlg': 'anotherhole2',
	   'Enabled':1    
	}, 
	'wheretherock2': {
	   'Text':
	    """S, bien has hecho progresos notables. Parece que has golpeado una pared. Yo me pregunto """\     
	    """que hay en el lado ms alejado. Pero una cosa me confunde. Dnde est toda la piedra """\    
	    """que has excavado? """,
	   'NextDlg': 'anotherhole',
	   'Enabled':1    
	}, 
	'thrucave': {
	   'Text':
	    """Bien, mientras has estado escavando lejos por ah abajo, yo he exterminado todos los asquerosos fantasmas  """\  
	    """que estaban vagando por ah y matado a un enorme Demonio. Ha sido una suerte que la pared fuera """\  
	    """tan fuerte o t habras ido directo a la guarida. Pero su trabajo no ha sido en vano """\  
	    """mi amigo! He descubierto lo que parece ser una mina de queso abandonada. """,
	   'NextDlg': 'ogoody',
	   'Enabled':1    
	}, 
	'neverthought': {
	   'Text':
	    """Ahhhh........ est muy claro. Yo te dejar para esto. Temo que no conseguirs pasar todo eso """\  
	    """muy pronto. """,
	   'NextDlg': 'stophere',
	   'Enabled':1
	}, 
	'neverthought2': {
	   'Text':
	    """Hmmm...... .ya veo. Yo nunca pens en eso. Sin embargo, pienso que averiguar una manera ms fcil. """\   
	    """Yo he descubierto una mina de queso abandonada. """,
	   'NextDlg': 'ogoody',
	   'Enabled':1
	}, 
	'ok1': {
	   'Text':
	    """Muy bien. Si hay un camino de salida nos encontraremos fuera. """,
	   'NextDlg': None,
	   'Enabled':1
	}, 
	'catchtalater': {
	   'Text':
	    """Est probablemente ms seguro aqu abajo. Yo regresar a echar una mirada alrededor. Te ver despus, """\  
	    """o no..... cuando se pueda. """,
	   'NextDlg': None,
	   'Enabled':1
        }
}    

########################################################################################################################
######################### Vinculanus ###################################################################################
########################################################################################################################

TSDB.Dlg ["Vinculanus"]={
	'gotcha': {
	    'Text':
	     """As pues! Pensaste que habas escapado. Piensa otra vez! Has visto tu ltimo amanecer. Antes de """\  
	     """que este da acabe tu cabeza estar en uno de los platos de mis Amos en la mesa de su cena. """,
           'Answers': ['getstuffed'],
           'NewDlg': None
        },
	'payfor': {
	    'Text':
	     """No me duelen tus dbiles insultos %Type. Las nieves estarn manchadas pronto con tu sangre. 
            'Answers': ['doyourworst'],
            'NewDlg': None
        }
}           
           
           
TSDB.Ans ["Vinculanus"]={
	'getstuffed': {
	    'Text':
	     """Si slo pudieras luchar tal como hablas Vinculanus. Pero ests de pie ante m desarmado. """\   
	     """Qu nuevos trucos ha estado enseando el Hechicero a su querido perro? """,
	    'NextDlg': 'payfor',
	    'Enabled':1
	},
	'doyourworst': {
	    'Text':
	     """Ha! T y todos de tu clase no son nada ms que escoria cobarde. Continua! Haz mi da....... """,
           'CallBack':'StartBossFight', 
	   'NextDlg': None,
	   'Enabled':1         
        }
}    

########################################################################################################################
################################ Robin the Scorched Knight #############################################################
########################################################################################################################

TSDB.Dlg ["Robin"]={
	'donttryit1': {
	    'Text':
	     """Quin es? Amigo o Enemigo? """,
	   'CallBack':'ResetTalkstate', 
           'Answers': ['onlyme'],
           'NewDlg': None
        },
	'passage': {
	    'Text':
	     """Es una historia triste amigo...... Ms all de la verja hay un gran peligro. """\
	     """Toda clase de seres asquerosos guardan en el camino. No pienses en aventurarte ah abajo. """\
	     """Slo una muerte ardiente te espera all... """,
            'Answers': ['lookforcolin'],
            'NewDlg': None
        },
	'passage2': {
	    'Text':
	     """Ah!.... el sabio y viejo Colin. Si hubiera escuchado su consejo. Si ests pensando en aventurarte """\     
	     """ms all de la verja, pinsalo de nuevo! Slo hay una muerte segura ms all. """,
            'Answers': ['morehelp'],
            'NewDlg': None
        },
	'passage3': {
	    'Text':
	      """Ah!.... el sabio y viejo Colin. Si hubiera escuchado su consejo. Si ests pensando en aventurarte """\     
	     """ms all de la verja, pinsalo de nuevo! Slo hay una muerte segura ms all. """,
            'Answers': ['morehelp3'],
            'NewDlg': None
        },
	'nothalf': {
	    'Text':
	     """Ha!... S, cierto! viejo Colin. Si yo le hubiera escuchado! l me advirti de no bajar all. """\   
	     """Yo tuve la suerte de escapar con vida, aunque me chamusqu un poco..... Vuelve al ascensor """\  
	     """y a lo largo del corredor. La puerta del Scriptorium queda directamente delante. Seguro que lo encuentras all. """\   
	     """Es decir, si l no ha cado bajo alguna abominacin reptante. """,
            'Answers': ['righto'],
            'NewDlg': None
        },
	'okhere': {
	    'Text':
	     """Gracias por tu preocupacin. Yo estar bien una vez que me haya refrescado fuera. Ve ahora y busca ayuda.....  """,
	    'CallBack':'RobinTalk1', 
	    'HideDelay':6, 
            'Answers': [],
            'NewDlg': None
        },
        'donttryit2': {
	    'Text':
	     """Quin es? Amigo o Enemigo? """,
	   'CallBack':'ResetTalkstate', 
           'Answers': ['onlyme2'],
           'NewDlg': None
        },
        'donttryit3': {
	    'Text':
	     """Quin es? Amigo o Enemigo? """,
	   'CallBack':'ResetTalkstate', 
           'Answers': ['onlyme3'],
           'NewDlg': None
        },
        'donttryit4': {
	    'Text':
	     """Ah! %PlayerName. me siento un poco mejor ahora. Pero ni unos caballos salvajes podran arrastrarme hasta all..... """,
	   'CallBack':'ResetTalkstate', 
           'Answers': ['morehelp3'],
           'NewDlg': None
        },
	'goodforyou': {
	    'Text':
	     """Los Dioses puedan protegerte en su busqueda. Ve ahora. Yo estar bien una vez me haya refrescado fuera...... """,
	    'CallBack':'RobinTalk2', 
	     'HideDelay':6, 
            'Answers': [],
            'NewDlg': None
        },
	'goodforyou3': {
	    'Text':
	     """Alabados sean los Dioses! Buena suerte amigo. Ve adelante y lucha. Yo estar bien una vez me haya refrescado fuera...... """,
            'Answers': ['imoff'],
            'NewDlg': None
        }
}           
           
           
TSDB.Ans ["Robin"]={
	'onlyme': {
	    'Text':
	     """No temas. Mi nombre es %PlayerName. Pareces haber sufrido heridas dolorosas. Qu est pasando """\  
	     """en este lugar? """,
	    'NextDlg': 'passage',
	    'Enabled':1
	},
	'onlyme2': {
	    'Text':
	     """No temas. Mi nombre es %PlayerName. Pareces haber sufrido heridas dolorosas. Debes de ser el """\  
	     """valiente Caballero del que Colin habl. """, 
	    'NextDlg': 'passage2',
	    'Enabled':1
	},
	'onlyme3': {
	    'Text':
	     """No temas. Mi nombre es %PlayerName. Pareces haber sufrido heridas dolorosas. Debes de ser el """\  
	     """valiente Caballero del que Colin habl. """, 
	    'NextDlg': 'passage3',
	    'Enabled':1
	}, 
	'lookforcolin': {
	   'Text':
	    """Escucho tus palabras seor Caballero. Estoy buscando a un Enano con el nombre de Colin. Me han dicho """\  
	    """que puede tener sabios consejos para impartir. """,
	   'NextDlg': 'nothalf',
	   'Enabled':1    
	}, 
	'righto': {
	   'Text':
	    """Ir recto por all, pero  estars bien? """,
	   'NextDlg': 'okhere',
	   'Enabled':1
	}, 
	'morehelp': {
	   'Text':
	    """Escucho tus palabras seor Caballero. Estoy intentando restaurar el poder del Santuario para que pueda """\  
	    """poner fin al mal que ha cado en este pacfico lugar. """,
	   'NextDlg': 'goodforyou',
	   'Enabled':1   
	}, 
	'morehelp3': {
	   'Text':
	    """Esto no te concierne seor Caballero. Yo he limpiado el monasterio de muertos vivientes y he restaurado """\  
	    """el poder del Santuario. Vengo preparado a desterrar al Demonio y traer la armona a este """\  
	    """lugar pacfico. """,
	   'NextDlg': 'goodforyou3',
	   'Enabled':1       
	}, 
	'imoff': {
	   'Text':
	    """As sea. Cierra la verja detrs de m e intenta hacer tu camino vuelta atrs. Todos estn seguros por el momento. """,
	   'CallBack':'LetGo', 
	   'NextDlg': None,
	   'Enabled':1                 
        }
}    

###########################################################################################################################
################## Fognar #################################################################################################
###########################################################################################################################

TSDB.Dlg ["Fognar"]={
	'hellothere': {
	    'Text':
	     """Arrgh! No me pegues! Soy simplemente un viejo y pobre Enano. Mis ojos son dbiles y mis piernas son an ms dbiles. """,
	   'CallBack':'StepBack', 
           'Answers': ['alarmed'],
           'NewDlg': None
        },
	'goingon': {
	    'Text':
	     """Eso es ciertamente verdad. No he visto ninguno de mis amigos durante algunos das y hay dos """\  
	     """enormes caballeros que patrullan por el patio. Deseo saber qu est pasando exactamente. No me atrevo """\  
	     """a probar de entrar en el Monasterio para averiguarlo. """
            'Answers': ['illhavalook'],
            'NewDlg': None
        },
	'carefulnow': {
	    'Text':
	     """No tengas tanta prisa mi amigo! Estoy seguro de que eres un guerrero valiente y hbil, pero esos caballeros """\   
	     """tiene la armadura muy dura. Toma estos dos Cohetes. Agujerearn la armadura ms gruesa. Toma tambin la Gema Prpura. """\
	     """sela para darte proteccin extra, pero no tires ningn Cohete mientras """\    
	     """te escudas as. """,
            'Answers': ['ithanku'],
            'NewDlg': None
        },
	'theyrok': {
	    'Text':
	     """No te preocupe por los Wyverns. Ellos han sido alguna vez benvolos con nosotros. Nosotros protegemos sus tierras de crianza """\
	     """y ellos mantienen los pasos montaeses libres de Orcos y Gnomos. """,  
	    'CallBack':'ResetTalkstate', 
            'Answers': ['soundsgood'],
            'NewDlg': None
        }
}           
           
           
TSDB.Ans ["Fognar"]={
	'alarmed': {
	    'Text':
	     """No te alarmes maestro Enano. No te quiero ningn dao. Yo busco slamente refugio, pero estoy empezando """\    
	     """a sospechar que algo no fnciona bien. """,
	    'NextDlg': 'goingon',
	    'Enabled':1
	},
	'illhavalook': {
	    'Text':
	     """Echar una mirada. Si los caballeros me dan algn problema, llegar a un trato con ellos. """,
	   'NextDlg': 'carefulnow',
	   'Enabled':1     
	},
	'ithanku': {
	    'Text':
	     """Te agradezco ese consejo, pero qu pasa con las grandes bestias voladoras que he visto en el rea? """,
	   'NextDlg': 'theyrok',
	   'Enabled':1             
	},
	'soundsgood': {
	    'Text':
	     """Ya veo. Bien ir ahora y ver si puedo entrar en el Monasterio. Si oyes sonidos de batalla, """\    
	     """cierra y obstruye la puerta. """,
	   'NextDlg': None,
	   'Enabled':1         
        }
}    

###########################################################################################################################
############################################# Asgeirr ##################################################################### 
###########################################################################################################################

TSDB.Dlg ["Asgeirr"]={
	'welcome': {
	    'Text':
	     """Hola y s bienvenido %PlayerName. te he estado esperando muchos das que llegaras a mi torre. """,
	   'CallBack':'LookAtMeWhenImTalkingToYou', 
           'Answers': ['howdyano'],
           'NewDlg': None
        },
	'word': {
	    'Text':
	     """Perdname. Soy Asgeirr, el Guardin de los Wyverns. Nosotros tenemos un amigo comn, Glofror. l me ha enviado """\   
	     """un mensaje de que estabas de viaje por estas montaas y saba que pasaras en el futuro por aqu. Yo me doy cuenta que estos """\  
	     """chacales tambin estaban buscndote. """, 
            'Answers': ['isee'],
            'NewDlg': None
        },
	'message': {
	    'Text':
	     """Me alegro de orlo. Pero escucha cuidadosamente %PlayerName. parece que el pueblo de Carras Varr est bajo la amenaza """\  
	     """de una incursin de una partida de Orcos. Ellos buscan esclavizar a la poblacin y tomar las forjas. Algunos de los """\  
	     """mejores armeros viven y trabajan all. Por nuestro bien, no podemos permitir que pase. """,  
	    'CallBack':'InitRoofTrigger',
            'Answers': ['howget'],
            'NewDlg': None
        },
	'meetup': {
	    'Text':
	     """El pueblo est en las profundidaes del pantano cerca de la boca del ro Gyoll. El suelo del territorio """\     
	     """es traicionero. Glofror y el grupo de compaeros del Enano permanecen en la casa de Voignus, en las afueras, """\     
	     """del pantano. l te reclama y ha enviado un mapa para que puedas encontrar el camino hasta all. """,
            'Answers': ['map'],
            'NewDlg': None
        },
	'uponroof': {
	    'Text':
	     """Lo tengo en un lugar seguro, para que no caiga en malas manos. Sube a la cima de la torre y si quieres """\   
	     """te lo entreguar. """, 
            'Answers': ['whatever'],
            'NewDlg': None
        }
}           
           
           
TSDB.Ans ["Asgeirr"]={
	'howdyano': {
	    'Text':
	     """Tiene ventaja sobre m Seor. Cmo sabes mi nombre? """,
	    'NextDlg': 'word',
	    'Enabled':1
	},
	'isee': {
	    'Text':
	     """Eso es verdad, pero ellos slo estaban de paso. Su lder ha huido. Dudo de que veas ms. """,
	   'NextDlg': 'message',
	   'Enabled':1    
	},
	'howget': {
	    'Text':
	     """No de hecho, pero cmo puedo ayudarte? """,
	   'NextDlg': 'meetup',
	   'Enabled':1    
	},
	'map': {
	    'Text':
	     """Ya veo. Bien, si Glofror necesita mi ayuda debo ir inmediatamente a su lado. Dnde est el mapa? """,
	   'NextDlg': 'uponroof',
	   'Enabled':1    
	},
	'whatever': {
	    'Text':
	     """Muy bien Asgeirr. Lo que t digas........ """,
	   'NextDlg': None,
	   'Enabled':1    
        }
}    

############################################################################################################################
############################################ Journal #######################################################################
############################################################################################################################

TSDB.JrlTxt = {
	'J1':
	    """Despus de muchos das y noches de viaje en los caminos abandonados de las montaas, creo que"""\  
	    """la Guardia Negra ha perdido mi rastro. El Monasterio de Karaz-Ankor no puede estar lejos.  """,
	'J2':
	    """Parece que Henry el Posadero ha tenido mucho tiempo problemas con los Orcos que infestan esta zona. """\
	    """Esta noche ellos consiguieron ms de lo que habn pactado y ahora muchos de ellos estn muertos. """,
	'J2a':
	    """Henry est vido de matar cualquier Orco que todava pueda estar escondido. En el campo, en la parte de atrs """\
	    """de la casa hay un fuego grande que los Orcos han hecho usando el mobiliario de Henry. """\
	    """Yo pienso que el campamento est cerca en las piedras. Yo tendr echar un vistazo con cuidado alrededor mientras Henry encuentra su maza. """,
	'J3':
	    """El Jefe Orco est muerto. Ahora el camino est libre para llegar al campamento y quiz recuperar algunos de los suministros """\  
	    """que ellos han robado de Henry. """,
	'J4':
	    """Aunque la hospitalidad de Henry es muy bien recibida, debo continuar siguiendo. l me ha dado un Amuleto Mgico """\     
	    """imbuido con un poco de gran poder, pero lo que realmente hace es desconocido por m. l me advierte de usarlo """\    
	    """slo en las circunstancias ms desesperadas. ste podra ser el legendario Amuleto del Destructor? En ese caso, es """\      
	    """conocido por exterminar toda la vida dentro de una distancia corta. Yo debo tener mucho cuidado. """,
	'J5':
	    """Por el inmenso puente azotado por los vientos que mide por palmos la garganta yo me he encontrado a tres Enanos. Yo parezco Karaz-Ankor """\    
	    """no pueda ser el asilo seguro para que yo haba esperado. Pero no hay ninguna ida. Hay simplemente la cuestin de algunos """\    
	    """monstruos cabelludos que han bloqueado el camino. Harold me ha contado un esfuerzo abortado por aclarar """\    
	    """el camino con el explosives. Yo pienso que yo intentar completar esta estrategia en lugar de la lucha las bestias """, 
	'J6':
	    """Yo he aclarado el paso estrecho y ahora el Monasterio est muy cercano. Yo debo estar en alarma por si hay otros peligros. """,
	'J7':
	    """La gran puerta del Monasterio est cerrada y las nicas seales de vida son Orcos que rondan por fuera. """\   
	    """Debo buscar otra manera. """,
	'J8':
	    """He descubierto un tnel que muestra seales de ocupacin. Sospecho para ser un escondite para una tribu """\    
	    """de Orcos. Si puedo encontrar otra salida, puede llevar por otro camino al Monasterio. Tambin all pueda """\    
	    """sea artculos tiles ocultados dentro de. """,
	'J9':
	    """Yo he descubierto una ocultacin Enana vieja cerca de la pared exterior del Monasterio. l me ha dado valioso """\   
	    """la informacin y los artculos tiles. Una seccin de la pared se ha derrumbado ms all adelante. Yo har mi manera en, """\     
	    """pareciendo fuera para los guardias que estn patrullando el patio. """,
	'J10':
	    """Yo he encontrado mi manera en el Monasterio a travs de los calabozos y he librado a algunos prisioneros. Yo seguir, """\  
	    """pero yo debo ser vigilante. All se liga para ser el peligro.""",
	'J11':
	    """Yo he matado tres ms de los caballeros grandes. Ellos se conocen para ser sirvientes de las Fuerzas Malas de este Mundo. """\
	    """lo que ellos estn haciendo aqu que yo no s. La puerta a la Capilla est ahora abierta. Yo temo una trampa. """,
	'J12':
	    """La situacin est empeorando. Parece un poco de poder oscuro ha abierto las tumbas y ha levantado los cadveres de guerreros """\
	    """del largo-muerto para hacerlo est ofreciendo. Yo tengo que ver todava ms de los Enanos residente. """,
	'J13':
	    """Yo he encontrado a un Enano amistoso, a saber Tom el cocinero de cabeza. Hay Zombi que se arrastran sobre en las manadas. """\  
	    """Parece yo debo localizar un enano nombrado Colin y busca su consejo. La mayora de las verjas ha sido """\  
	    """rodeado un esfuerzo por contener los Zombi. Tom me informa de una posible ruta """\  
	    """a travs del cuarto del Acuario. """,
	'J14':
	    """Colin me ha dicho exactamente lo que ha transpirado durante los ltimos das. Yo parezco que la nica esperanza es reunir """\ 
	    """cuatro sagradas estatuas en la Urna de Ianna. Estas estatuas estaban apresuradamente alejadas cuando el problema empez """\  
	    """y podra estar en cualquier parte en este inmenso edificio. Yo investigar completamente. Colin tiene una idea que George el """\  
	    """Campanero est vivo y tiene una de las estatuas. """,
	'J15':
	    """El poder de la Santuario se restaura e Ianna ha llovido su bendicin en m. Yo me encajo ahora a """\   
	    """baje en las cavernas bajo el Monasterio y luche con la Gran Bestia. """,
	'J16':
	    """La Bestia y todos sus favorito estn muertos. Pero yo el tnel por que yo entr se bloquea. Yo debo """\    
	    """investigue para otra manera fuera. """,
	'J17':
	    """He alcanzado una vez ms la superficie, pero me doy cuenta de una mala atmsfera. Una feroz tormenta est preparndose.... """,
	'J18':
	    """Despus de una batalla dura, he escapado una vez ms de los rompecabezas de Vinculnaus. Su espritu oscuro ha tomado la forma """\     
	    """de un pjaro carroero y ha hudo. Aunque yo haba planeado quedarme aqu, debo seguir. La Guardia Negra volver """\    
	    """, seguro. Les dar las gracias a mis nuevos amigos y volver al camino. """, 
        }


###########################################################################################################################
############ Load Screen


#      High among the icy peaks of the Western Range stands the Monastery of Karaz-Ankor.
#  The mighty fortress is steeped in Legends of the Dwarf-Lord Skorageirr: of how, after
#  the siege of Tumunzahar, the Goddess Ianna appeared to him on the field of battle.
#  In recognition of his great courage, four sacred statues were given into his charge
#  and he and his company journeyed into the mountains and built a Shrine to hold the
#  statues and raised the great walls around it so that they may ever be protected.
#       The ancient heroes have long since passed beyond. Only their tombs remain. 
#  A brotherhood of Dwarves have become guardians of the Shrine and the power of the
#  four statues still holds a benign influence throughout the region. The Monastery has 
#  become a place of sanctuary for all who seek refuge from oppression........




#       En lo alto, entre las crestas heladas del Rango Occidental, se asienta el Monasterio de Karaz-Ankor.
#  La poderosa fortaleza se empapa de las Leyendas del Seor Enano Skorageirr: de cmo, despus del   
#  asedio de Tumunzahar, la Diosa que Ianna se le apareci en el campo de batalla. En reconocimiento
#  a su gran valor, le dejaron a su cargo cuatro estatuas sagradas y l y su grupo viajaron por las 
#  montaas y construyeron una santuario para guardar las estatuas y levant grandes paredes 
#  alrededor para que siempre estuvieran protegidas. Ha pasado mucho tiempo desde los Antiguos Hroes, 
#  desde que pas todo. Slo sus tumbas permanecen.   Una hermandad de Enanos se ha convertido en
#  guardian del santuario y el poder de las cuatro estatuas todava mantiene una influencia benigna en toda 
#  la regin. El Monasterio se ha vuelto un santuario para todos aquellos que buscan refugio de la 
#  opresin........



















