import Sounds
import Bladex
import math

Bladex.AddParticleGType("AguaC","WaterParticle",B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	r=120
	g=120
	b=120
	a=60
	size=120.0
	Bladex.SetParticleGVal("AguaC",i,r,g,b,a,size)


Bladex.AddParticleGType("AguaCD","WaterParticle",B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	r=50
	g=50
	b=60
	a=60
	size=120.0
	Bladex.SetParticleGVal("AguaCD",i,r,g,b,a,size)
	

###############

Bladex.AddParticleGType("AguaCi","WaterParticle",B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	r=75
	g=85
	b=75
	a=90
	size=450.0
	Bladex.SetParticleGVal("AguaCi",i,r,g,b,a,size)
	

Bladex.AddParticleGType("Espumai","SmokeParticle",B_PARTICLE_GTYPE_BLEND,10)

for i in range(10):
	aux=(10.0-i)/10.0
	r=100
	g=105
	b=105
	#a=255*math.sqrt(1.0-aux)
	a=255
	size=1400.0*math.sqrt(1.0-aux)
	Bladex.SetParticleGVal("Espumai",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("AguaCw","WaterParticle",B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	r=100
	g=100
	b=120
	a=90
	size=150.0
	Bladex.SetParticleGVal("AguaCw",i,r,g,b,a,size)
	

Bladex.AddParticleGType("Espumaw","SmokeParticle",B_PARTICLE_GTYPE_BLEND,10)

for i in range(10):
	aux=(10.0-i)/10.0
	r=100
	g=105
	b=125
	a=255
	size=120
	Bladex.SetParticleGVal("Espumaw",i,r,g,b,a,size)
	
##########################################################################################################################

CreateCascada("Waterfall1",(645000 ,19000 ,70250 ),(-3000.0, -200.0, 500.0),(0, 3000, -15000.0),(646000,20000 ,70250),23)

CreateCascadaD("Waterfall1D",(645000 ,19000 ,-59750 ),(-3000.0, -200.0, 500.0),(0, 3000, -15000.0),(646000,20000 ,-59750),23)

##### cave

CreateCascadaCave("Cascadai1",(272500,1500,-110750),(0.0, 500.0, 3450.0),(-5000.0, 2000.0, 0.0),(270500,2000,-112500),30)

CreateCascadaCave("Cascadai2",(273500,-6000,-109750),(500.0, 0.0, 500.0),(0.0, 4000.0, 0.0),(270500,2000,-112500),30)

###### atrium


CreateWaterspout("Cascadai3",(33481,16173,-42950),(0.0, 20.0, 20),(-5000.0, 3000.0, 0.0),(32481,17600,-42950),16)

CreateWaterspout("Cascadai4",(27740,16173,-46286),(20.0, 20.0, 0.0),(0.0, 3000.0, 5000.0),(27740,17600,-45286),16)


v1=Bladex.CreateSound("..\\..\\Sounds\\agua-canal.wav","v1")
v1.MaxDistance=20000
v1.MinDistance=2000
v1.Volume=3.2
v1.BaseVolume=1.0
v1.SendNotify=0
v1.Play(648000 ,19000 ,72250,-1)


v2=Bladex.CreateSound("..\\..\\Sounds\\agua-canal.wav","v2")
v2.MaxDistance=20000
v2.MinDistance=2000
v2.Volume=3.2
v2.BaseVolume=1.0
v2.SendNotify=0
v2.Play(648000 ,19000 ,-57750,-1)


v3=Bladex.CreateSound("..\\..\\Sounds\\small-waterfall.wav","v3")
v3.MaxDistance=45000
v3.MinDistance=2000
v3.Volume=3.2
v3.BaseVolume=1.0
v3.SendNotify=0
v3.Play(272500,2000,-112500,-1)


v4=Bladex.CreateSound("..\\..\\Sounds\\agua-canal.wav","v4")
v4.MaxDistance=18000
v4.MinDistance=2000
v4.Volume=3.2
v4.BaseVolume=1.0
v4.SendNotify=0
v4.Play(25740,16173,-46286,-1)






