import Bladex
import AuxFuncs


sonidowall1=Bladex.CreateSound("..\\..\\Sounds\\Wooden-bridge-collapse.wav", "SonidoWall1")

sonidowall2=Bladex.CreateSound("..\\..\\Sounds\\Stone-floor-collapse.wav", "SonidoWall2")

bricksnd=Sounds.CreateEntitySound("..\\..\\Sounds\\golpe-bola-piedra.wav", "BrickSound")
bricksnd.Volume=1.0
bricksnd.MinDistance=10000
bricksnd.MaxDistance=90000

##########################################################################################
###### window in flat roof building

sectorbrk1=Bladex.GetSector(618875, 17000, 46750)
sectorbrk1.Active=0

sectorbrk1.InitBreak((250, 0, 0), (800, 200.0, 0), (-200, 800, 0))


sectorbrk1D=Bladex.GetSector(618875, 17000, -83250)
sectorbrk1D.Active=0

sectorbrk1D.InitBreak((250, 0, 0), (800, 200.0, 0), (-200, 800, 0))

################################
#### door in storehouse


sectorbrk2=Bladex.GetSector(631125, 17000, 59250)
sectorbrk2.Active=0

sectorbrk2.InitBreak((250, 0, 0), (800, 200.0, 0), (-200, 800, 0))


sectorbrk2D=Bladex.GetSector(631125, 17000, -70750)
sectorbrk2D.Active=0

sectorbrk2D.InitBreak((250, 0, 0), (800, 200.0, 0), (-200, 800, 0))


#####skel closet

sectorbrk3=Bladex.GetSector(-6750, -4000, -27375)
sectorbrk3.Active=0

sectorbrk3.InitBreak((250, 0, 0), (800, 200.0, 0), (0, 800, -200))

####################################
####### Snowball ###################
SnowballDropped=0

p1=668005,1212,-19500
r1=0.707107,0.707107,0.000000,0.000000
o=heavyObjects.CreateHeavyObject("Snowball1","BoladePiedra",p1,r1,0.7, heavyObjects.StoneHitEvent )

stone.lock( o.Name, stone.DROPBROWNDUST, 0, 1000, 0.0, 0.6, 12.0, stone.STONESOUND, 0.1 ) 


p2=672205,1612,-19500
r2=0.707107,0.707107,0.000000,0.000000
o=heavyObjects.CreateHeavyObject("Snowball2","BoladePiedra",p2,r1,0.7, heavyObjects.StoneHitEvent )

stone.lock( o.Name, stone.DROPBROWNDUST, 0, 1000, 0.0, 0.6, 12.0, stone.STONESOUND, 0.1 ) 


######################################
##### Rockslide ######################
######################################

r=0.707107,0.707107,0.000000,0.000000

o = heavyObjects.CreateHeavyObject("Stone1","Roca2Aurelio",(689500,-2000,-92000),r,1.0, SmallRockHit )
o.Scale=1.0
o.Orientation=0.707107,0.707107,0.000000,0.000000
o.Position = (689500,-2000,-92000)
o.InflictHitFunc = SmallRockHit

o = heavyObjects.CreateHeavyObject("Stone2","Roca1Aurelio",(688000,-3000,-96000),r,1.0, SmallRockHit )
o.Scale=1.0
o.Orientation=0.707107,0.707107,0.000000,0.000000
o.Position = (688000,-3000,-96000)
o.InflictHitFunc = SmallRockHit


o = heavyObjects.CreateHeavyObject("Stone3","Roca1Aurelio",(685250,0,-91000),r,0.6, SmallRockHit )
o.Scale=0.6
o.Orientation=0.707107,0.707107,0.000000,0.000000
o.Position = (685250,-2000,-91000)
o.InflictHitFunc = SmallRockHit
	

o = heavyObjects.CreateHeavyObject("Stone4","Roca1Aurelio",(683750,-4000,-94750),r,1.5, BigRockHit )
o.Scale=1.5
o.Orientation=0.707107,0.707107,0.000000,0.000000
o.Position = (683750,-4000,-94750)
o.InflictHitFunc = BigRockHit
 

stone.lock( "Stone1", stone.DROPBROWNDUST, 0, 200, 0.0, 0.1, 9.0, stone.STONESOUND, 0.1 ) 
stone.lock( "Stone2", stone.DROPBROWNDUST, 0, 200, 0.0, 0.1, 9.0, stone.SOUNDNULL, 0.1 ) 
stone.lock( "Stone3", stone.DROPBROWNDUST, 0, 200, 0.0, 0.1, 9.0, stone.SOUNDNULL, 0.1 ) 
stone.lock( "Stone4", stone.DROPBROWNDUST, 0, 200, 0.0, 0.1, 9.0, stone.STONESOUND, 0.1 ) 


##########################################################################################################################
###### Falling Masonry

o = heavyObjects.CreateHeavyObject("Brick1","Roca1",(-27298,-5581,-39929),(0.380,0.188,-0.450,-0.785),0.5, BrickHit )
o.Scale=0.5
o.Orientation=0.380,0.188,-0.450,-0.785
o.Position = (-27298,-5581,-39929)
o.InflictHitFunc = BrickHit


o = heavyObjects.CreateHeavyObject("Brick2","Roca1",(-27488,-5817,-38126),(0.912,-0.154,0.169,-0.337),0.7, BrickHit )
o.Scale=0.7
o.Orientation=0.912,-0.154,0.169,-0.337
o.Position = (-27488,-5817,-38126)
o.InflictHitFunc = BrickHit


o = heavyObjects.CreateHeavyObject("Brick3","Roca1",(-19309,-5458,-43947),(0.549,0.119,-0.278,-0.778),0.5, BrickHit )
o.Scale=0.5
o.Orientation=0.549,0.119,-0.278,-0.778
o.Position = (-19309,-5458,-43947)
o.InflictHitFunc = BrickHit


o = heavyObjects.CreateHeavyObject("Brick4","Roca1",(-32025,-5693,-34077),(0.835,0.047,-0.395,-0.377),0.6, BrickHit )
o.Scale=0.6
o.Orientation=0.835,0.047,-0.395,-0.377
o.Position = (-32025,-5693,-34077)
o.InflictHitFunc = BrickHit


o = heavyObjects.CreateHeavyObject("Brick5","Roca1",(-31456,-5542,-36965),(0.470,-0.682,0.396,-0.394),0.6, BrickHit )
o.Scale=0.6
o.Orientation=0.470,-0.682,0.396,-0.394
o.Position = (-31456,-5542,-36965)
o.InflictHitFunc = BrickHit


stone.lock( "Brick1", stone.DROPBROWNDUST, 0, 200, 0.0, 0.1, 9.0, stone.SOUNDNULL, 0.1 ) 
stone.lock( "Brick2", stone.DROPBROWNDUST, 0, 200, 0.0, 0.1, 9.0, stone.SOUNDNULL, 0.1 ) 
stone.lock( "Brick3", stone.DROPBROWNDUST, 0, 200, 0.0, 0.1, 9.0, stone.SOUNDNULL, 0.1 ) 
stone.lock( "Brick4", stone.DROPBROWNDUST, 0, 200, 0.0, 0.1, 9.0, stone.SOUNDNULL, 0.1 ) 
stone.lock( "Brick5", stone.DROPBROWNDUST, 0, 200, 0.0, 0.1, 9.0, stone.SOUNDNULL, 0.1 ) 


###########################################################################################################################
######### CDf tunnel

sectorbrk4=Bladex.GetSector(58750, 25000, -20000)
sectorbrk4.Active=0
sectorbrk4.InitBreak((750, 0, 0), (800, 200.0, 0), (-200, 800, 0))


sectorbrk5=Bladex.GetSector(58750, 23500, -20000)
sectorbrk5.Active=0
sectorbrk5.InitBreak((750, 0, 0), (800, 200.0, 0), (-200, 800, 0))

############################################################################################################################
#### tunnel collapse


o = heavyObjects.CreateHeavyObject("Trock1","Roca1",(0,30000,0),(0.126,0.739,-0.256,-0.609),0.5, BrickHit )
o.Scale=0.9
o.Orientation=0.126,0.739,-0.256,-0.609
o.Position = (0,30000,0)
o.InflictHitFunc = BrickHit

o = heavyObjects.CreateHeavyObject("Trock2","Roca1",(0,30000,0),(0.126,0.739,-0.256,-0.609),0.5, BrickHit )
o.Scale=1.0
o.Orientation=0.126,0.739,-0.256,-0.609
o.Position = (0,30000,0)
o.InflictHitFunc = BrickHit

o = heavyObjects.CreateHeavyObject("Trock3","Roca1",(0,30000,0),(0.126,0.739,-0.256,-0.609),0.5, BrickHit )
o.Scale=0.8
o.Orientation=0.126,0.739,-0.256,-0.609
o.Position = (0,30000,0)
o.InflictHitFunc = BrickHit