import Bladex
import ItemTypes
import Interpolator
import CharStats
import ItemTypes
import AuxFuncs
import Sparks
import Objects
import InitDataField
import Blood
import dust
import B3DLib
import Damage
import darfuncs
import GenFX
import Reference
import Sounds
import MenuText
import Actions
import Auras
import math
import BCopy
import whrandom
import Actions
import BUIx	
import ScorerWidgets
import Scorer
import Ally_Def
import ObjStore
import netgame
import GameStateAux
import Language
import Change

from Tr import Tr

########################################################################################################################

TRUE = 1
FALSE = 0

#######################################################################################################################

	   	
def LaunchWeapon (EntityName):
	me= Bladex.GetEntity(EntityName)
	if me and me.Life>0:
		return me.Data.StartThrowMissle (EntityName)
	return 0
		
	
def LaunchSpecialAttack (EntityName):
	me= Bladex.GetEntity(EntityName)
	if me and me.Life>0:
		return me.Data.StartSpecialAttack (EntityName)
	return 0

###########################################################################################################################

def BurnAway(EntityName):
	ps=Bladex.CreateEntity(EntityName+"DCL", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName=EntityName
	ps.ParticleType="DeathCloud"
	ps.Time2Live=64
	ps.RandomVelocity=0
	ps.Velocity=100,200,0
	ps.NormalVelocity=2.0
	ps.YGravity=-300
	ps.DeathTime=Bladex.GetTime()+2.0
	ps.PPS=250   
	me = Bladex.GetEntity(EntityName)
	me.Alpha=0.8
	me.RasterMode="Read"
	me.CastShadows=0
	AuxFuncs.FadeObject(EntityName, 0.8, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, me.RemoveFromWorld,())
	lite=Bladex.GetEntity(EntityName+"Luz")
	AuxFuncs.GetSpot(lite)
	AuxFuncs.SpotIntensityVariation(lite.Name,7.0,0.0,4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.2, lite.SubscribeToList,("Pin",))
	print("golem melted away")


def Dissolve(PersonName):
	ps=Bladex.CreateEntity(PersonName+"PS", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName=PersonName
	ps.ParticleType="GreenSmoke1"
	ps.Time2Live=64
	ps.RandomVelocity=0
	ps.Velocity=100,200,0
	ps.NormalVelocity=2.0
	ps.YGravity=-300
	ps.DeathTime=Bladex.GetTime()+2.0
	ps.PPS=300
	me = Bladex.GetEntity(PersonName)
	me.Alpha=1.00
	me.RasterMode="Read"
	me.CastShadows=0
	AuxFuncs.FadeObject(PersonName, 1.00, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, GoAway,(me.Name,))
	print("green skel turned to dust")


def GoAway(entity):
	thing=Bladex.GetEntity(entity)
	thing.Position=(0,50000,0)
	print("gone away")


def Dissolve2(ObjName):
	me= Bladex.GetEntity(ObjName)
	if me:
		wps=Bladex.CreateEntity(ObjName+"WPS", "Entity Particle System Dobj", 0.0, 0.0, 0.0)
		wps.ObjectName=ObjName
		wps.ParticleType="GreenSmoke1"
		wps.Time2Live=64
		wps.RandomVelocity=0
		wps.Velocity=100,300,0
		wps.NormalVelocity=2.0
		wps.YGravity=-300
		wps.DeathTime=Bladex.GetTime()+1.5
		wps.PPS=300
		me = Bladex.GetEntity(ObjName)
		me.Alpha=1.00
		me.RasterMode="Read"
		me.CastShadows=0
		AuxFuncs.FadeObject(ObjName, 1.00, 0.0, 4.0)
		if me.Kind=="Skull":
			Bladex.AddScheduledFunc(Bladex.GetTime()+4.1,GoAway,(me.Name,))
		else:
			Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, me.RemoveFromWorld,())
		print("skel limb dissolved")


def PullMyHeadOff(entity):
	print ("start to pull head off")
	pers=Bladex.GetEntity(entity)
	pers.Wuea=Reference.WUEA_ENDED
	pers.LaunchAnimation("Chg_r_l")
	o=pers.SeverLimb(1)
	try:
		o.SubscribeToList("Pin")
	except:
		print("head not dissappeared")
			
	persinv= pers.GetInventory()
	persrwp=Bladex.GetEntity(pers.InvRight)
	if persrwp:
		persinv.RemoveWeapon(persrwp.Name)
		persinv.LinkRightHand("None")
		persrwp.SubscribeToList("Pin")
	head=Bladex.GetEntity(entity+"SpareHead")
	persinv.LinkRightHand(head.Name)
	print("pulled head off")

############################################################################################################################

class XtraWeaponFX:

	def __init__(self, WeaponName, auraparams, auragradient, prtldata, lightdata):
		self.ObjId= ObjStore.GetNewId()
		ObjStore.ObjectsStore[self.ObjId]= self
		weapon=Bladex.GetEntity(WeaponName)
		self.WeaponName=WeaponName
		self.Aura=None
		self.Particles=None
		self.Light=None
		if auraparams:
			s, a, ci, f, b, am=auraparams
			m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd=auragradient
			self.Aura=Bladex.CreateEntity(WeaponName+"Aura", "Entity Aura", 0, 0, 0)
			self.Aura.SetAuraParams(s, a, ci, f, b, am)
			self.Aura.SetAuraGradient(m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd)
			weapon.Link(self.Aura)
			self.Aura.SetAuraActive(1)
		if prtldata:
			pt, pps, v, nv, rv, g, fr, ff, t2l=prtldata
			self.Particles=Bladex.CreateEntity(WeaponName+"Particles", "Entity Particle System Dobj", 0, 0, 0)
			self.Particles.ObjectName=WeaponName
			self.Particles.ParticleType=pt
			self.Particles.PPS=pps
			self.Particles.Velocity=v
			self.Particles.NormalVelocity=nv
			self.Particles.RandomVelocity=rv
			self.Particles.YGravity=g
			self.Particles.Friction=fr
			self.Particles.FollowFactor=ff
			self.Particles.Time2Live=t2l
		if lightdata:
			i, color, fl=lightdata
			self.Light=Bladex.CreateEntity(WeaponName+"Light", "Entity Spot", 0, 0, 0)
			self.Light.Intensity=i
			self.Light.Color=color
			self.Light.Flick=fl
			self.Light.CastShadows=0
			self.Light.Visible=0
			weapon.Link(self.Light)

	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.WeaponName,
				GameStateAux.SaveEntityAux(self.Aura),
				GameStateAux.SaveEntityAux(self.Particles),
				GameStateAux.SaveEntityAux(self.Light)
			)


	def __setstate__(self,parm):
		#print "GenFX.__setstate__()",parm
		if parm[0]==1:
			self.ObjId= parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.WeaponName=parm[2]
			self.Aura=GameStateAux.LoadEntityAux(parm[3])
			self.Particles=GameStateAux.LoadEntityAux(parm[4])
			self.Light=GameStateAux.LoadEntityAux(parm[5])
		else:
			print "XtraWeaponFX.__setstate__() -> Version mismatch"
			self.WeaponName=""
			self.Aura=""
			self.Particles=""
			self.Light=""
			self.ObjId= ObjStore.GetNewId()
			ObjStore.ObjectsStore[self.ObjId]=self



def AddXtraWeaponFX(WeaponName,data):
	weapon=Bladex.GetEntity(WeaponName)
	if not data:
		InitDataField.Initialise(weapon)
		data= weapon.Data
	if weapon.Kind==("Skull"):
		auraparams=()
		auragradient=()
		prtldata=("GreenVapour", 30, (0.0, 0.0, 0.0), 0.0, 1.0, 0.0, 0.02, 0.0, 60)
		lightdata=()
		weapon.SelfIlum=0.4
	elif weapon.Kind in ("Espadaromana", "HookSword", "Daga", "Gladius","Phurbhu"):
		auraparams=()
		auragradient=()
		prtldata=("Vaho", 20, (0.0, 0.0, 0.0), 0.0, 1.0, 150.0, 0.02, 0.0, 60)
		lightdata=()
		weapon.SelfIlum=0.1
		weapon.Alpha=0.99
	elif weapon.Kind ==("Varita7"):
		auraparams=(10, 1, 1, 0, 0, 1)
		auragradient=(2, 0.9, 1.0, 1.0, 0.2, 0.1, 0.4, 0.8, 1.0, 0.2, 1.0)
		prtldata=("Vaho", 20, (0.0, 0.0, 0.0), 0.0, 1.0, 150.0, 0.02, 0.0, 60)
		lightdata=()
		weapon.SelfIlum=0.2
		weapon.Alpha=0.99
	data.XtraWeaponFX=XtraWeaponFX(WeaponName, auraparams, auragradient, prtldata, lightdata)
	
	
class WierdWeapons:
	def __init__ (self, me):
		AddXtraWeaponFX(me.Name, self)
		
###########################################################################################################################

class GladiatorTravelBook(BUIx.B_RectWidget):
	def __init__(self,Parent,Menudesc,StackMenu,VertPos=0):
		import Language
		import Raster
		self.index = 1
		self.images = []
		self.vidw = 1
		self.vidh = 1
		char = Bladex.GetEntity("Player1")
		Raster.UnifyRenderBuffers()
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillaspecials.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillaweapons.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillahabilities.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current +"\\Items\\plantillaGitems.jpg")
		#self.AddImage("..\\..\\Maps\\gladiator\\gladiator.jpg")
		#self.AddImage("..\\..\\Maps\\gladiator\\credits.jpg")
		BUIx.B_RectWidget.__init__(self,Parent,Menudesc["Name"],self.vidw,self.vidh)
		self.Selected=0
		self.Solid=0
		self.Border=0
		self.SetDrawFunc(self.Draw)
		self.SndCorreGema=Bladex.CreateSound("..\\..\\Sounds\\golpe-2.wav","Chanje")
		self.SndCorreGema.Volume=0.5
		self.SndCorreGema.MinDistance=1000000.0
		self.SndCorreGema.MaxDistance=2000000


	def AddImage(self, file):
		import BBLib
		image = BBLib.B_BitMap24()
		image.ReadFromFile(file)
		self.images.append(image)


	def Draw(self,x,y,time):
		import Menu
		import Raster
		char = Bladex.GetEntity("Player1")
		x,y = Raster.GetSize()
		Raster.SetPosition((x - 640)/2, (y - 480)/2)
		if self.index < 0:
			self.index = len(self.images) - 1
		if self.index > len(self.images) - 1:
			self.index = 0
		Raster.DrawImage(640,480,"BGR","Normal",self.images[self.index].GetData())
		self.DefDraw(x,y,time)

	def FinalRelease(self):
		BUIx.B_RectWidget.FinalRelease(self)

	def AcceptsFocus(self):
		return 1

	def IncMenuItem(self):
		self.SndCorreGema.PlayStereo()
		self.index = self.index + 1

	def DecMenuItem(self):
		self.SndCorreGema.PlayStereo()
		self.index = self.index - 1

	def GetFocus(self):
	    return self

	def ActivateItem(self,activate):
		import Menu
		Menu.ActivateMenu()


def ExecTravelBook():
	print("travel book activated")
	import Menu
	import GameText
	import Scorer
	import acts
	GameText.AbortText()
	if not Menu.MENU_PREACTIVATED:
		try:
			Menu.TB_ACTIVATED=1
		except:
			pass
		Menu.MENU_PREACTIVATED = 1
		pepote = Menu.Desc1
		Menu.Desc1={"Name":"TopMenu","FrameKind":GladiatorTravelBook,"ListDescr":[{"Name":"Back","Kind":GladiatorTravelBook}]}
		Menu.ActivateMenu()
		Menu.Desc1 = pepote
		Scorer.HideTBS()
		for kn in acts.GetKeyList("Turn Left"):
			if kn!="Left":
				Bladex.AssocKey("Menu Dec","Keyboard",kn)
		for kn in acts.GetKeyList("Turn Right"):
			if kn!="Right":
				Bladex.AssocKey("Menu Inc","Keyboard",kn)
	
	

	
				
				
# Dropping Bows 8/)
	
def TryDropLeftBow (EntityName):
	me = Bladex.GetEntity(EntityName)
	statL=Actions.StatL(me.Name)
	statR=Actions.StatR(me.Name)
	if statL == Actions.LA_BOW:
		print "Bow in left hand - try drop"
		inv=me.GetInventory()
		if me.InvRight and Reference.GiveObjectFlag(me.InvRight)==Reference.OBJ_ARROW:
			Actions.SheatheArrow(inv, me.InvRight)
		object = Bladex.GetEntity(me.InvLeft)
		object.ExcludeHitFor(me)
		me.AddAnmEventFunc("DropLeftEvent",Actions.DropReleaseEventHandler)
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.0,me.LaunchAnmType,("drp_l",))
		return TRUE
		print"I have dropped a bow"
	elif statL <> Actions.LA_NO_WEAPON:
		object = Bladex.GetEntity(me.InvLeft)
		if Actions.IsValidForDropping (object.Name):
			object.ExcludeHitFor(me)
			me.AddAnmEventFunc("DropLeftEvent",Actions.DropReleaseEventHandler)
			me.LaunchAnmType("drp_l")
			return TRUE
			print"dropping Shield?"
		else:
			ReportMsg ("Cannot be dropped")
	else:
		return FALSE

	
	
def CheckDropBow(EntityName):
	me = Bladex.GetEntity(EntityName)
	throw_pressed = Bladex.GetTimeActionHeld ("Throw")
	if not throw_pressed:
		return
	TryDropLeftBow (EntityName)
	
	
	
	
	
def EnableTravelBook():
	Bladex.AddBoundFunc("LaunchTravel",ExecTravelBook)
	import acts
	Bladex.AddBoundFunc("Throw Left",acts.DefArgWrapper ("Player1", CheckDropBow))
	Bladex.AddBoundFunc("Block",acts.DefArgWrapper ("Player1", CheckDropBow))
	Bladex.RemoveBoundFunc("LaunchTravel",acts.ExecTravelBookNP)
	Bladex.RemoveBoundFunc("Throw Left",Actions.TestThrowLeft)
	Bladex.RemoveBoundFunc("Block",Actions.TestThrowLeft)
	
	

##########################################################################################################################
##### Amulet Aux Functions

def DestSound(amu):
	sndpos=Bladex.GetEntity("Player1").Position
	snddestroya=Bladex.CreateSound("..\\..\\Sounds\\llave-estrella.wav", "SndDestroyer"+str(amu))
	snddestroya.Volume=3.7
	snddestroya.MinDistance= 5000
	snddestroya.MaxDistance=25000     
	snddestroya.Play(sndpos[0],sndpos[1],sndpos[2],0)
	
	   
def KillOff(entity):
	pers=Bladex.GetEntity(entity)
	pers.Life=-1
	
	
	
def Decapitate(entity):
	pers=Bladex.GetEntity(entity)
	pers.Life=-1
	pers.SeverLimb(1)
	


def EnemyMagicallyAppearingX(entity, xtime):
	TimeEffect=xtime
	time=Bladex.GetTime()
	AuraParams0=(240, 0.01, 1.0, 0, 1, 1)
	AuraParams1=(50 , 1.0 , 1.0, 0, 1, 1)
	AuraParams2=(50 , 0.01, 1.0, 0, 1, 1)
	AuraGradient0=(2,  0.4, 0.4, 1.0, 1.0, 0.2  ,  0.0, 0.3, 0.9, 0.0, 0.7)
	AuraGradient1=(2,  0.1, 0.2, 0.9, 1.0, 0.2  ,  0.6, 0.6, 0.9, 0.1, 1.0)
	aura=Auras.MakeAura(entity, TimeEffect, AuraParams0, (), (), AuraGradient0)
	aura.Data.AddEvent (time+TimeEffect/2.0, AuraParams1, (), (), AuraGradient1)
	aura.Data.AddEvent (time+TimeEffect, AuraParams2, (), (), AuraGradient0)
	ps=Bladex.CreateEntity("PSEnemyMagicallyAppearing", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName=entity
	ps.ParticleType="FastEnergyConc"
	ps.PPS=400  
	ps.YGravity=-800    
	ps.Friction=0.5 
	ps.Velocity=0.0, 0.0, 0.0
	ps.RandomVelocity=0.5
	ps.NormalVelocity=-2.0
	ps.Time2Live=30    
	ps.DeathTime=time+TimeEffect/2.0
	
	
def Flare(entity):
	pos=Bladex.GetEntity(entity).Position
	luz=Bladex.CreateEntity("AmLite"+str(entity),"Entity Spot",pos[0],pos[1],pos[2])
	luz.Color=100, 100, 180
	luz.Intensity=0.1
	luz.Precission=0.1
	luz.CastShadows=0
	luz.GlowTexture="SunFlare"
	luz.AngVel=1.59
	luz.SizeFactor=0.01
	FlareAndGo(luz.Name)
	print("flare")
	
	
def FlareAndGo(entity):
	lite=Bladex.GetEntity(entity)
	AuxFuncs.SpotIntensityVariation(lite.Name, 0.1, 35.0, 1.5)
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.7, lite.SubscribeToList,("Pin",))
	

def VanishPJ():
	reapptime=2.8
	pj=Bladex.GetEntity("Player1")
	inv=pj.GetInventory()
	lwp=Bladex.GetEntity(pj.InvLeft)
	rbwp=Bladex.GetEntity(pj.InvRightBack)
	lbwp=Bladex.GetEntity(pj.InvLeftBack)
	
	if lwp:
		lwp.Alpha=0.0
		lwp.CastShadows=0
	if lbwp:
		lbwp.Alpha=0.0
		lbwp.CastShadows=0
	if rbwp:
		rbwp.Alpha=0.0
		rbwp.CastShadows=0
	pj.Alpha=0.0
	pj.CastShadows=0
	Bladex.AddScheduledFunc(Bladex.GetTime()+reapptime,ReappearPJ,())
		
		
def ReappearPJ():
	pj=Bladex.GetEntity("Player1")
	pj.Data.Invincibility= 0
	inv=pj.GetInventory()
	lwp=Bladex.GetEntity(pj.InvLeft)
	rbwp=Bladex.GetEntity(pj.InvRightBack)
	lbwp=Bladex.GetEntity(pj.InvLeftBack)
	
	if lwp:
		AuxFuncs.FadeObject(lwp.Name,0.0,1.0,1.2)
		lwp.CastShadows=1
	if lbwp:
		AuxFuncs.FadeObject(lbwp.Name,0.0,1.0,1.3)
		lbwp.CastShadows=1
	if rbwp:
		AuxFuncs.FadeObject(rbwp.Name,0.0,1.0,1.4)
		rbwp.CastShadows=1
	pj.Alpha=1.0
	pj.CastShadows=1	
	EnemyMagicallyAppearingX("Player1", 1.5)
	
######################################################################################################################

class PowerAmulet (ItemTypes.ItemOfProtection):

        def __init__ (self, me):
                ItemTypes.ItemOfProtection.__init__(self, me)
                self.Name= me.Name
                self.UsedBy= "Player1"
                self.UseTime= 3.0
                self.Resistances= {}
                self.nUses= 1
                self.exemptlist=[]
           	Reference.EntitiesSelectionData[self.Name]=(8,4000,MenuText.GetMenuText('Talisman of Nemesis'))
             
        def UseStart (self, ObjectName, use_from):
                ItemTypes.ItemOfProtection.UseStart (self, ObjectName, use_from)
                dumamu=Bladex.CreateEntity("DummyPowerAmulet","Amuleto",0,0,0)
		dumamu.Scale=0.7
		dumamu.SelfIlum=0.4
		Reference.EntitiesObjectData["DummyPowerAmulet"]=[Reference.OBJ_STANDARD]
                pj=Bladex.GetEntity("Player1")
                pj.Data.Invincibility= 1
                inv=pj.GetInventory()
                if inv.HoldingBow:
                	Actions.FreeBothHands("Player1")
                rwp=Bladex.GetEntity(pj.InvRight)
		if rwp:
                	inv.LinkRightHand("None")
                	#dropobj=Bladex.GetEntity(rwp)
                	rwp.Impulse(0,0,0)
                	inv.RemoveWeapon(rwp.Name)
                pj.Wuea = Reference.WUEA_ENDED
		pj.SetTmpAnmFlags(1,1,1,0,5,1)
                Bladex.AddScheduledFunc(Bladex.GetTime() + 0.4,pj.LaunchAnmType,("Chg_r",))
                pj.AnmEndedFunc=self.Anm2
                Bladex.AddScheduledFunc(Bladex.GetTime() + 0.5,inv.LinkRightHand,(dumamu.Name,)) 
                Bladex.AddScheduledFunc(Bladex.GetTime() + 1.7, self.Destroy,(dumamu.Name,))
                
                
        def Anm2(self,entity):
        	pj=Bladex.GetEntity("Player1")
        	pj.LaunchAnmType("Fire3")
        	pj.AnmEndedFunc=self.Anm3
        	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.3,VanishPJ,())
        	
        def Anm3(self,entity):
        	pj=Bladex.GetEntity("Player1")
        	pj.LaunchAnmType("Rlx_no")
        	pj.AnmEndedFunc=None
        	
                
	def Destroy(self,obj):
		pj=Bladex.GetEntity("Player1")
		dumamu=Bladex.GetEntity(obj)
		inv=pj.GetInventory()
		pos=pj.Position
                DestSound(dumamu.Name)
                AuxFuncs.FadeObject(dumamu.Name,1.0,0.0,1.0)
                Flare(dumamu.Name)
                Bladex.AddScheduledFunc(Bladex.GetTime() + 1.2,inv.LinkRightHand,("None",))
                Bladex.AddScheduledFunc(Bladex.GetTime() + 1.3, dumamu.SubscribeToList,("Pin",)) 
                 
                		
		enems = Bladex.GetEntitiesAt(pos[0],pos[1],pos[2],6000)
		for id in enems:
			victim = Bladex.GetEntity(id)			
			if victim.Person and victim.Name != 'Player1':
				if victim.Life>0:
					if victim.Kind=="Knight_Traitor" or victim.Kind=="Dark_Knight":
						if victim.GetInventory().GetMagicShield():
							pass
							
						if victim.Name in self.exemptlist:	
							import GameText
							GameText.AbortText()
							GameText.WriteTextAux(Tr("Ha-ha!..your foolish tricks will not work on me!"), 2.5, 190,120,120,[],100)	
							
				
						else:
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
							EnemyMagicallyAppearingX(victim.Name,2)
							Bladex.AddScheduledFunc(Bladex.GetTime() + 0.3,victim.SetMesh,("Skeleton",))
							Bladex.AddScheduledFunc(Bladex.GetTime() + 1.0,KillOff,(victim.Name,))
							Bladex.AddScheduledFunc(Bladex.GetTime() + 6.0,dust.EnPolvoPerson,(victim.Name,100,0,))
					elif victim.Kind=="Minotaur":
						KillOff(victim.Name)
						Actions.FireDeath(victim.Name)
						victim.CastShadows=0
					elif victim.Kind in ("Golem_stone","Golem_lava","Little_Demon","Cos","ChaosKnight"):
						KillOff(victim.Name)
					elif victim.Kind in ("Great_Ork","Ork","Skeleton","Lich","Knight_Zombie"):
						Decapitate(victim.Name)
					print("enemy destroyed")
				
						
        def UseEnd (self,ObjectName, UserName):
        	amu=Bladex.GetEntity(ObjectName)
        	amu.SubscribeToList("Pin")        	
                ItemTypes.ItemOfProtection.UseEnd (self, ObjectName, UserName)
                
##########################################################################################################################

class PhurbhuX (ItemTypes.PersistantItemType):

	def __init__(self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Name= me.Name
		self.Age = 0
		self.Hit = 0
		self.OwnerName=""
		try:
			AddXtraWeaponFX(me.Name, self)
		except:
			print"no FX on Ice Rocket"
		
		Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_ITEM]
		Reference.StackObjects['Phurbhu']= 4
		weapon= Bladex.GetEntity(self.Name)
		InitDataField.Initialise(weapon)
		
		
		if Language.Current == "Spanish":
           		MenuText.ForeingDict['Rocket'] = 'Cohete'
		Reference.EntitiesSelectionData[self.Name]=(8,4000,MenuText.GetMenuText('Rocket'))

		me.UseFunc = self.UsePhurbhu

		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["PhurbhuX"]=   (				self.Name,
									self.Age,
									self.Hit,
									self.OwnerName
								)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["PhurbhuX"]
			self.Name=parms[0]
			self.Age=parms[1]
			self.Hit= parms[2]
			self.OwnerName=  parms[3]		
		else:
			self.Name=""
			self.Age=0
			self.Hit= 0
			self.OwnerName= "Player1"
			
	

	def UsePhurbhu(self, RocketName, TipoUso):
		rocket=Bladex.GetEntity(RocketName)
		if TipoUso == Actions.USE_FROM_INV:
		   	ownerName= rocket.Data.UsedBy
		   	Actions.FreeBothHands(ownerName)
		   	owner=Bladex.GetEntity(ownerName)
		   	if owner and owner.Life >0:
		   		owner.Data.throw_weapon = None
      	              	inv=owner.GetInventory()
      	              	inv.RemoveObject(RocketName)
   	              	Change.ChangeObject(ownerName, RocketName, self.FinishChange)
   	        elif TipoUso == Actions.USE_FROM_TAKE:
		   	Actions.StdUse (ownerName)


	def FinishChange(self, EntityName,ObjectName):
		rocket=Bladex.GetEntity(ObjectName)
		rocket.Data=IceRocket(rocket)
	       	Reference.EntitiesObjectData[ObjectName]= [Reference.OBJ_STANDARD,   600, 0, 1.0, Reference.THR_SPINNING, [],["Ice", +1000.0]]
   
  


class IceRocket(ItemTypes.ActivateableSpecialWeapon):
	
	def __init__(self, me):
		ItemTypes.ActivateableSpecialWeapon.__init__(self, me)
		self.SpecialExtraDamage= [["Ice", +5000],]
		me.Weapon= 1
		self.Age= 0
		self.FadeTime= 1.0
		self.Speed= 10000.0
		self.missileName= ""
		self.LastHitTime=-1
		self.AuxFuncsData=None
		
		self.WhileSound=Bladex.CreateEntity (me.Name+"MissileLoopSound", "Entity Sound", 0, 0, 0)
		self.WhileSound.SetSound("..\\..\\Sounds\\electric-eels.wav")
		self.WhileSound.MinDistance=5000
		self.WhileSound.MaxDistance=30000
		me.Link(self.WhileSound)
		
		self.ImpactSound=Bladex.CreateEntity (me.Name+"MissileImpactSound", "Entity Sound", 0, 0, 0)
		self.ImpactSound.SetSound("..\\..\\Sounds\\energy-ball-impact.wav")
		self.ImpactSound.MinDistance=5000
		self.ImpactSound.MaxDistance=30000
		self.OwnerName=""


	def __getstate__(self):
		state= ItemTypes.ActivateableSpecialWeapon.__getstate__(self)
		state[1]["IceRocket"]=   (self.Age,
									self.FadeTime,
									self.Speed,
									self.missileName,
									self.LastHitTime,
									self.WhileSound.Name,
									self.ImpactSound.Name,
									self.AuxFuncsData,
									self.OwnerName
									)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.ActivateableSpecialWeapon.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["IceRocket"]
			self.Age=parms[0]
			self.FadeTime= parms[1]
			self.Speed=parms[2]
			self.missileName= parms[3]
			self.LastHitTime= parms[4]
			self.WhileSound= Bladex.GetEntity(parms[5])
			self.ImpactSound= Bladex.GetEntity(parms[6])
			self.AuxFuncsData= parms[7]
			self.OwnerName=  parms[8]
		else:
			self.Age=0
			self.FadeTime= 1.0
			self.Speed= 10000.0
			self.missileName= ""
			self.LastHitTime=-1
			self.WhileSound= Bladex.GetEntity(self.Name+"MissileLoopSound")
			self.ImpactSound= Bladex.GetEntity(self.Name+"MissileImpactSound")
			self.AuxFuncsData= None
			self.OwnerName= ""
		
		weapon=  Bladex.GetEntity(self.Name)
		if weapon:
			#weapon.OnStopFunc=self.Disintegrate
			pass
		
		if self.missileName:
			missile= Bladex.GetEntity(self.missileName)
			if missile:
				missile.InflictHitFunc= self.BladeSwordInflictHitFunc
				missile.OnHitFunc= self.MissileOnHitFunc
				if weapon:
					weapon.InflictHitFunc= self.BladeSwordInflictHitFunc
			else:
				print "Missile "+self.missileName+" unavailable for linking...."


	def Disintegrate(self, EntityName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		AuxFuncs.FadeObject(weapon.Name, weapon.Alpha, 0.01, self.FadeTime)
		blaura=Bladex.GetEntity(weapon.Name+"Aura")
		if blaura:
			AuxFuncs.FadeAndScaleAura(blaura.Name, 80.0, 250.0, 1.0, 0.01, self.FadeTime)
		bllight=Bladex.GetEntity(weapon.Name+"Light")
		if bllight:
			AuxFuncs.SpotIntensityVariation(bllight.Name, 1.0, 0.0, self.FadeTime)
		Bladex.AddScheduledFunc(Bladex.GetTime()+self.FadeTime, self.SubcribeToList, ("Pin",))
	
	
	def DropReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return		
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return	
		if weapon.TestHit:
			return
		Actions.RemoveFromInventory (owner, weapon, EventName)
		ix, iy, iz = owner.Rel2AbsVector(-1000.0, -1500.0, 0.0)
		weapon.Impulse(ix, iy, iz)
		weapon.ExcludeHitFor(owner)
		owner.DelAnmEventFunc(EventName)
		Reference.EntitiesObjectData[weapon.Name]= [Reference.OBJ_ITEM]
		weapon.Data=PhurbhuX(weapon)
	
	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return
		
		if weapon.TestHit:
			return
		
		Actions.RemoveFromInventory (owner, weapon, EventName)
		self.Age= self.Age+1
		x,y,z= weapon.Position
		missile= Bladex.CreateEntity(self.Name+"_Missile_"+`self.Age`, "Entity Magic Missile", x,y,z)
		InitDataField.Initialise(missile)
		missile.CastShadows=0
		missile.Color=0, 0, 0
		self.missileName= missile.Name
		
		# Set the velocity of the missile
		if owner.ActiveEnemy:
			enemy= Bladex.GetEntity(owner.ActiveEnemy)
			if enemy and enemy.Person:
				tx1,ty1,tz1= enemy.GraspPos ("ViewPoint")
				tx2,ty2,tz2= enemy.Position
				tx= (tx1+tx2)/2.0; ty= (ty1+ty2)/2.0; tz= (tz1+tz2)/2.0; 
			else:
				tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
		else:
			tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
		
		angley= -B3DLib.GetYAngle(tx-x,ty-y,tz-z)
		vx,vy,vz= owner.Rel2AbsVector(0.0, -math.cos(angley)*self.Speed, -math.sin(angley)*self.Speed)
		
		anglexz= B3DLib.Pos2PosXZAngle(x,y,z,tx,ty,tz)
		diff_angle= min (max (B3DLib.DiffAngle(anglexz, owner.Angle), -Actions.FACINGANGLE), Actions.FACINGANGLE)
		cos_ang= math.cos(diff_angle); sin_ang= math.sin(diff_angle)
		vx,vy,vz=  (vx*cos_ang-vz*sin_ang, vy, vx*sin_ang+vz*cos_ang)
		
		# Reorient and Link the sword to the missile
		weapon.Orientation=0.707107,0.707107,0.000000,0.000000
		weapon.RotateRel(0,0,0, 0,-1,0, 3.14159/2.0)
		weapon.RotateRel(0,0,0, -1,0,0, (3.0*3.14159/2.0)-anglexz)
		weapon.RotateRel(0,0,0, 0,-1,0, -angley)
		
		weapon.Position=0, 0, 0
		missile.Link(weapon)
		AuxFuncs.FadeObject(weapon.Name, weapon.Alpha, 0.01, self.FadeTime)
		AuxFuncs.ColorObject(missile.Name, missile.Color, (150,200,255), self.FadeTime*2.0)
		missile.Velocity= vx,vy,vz
		
		prtl=Bladex.CreateEntity(weapon.Name+"TrailParticles"+`self.Age`, "Entity Particle System Dobj", 0, 0, 0)
		prtl.ObjectName=weapon.Name
		prtl.ParticleType="SnowDust"
		prtl.PPS=400
		prtl.Velocity=0.0, 0.0, 0.0
		prtl.NormalVelocity=14.0
		prtl.RandomVelocity=4.0
		prtl.YGravity=0.0
		prtl.Friction=0.01
		prtl.FollowFactor=0.0
		prtl.Time2Live=30
		
		self.WhileSound.PlaySound(-1)
		
		Reference.EntitiesObjectData[missile.Name]= Reference.DefaultObjectData[weapon.Kind]
		missile.OnHitFunc= self.MissileOnHitFunc
		missile.Data.ThrownBy= owner  		# this pointer may not be valid
		missile.InflictHitFunc= self.BladeSwordInflictHitFunc
		weapon.InflictHitFunc= self.BladeSwordInflictHitFunc
		
	def BladeSwordInflictHitFunc(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		if self.missileName:
			self.MissileOnHitFunc (self.missileName, VictimName)
	
	def DeleteMissileData(self):
		if self.missileName and Reference.EntitiesObjectData.has_key(self.missileName):
			del Reference.EntitiesObjectData[self.missileName]
			self.missileName= ""
			
	def MissileOnHitFunc (self, EntityName, hit_entity):
		time=Bladex.GetTime()
		if time==self.LastHitTime:
			return
		if hit_entity:
			print EntityName+" hitting "+hit_entity
			pass
		else:
			pass
			print EntityName+" hitting world"
		missile= Bladex.GetEntity(EntityName)
		weapon= Bladex.GetEntity(self.Name)
		if weapon: weapon.Data.InflictHitFunc=0
		if missile and weapon:
			Bladex.AddScheduledFunc(time, self.DeleteMissileData, (), "DeleteMissileData")
			prtl=Bladex.GetEntity(weapon.Name+"TrailParticles"+`self.Age`)
			if prtl:
				prtl.DeathTime=Bladex.GetTime()
			#self.weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
			missile.Unlink(weapon)
			missile.Stop()
			missile.SubscribeToList("Pin")
			self.WhileSound.StopSound()
			self.ImpactSound.Position=weapon.Position
			self.ImpactSound.PlaySound(0)
			
			
			owner= Bladex.GetEntity(self.OwnerName)
			if owner:
				inv= owner.GetInventory()
				#flag=Reference.GiveWeaponFlag(weapon.Name)
				#inv.AddWeapon(weapon.Name,flag)
				weapon.RemoveFromWorld()
				blaura=Bladex.GetEntity(weapon.Name+"Aura")
				bllight=Bladex.GetEntity(weapon.Name+"Light")
				if not owner.InvRight:
					if blaura:
						AuxFuncs.FadeAndScaleAura(blaura.Name, 250.0, 80.0, 0.01, 1.0, self.FadeTime)
					if bllight:
						AuxFuncs.SpotIntensityVariation(bllight.Name, 0.0, 1.0, self.FadeTime)
				else:
					weapon.Alpha= 1.0
					if blaura:
						blaura.SetAuraParams(80.0, 1.0, 1, 0, 0, 1)
					if bllight:
						bllight.Intensity=1.0
					weapon.RemoveFromWorld()
		

def CreateIceRocket (name,pos):
	rckt=Bladex.CreateEntity(name,"Phurbhu",pos[0],pos[1],pos[2], "Weapon")
	rckt.Orientation=(0.236,0.1047,0.0,0.966)
	rckt.Impulse(0,0,0)
	rckt.Data=PhurbhuX(rckt)
	return rckt.Data

		
############################################################################################################################
############# Flying Heads #################################################################################################
############################################################################################################################

class Skull(ItemTypes.PersistantItemType):
	Name=""
	Speed= 15000.0
	Spin= -0.8
	Axis= (1.0, 0.0, 0.0)
	OwnerName= ""
	C= None
	TimeWeaponStarted= None
	R= None
	Rn= None
	w= None
	RSQdist=None
	WeaponActive= 0
	grasped= 0
	tFinished= None
	Weapon= None
	ThrownBy= None
	Target= None
	Time2Grasp=0.4
	spinsound=None
	WeaponFX=None
	
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Name= me.Name
		#self.Speed= 12000.0
		self.Speed= 15000.0
		self.Spin= -0.8
		self.Axis= (1.0, 0.0, 0.0)
		self.OwnerName= ""
		self.C= None
		self.TimeWeaponStarted= None
		self.R= None
		self.Rn= None
		self.w= None
		self.RSQdist=None
		self.WeaponActive= 0
		self.grasped= 0
		self.tFinished= None
		self.Weapon= None
		self.ThrownBy= None
		self.Target= None
		self.Time2Grasp=0.4
		# Create a looped sound
		SoundName= "..\\..\\Sounds\\vueltas-en-el-aire.wav"
		self.spinsound= Bladex.CreateEntity (me.Name+"LoopSound", "Entity Sound", 0, 0, 0)
		self.spinsound.SetSound (SoundName)
		self.spinsound.MinDistance=5000
		self.spinsound.MaxDistance=30000
		me.Link(self.spinsound)
		
		AddXtraWeaponFX(me.Name, self)

	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		ThrownByName=""
		WeaponName=""
		SpinSoundName=""
		if self.Weapon: WeaponName=self.Weapon.Name
		if self.ThrownBy: ThrownByName=self.ThrownBy.Name
		if self.spinsound: SpinSoundName=self.spinsound.Name
		
		state[1]["Skull"]=(self.Name,
								self.Speed,
								self.Spin,
								self.Axis,
								self.OwnerName,
								self.C,
								self.TimeWeaponStarted,
								self.R,
								self.Rn,
								self.w,
								self.RSQdist,
								self.WeaponActive,
								self.grasped,
								self.tFinished,
								WeaponName,
								ThrownByName,
								self.Target,
								self.Time2Grasp,
								SpinSoundName,
								self.WeaponFX)
		
		return state
	
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["Skull"]
			ThrownByName=""
			WeaponName=""
			SpinSoundName=""
			
			(self.Name,
			self.Speed,
			self.Spin,
			self.Axis,
			self.OwnerName,
			self.C,
			self.TimeWeaponStarted,
			self.R,
			self.Rn,
			self.w,
			self.RSQdist,
			self.WeaponActive,
			self.grasped,
			self.tFinished,
			WeaponName,
			ThrownByName,
			self.Target,
			self.Time2Grasp,
			SpinSoundName,
			self.WeaponFX)= parms
			
			if WeaponName: self.Weapon=Bladex.GetEntity(WeaponName)
			if ThrownByName: self.ThrownBy=Bladex.GetEntity(ThrownByName)
			if SpinSoundName: self.spinsound=Bladex.GetEntity(SpinSoundName)
			
		else:
			self.Name="Unnamed"

	def SetTarget(self, TargetName):
		enemy= Bladex.GetEntity(TargetName)
		print "setting target to "+TargetName
		print enemy
		if enemy:
			self.Target= enemy.GraspPos ("ViewPoint")
			
	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return
		
		if owner=="Player1":
			return

		if weapon.TestHit:
			return

		Actions.RemoveFromInventory (owner, weapon, EventName)
		print("trying to throw2")
		SourcePos= weapon.Position
		
		if self.Target:
			TargetPos= self.Target
			self.Target= None
		else:
			TargetPos= owner.Rel2AbsPoint(0,-30000.0,0.0)

		# target one metre past the enemies head
		offsetx,offsety,offsetz= B3DLib.Scale(B3DLib.Normalize((TargetPos[0]-SourcePos[0], TargetPos[1]-SourcePos[1], TargetPos[2]-SourcePos[2])), 1000.0)
		TargetPos= TargetPos[0]+offsetx, TargetPos[1]+offsety, TargetPos[2]+offsetz

		self.C= (SourcePos[0]+TargetPos[0])*0.5, (SourcePos[1]+TargetPos[1])*0.5, (SourcePos[2]+TargetPos[2])*0.5
		self.TimeWeaponStarted= Bladex.GetTime()
		self.R= SourcePos[0]-self.C[0], SourcePos[1]-self.C[1], SourcePos[2]-self.C[2]
		self.RSQdist= abs(self.R[0]**2.0+self.R[1]**2.0+self.R[2]**2.0)
		moduloR= math.sqrt(self.RSQdist)
		scale= (moduloR/8.0) / math.sqrt(self.R[2]*self.R[2]+self.R[0]*self.R[0])
		self.Rn= -self.R[2]*scale, 0.0, self.R[0]*scale
		self.w = self.Speed / moduloR
		Bladex.SetAfterFrameFunc("DalWeaponMoveWeapon", self.MoveWeapon)
		print("trying to throw3")
		self.WeaponActive= 0
		self.grasped= 0
		self.tFinished= Actions.TWOPI/self.w
		self.Weapon= weapon
		self.ThrownBy= owner  # this pointer may not be valid
		self.Time2Grasp= Bladex.GetAnimationDuration("Dgk_catch")*0.239 # currently 0.239 is the point for the catch
		self.spinsound.PlaySound(-1)
		weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
		
		
	def MoveWeapon (self, time):
		self.Weapon.RemoveFromWorld()
		t= time-self.TimeWeaponStarted
		wt= self.w*t
		cos_wt= math.cos(wt)
		sin_wt= math.sin(wt)
		P= self.R[0]*cos_wt + self.Rn[0]*sin_wt, self.R[1]*cos_wt + self.Rn[1]*sin_wt, self.R[2]*cos_wt + self.Rn[2]*sin_wt
		self.Weapon.Position= P[0]+self.C[0], P[1]+self.C[1], P[2]+self.C[2]
		
		if wt>=Actions.TWOPI:
			owner=Bladex.GetEntity(self.OwnerName)
			if owner:
				inv= owner.GetInventory()
				inv.AddWeapon(self.Weapon.Name)
				if not owner.InvRight:
					inv.LinkRightHand(self.Weapon.Name)
			Bladex.RemoveAfterFrameFunc("DalWeaponMoveWeapon")
		elif wt >= Actions.PI*1.5:
			if self.WeaponActive:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
		elif wt >= Actions.PI and self.WeaponActive:
			owner=Bladex.GetEntity(self.OwnerName)
			if owner and owner.SQDistance2(self.Weapon) < self.RSQdist/2.0:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
		elif wt >= Actions.PI*0.5:
			if not self.WeaponActive:
				self.Weapon.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
				self.WeaponActive= 1
		
		if (not self.grasped) and t+self.Time2Grasp >= self.tFinished:
			self.grasped=1
			self.spinsound.StopSound()
			owner=Bladex.GetEntity(self.OwnerName)
			if owner and owner.Life>0:
				owner.Wuea=Reference.WUEA_ENDED
				owner.InterruptCombat()
				owner.LaunchAnmType("Grab")
			else:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
				self.Weapon.Impulse(0,10,0)
				Bladex.RemoveAfterFrameFunc("DalWeaponMoveWeapon")
		# Angular velocity
		self.Weapon.RotateRel(0.0, 0.0, 0.0 ,self.Axis[0],self.Axis[1],self.Axis[2],self.Spin,1)
		
#############################################################################################################################
######### Magic gem stuff

class PersonGemFX:

	def __init__(self, PersonName, ItemName, TimeEffect):
		pers=Bladex.GetEntity(PersonName)
		item=Bladex.GetEntity(ItemName)
		time=Bladex.GetTime()
		self.PersonName=PersonName
		self.ItemName=ItemName

		AuraParams0=(240, 0.01, 1.0, 0, 1, 1)
		AuraParams1=(50 , 1.0 , 1.0, 0, 1, 1)
		AuraParams2=(40 , 0.6 , 1.0, 0, 1, 1)

		XtraParam0=('Bladex.GetEntity("'+PersonName+'").SelfIlum', 0.0)
		XtraParam1=('Bladex.GetEntity("'+PersonName+'").SelfIlum', 0.6)
		XtraParam2=('Bladex.GetEntity("'+PersonName+'").SelfIlum', 0.1)

		if item.Kind=="Gemaazul":

			AuraGradient0=(2,  0.2, 0.4, 0.8, 1.0, 0.2  ,  0.0, 0.2, 0.8, 0.0, 0.7)
			AuraGradient1=(2,  0.8, 0.9, 1.0, 1.0, 0.2  ,  0.0, 0.2, 0.9, 0.1, 1.0)

			self.Aura=Auras.MakeAura(PersonName, TimeEffect, AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)
			self.Aura.Data.AddEvent (time+1.0,               AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-4.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-3.6,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-3.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.7,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-2.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.0,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.7,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.5,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.2,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.05,   AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.0,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect,        AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)

		elif item.Kind=="Gemapurpura": # this is blue - should be purple

			AuraGradient0=(2,  0.2, 0.4, 0.8, 1.0, 0.2  ,  0.0, 0.2, 0.8, 0.0, 0.7)
			AuraGradient1=(2,  0.8, 0.9, 1.0, 1.0, 0.2  ,  0.0, 0.2, 0.9, 0.1, 1.0)

			self.Aura=Auras.MakeAura(PersonName, TimeEffect, AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)
			self.Aura.Data.AddEvent (time+1.0,               AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-4.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-3.6,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-3.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.7,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-2.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.0,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.7,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.5,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.2,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.05,   AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.0,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect,        AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)

		elif item.Kind=="GemaRoja":

			AuraGradient0=(2,  1.0, 0.4, 0.0, 1.0, 0.2  ,  1.0, 0.0, 0.0, 0.0, 0.7)
			AuraGradient1=(2,  1.0, 0.7, 0.0, 1.0, 0.1  ,  1.0, 0.0, 0.0, 0.0, 1.0)

			self.Aura=Auras.MakeAura(PersonName, TimeEffect, AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)
			self.Aura.Data.AddEvent (time+1.0,               AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-4.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-3.6,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-3.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.7,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-2.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.0,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.7,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.5,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.2,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.05,   AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.0,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect,        AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)

		else: # para item.Kind=="Gema"

			AuraGradient0=(2,  0.0, 1.0, 0.4, 1.0, 0.2  ,  0.0, 0.8, 0.0, 0.0, 0.7)
			AuraGradient1=(2,  0.0, 1.0, 0.7, 1.0, 0.1  ,  0.0, 0.6, 0.0, 0.0, 1.0)

			self.Aura=Auras.MakeAura(PersonName, TimeEffect, AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)
			self.Aura.Data.AddEvent (time+1.0,               AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-4.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-3.6,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-3.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.7,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-2.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-2.0,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.7,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.5,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.3,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.2,    AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.1,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect-1.05,   AuraParams2, (), (), AuraGradient1  ,  1,  XtraParam2)
			self.Aura.Data.AddEvent (time+TimeEffect-1.0,    AuraParams1, (), (), AuraGradient1  ,  1,  XtraParam1)
			self.Aura.Data.AddEvent (time+TimeEffect,        AuraParams0, (), (), AuraGradient0  ,  1,  XtraParam0)


	def __getstate__(self):
		return (1,
				self.PersonName,
				self.ItemName,
				GameStateAux.SaveEntityAux(self.Aura),
			)


	def __setstate__(self,parm):
		if parm[0]==1:
			self.PersonName=parm[1]
			self.ItemName=parm[2]
			self.Aura=GameStateAux.LoadEntityAux(parm[3])
		else:
			print "GemFX.__setstate__() -> Version mismatch"
			self.PersonName=""
			self.ItemName=""
			self.Aura=""



def AddPersonGemFX(PersonName, ItemName, TimeEffect):
	pers=Bladex.GetEntity(PersonName)
	item=Bladex.GetEntity(ItemName)
	if ((not item) or (item.Kind not in ("Gema", "GemaRoja", "Gemaazul", "Gemapurpura"))):
		print "El item especificado no existe no hay efecto definido para este tipo de item!"
		return
	pers.Data.PersonGemFX=PersonGemFX(PersonName, ItemName, TimeEffect)
	
	
class MagicShieldX:
	def __init__(self, me, owner):
		self.ObjId=ObjStore.GetNewId() # Para identificarlo al grabar/guardar
		ObjStore.ObjectsStore[self.ObjId]=self

		self.Name= self.CurrentName= me.Name
		self.OwnerName= owner.Name
		self.AuxFuncsData= None

		me.Weapon= 1
		me.Alpha= 0.0
		me.RasterMode="Read"
		me.RasterMode="AdditiveAlpha"
		me.Solid= 0
		me.CastShadows=0
		me.HitShieldFunc= self.TakeImpact
		inv= owner.GetInventory()
		inv.AddMagicShield(self.Name)

		shield2= Bladex.CreateEntity(self.Name+"Phase2","MagicShield2",0,0,0,"Weapon")
		shield2.Solid= 0
		shield2.SelfIlum=1.0
		shield2.Alpha= 0.0
		shield2.RasterMode="Read"
		shield2.RasterMode="AdditiveAlpha"
		shield2.CastShadows=0

		shield3= Bladex.CreateEntity(self.Name+"Phase3","MagicShield3",0,0,0,"Weapon")
		shield3.Solid= 0
		shield3.SelfIlum=1.0
		shield3.Alpha= 0.0
		shield3.RasterMode="Read"
		shield3.RasterMode="AdditiveAlpha"
		shield3.CastShadows=0

		shieldbr= Bladex.CreateEntity(self.Name+"Breaking","MagicShieldBreak",0,0,0,"Weapon")
		shieldbr.Solid= 0
		shieldbr.SelfIlum=1.0
		shieldbr.Alpha= 0.0
		shieldbr.RasterMode="Read"
		shieldbr.RasterMode="AdditiveAlpha"
		shieldbr.CastShadows=0

		self.shieldlight= Bladex.CreateEntity(self.Name+"ImpactLight", "Entity Spot", 0, 0, 0)
		self.shieldlight.Color=0, 0, 0
		self.shieldlight.Intensity=0.0
		self.shieldlight.Precission=0.01
		self.shieldlight.CastShadows=0
		self.shieldlight.Flick=0
		self.shieldlight.Visible=0

		me.Link(shield2)
		me.Link(shield3)
		me.Link(shieldbr)
		me.Link(self.shieldlight)

		self.AGE=0
		self.ParticleData=[]
		self.PrepareParticleData()

		kind = Bladex.GetEntity(self.Name).Kind
		if Reference.DefaultObjectData.has_key(kind):
			Reference.EntitiesObjectData[self.Name]= BCopy.deepcopy(Reference.DefaultObjectData[kind])
			self.MaxDefence= self.Defence= Reference.EntitiesObjectData[self.Name][2]
			self.IntDefence= self.MaxDefence/3.0
		else:
			print "Error -- Cannot find default object data for "+kind
			self.MaxDefence= self.Defence= 0
			self.IntDefence= 0
			
		# Create a looped sound
		#SoundName= "..\\..\\Sounds\\campo-escudo-barrera1.wav"
		#self.loopsound= Bladex.CreateEntity (me.Name+"LoopSound", "Entity Sound", 0, 0, 0)
		#self.loopsound.SetSound (SoundName)
		#self.loopsound.MinDistance=5000
		#self.loopsound.MaxDistance=10000
		#owner.Link(self.loopsound)
		#self.loopsound.PlaySound(-1)

	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.Name,
				self.OwnerName,
				self.CurrentName,
				self.shieldlight,
				self.AGE,
				self.ParticleData,
				self.MaxDefence,
				self.Defence,
				self.IntDefence,
				self.AuxFuncsData,
				)

	def __setstate__(self,parm):
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Name=parm[2]
			self.OwnerName=parm[3]
			self.CurrentName=parm[4]
			self.shieldlight=parm[5]
			self.AGE=parm[6]
			self.ParticleData=parm[7]
			self.MaxDefence=parm[8]
			self.Defence=parm[9]
			self.IntDefence=parm[10]
			self.AuxFuncsData=parm[11]
		else:
			print "Version mismatch in BreakSector"
			self.ObjId=ObjStore.GetNewId() # Para identificarlo al grabar/guardar
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Name=""
			self.OwnerName=""
			self.CurrentName=""
			self.shieldlight=None
			self.AGE=0
			self.ParticleData=[]
			self.MaxDefence=0
			self.Defence=0
			self.IntDefence=0
			self.loopsound=None
			self.AuxFuncsData= None
		
		if self.Defence>0:
			owner= Bladex.GetEntity(self.OwnerName)
			if owner:
				inv= owner.GetInventory()
				inv.AddMagicShield(self.Name)
				


	def TakeImpact (self,hit_entity,hitting_entity,xhit_point,yhit_point,zhit_point,ximpulse,yimpulse,zimpulse,DamageType):
		hitting_ent=Bladex.GetEntity(hitting_entity)
		try: 
			ball=hitting_ent.Data.DamageEntityName
			if Bladex.GetEntity(ball).Kind=="EsferaOrbital":
				return
		except AttributeError:
			pass
		hitting_ent.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
		hitting_ent.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
		
		hit_ent=Bladex.GetEntity(hit_entity)

		datos_esc=Reference.DefaultObjectData[hit_ent.Kind]
		if datos_esc[0]==Reference.OBJ_SHIELD:
			Reference.DefaultObjectData[hit_ent.Kind][3].Play(xhit_point, yhit_point, zhit_point, 0)
		else:
			if datos_esc[0]==Reference.OBJ_WEAPON:
				if Reference.GiveWeaponFlag(hit_entity)<>Reference.W_FLAG_1H:
					Reference.DefaultObjectData[hit_ent.Kind][5][6].Play(xhit_point, yhit_point, zhit_point, 0)	

		VictimName=self.OwnerName
		AttackerName=hitting_ent.Parent
		pj=Bladex.GetEntity(VictimName)

		#if hitting_ent.Arrow and (hitting_ent.Parent):
		#	pdb.set_trace()
		pj.DamageFunc(VictimName, AttackerName, hitting_entity, DamageType, 0, -1, xhit_point, yhit_point, zhit_point, 1)

		if netgame.GetNetState() == 1:
			netgame.CallEventSound(hit_entity,4)

		# Make arrows stick temporarily
		if hitting_ent.Arrow and (not hitting_ent.Parent):
			hitting_ent.Stop()
			# Check type of damage
			impact= hitting_ent.GraspPos ("Impact")
			centre= hitting_ent.Position
			impact2centre= centre[0]-impact[0], centre[1]-impact[1], centre[2]-impact[2]
			abs_pos= xhit_point+impact2centre[0], yhit_point+impact2centre[1], zhit_point+impact2centre[2]
			rel_pos= hit_ent.Abs2RelPoint(abs_pos[0], abs_pos[1], abs_pos[2])
			# To bring it closer to centre, multiply vector by < 1.0
			hitting_ent.Position= rel_pos[0]*0.8, rel_pos[1], rel_pos[2]*0.8
			hit_ent.Link(hitting_ent)
			sticktime= (1.0)/hitting_ent.Mass
			Bladex.AddScheduledFunc (Bladex.GetTime()+sticktime, Damage.StuckWeaponFall, (hitting_ent.Name, hit_ent.Name), hitting_ent.Name+"_StuckWeaponFall")

		# Make the shield appear in the correct place
		pos= pj.Position
		hit_ent.Position= pos
		hit_ent.Orientation= (1,0,0,0)		
		x= xhit_point-pos[0]; y= yhit_point-pos[1]; z= zhit_point-pos[2]		
		xz_ang= B3DLib.GetXZAngle (x,y,z)
		y_ang = B3DLib.GetYAngle (x,y,z)		
		hit_ent.RotateRel(0,0,0, 0,-1,0, xz_ang)
		hit_ent.RotateRel(0,0,0, 1,0,0, y_ang)


	def PrepareParticleData(self):
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 #va de 0 a 1
				aux=traux**0.5
			else:
				traux=i/25.0 #va de 1 a 0
				aux=traux**2.0
			self.ParticleData.append(255.0*traux)
			self.ParticleData.append(300.0*aux)


	def ChangeParticleColour(self, r, g, b):
		for i in range(30):
			Bladex.SetParticleGVal("MulticolourEnergyDissip", i, r, g, b, self.ParticleData[2*i], self.ParticleData[2*i+1])


	def FadeOut(self, EntityName, r, g, b, nv, rv, pps, fadeTime):
		me= Bladex.GetEntity(EntityName)
		if me:
			self.shieldlight.Color=r, g, b
			self.ChangeParticleColour(r, g, b)
			psimpact=Bladex.CreateEntity(self.Name+"PSImpact"+`self.AGE`, "Entity Particle System Dobj", 0, 0, 0)
			psimpact.ObjectName=self.Name
			psimpact.ParticleType="MulticolourEnergyDissip"
			psimpact.YGravity=0
			psimpact.Velocity=0, 0, 0
			psimpact.NormalVelocity=nv
			psimpact.RandomVelocity=rv
			psimpact.FollowFactor=0.0
			psimpact.PPS=pps
			psimpact.Time2Live=30
			psimpact.DeathTime=Bladex.GetTime()+0.5
			if me.Kind=="MagicShieldBreak":
				shield=Bladex.GetEntity(self.Name)
				currentshield=Bladex.GetEntity(self.CurrentName)
				shield.Unlink(currentshield)
				AuxFuncs.SpotIntensityVariation(self.shieldlight.Name, 6.0, 0.0, fadeTime)
				AuxFuncs.FadeAndScale(me.Name, me.Position, 0.9, 0.0, -1, 1.0, 2.5, -1, fadeTime, 1.0, 1)
			else:
				AuxFuncs.SpotIntensityVariation(self.shieldlight.Name, 4.0, 0.0, fadeTime+0.5)
				AuxFuncs.FadeObject(me.Name, 0.9, 0.0, fadeTime)


	def AbsorbFunc (self, AttackerName, WeaponName, DamagePoints):
		owner=Bladex.GetEntity(self.OwnerName)
		if owner and owner.Life > 0:
			me= Bladex.GetEntity(self.Name)
			self.Defence= max (self.Defence-DamagePoints, 0)
			Reference.EntitiesObjectData[self.Name][2]= self.Defence
			Reference.EntitiesObjectData[self.Name][7]= self.Defence
			#print "Defence remaining "+`self.Defence`

			# play an impact sound
			randsound= whrandom.randint(1,3)
			if randsound==1:	
				SoundName= "..\\..\\Sounds\\M-impacto-berrera-22.wav"
			elif randsound==2:
				SoundName= "..\\..\\Sounds\\M-impacto-barrera-11.wav"
			else:
				SoundName= "..\\..\\Sounds\\M-impacto-barrera-44.wav"

			self.AGE= self.AGE+1
			impsound=Bladex.CreateEntity (me.Name+"ImpactSound_"+`self.AGE`, "Entity Sound", 0, 0, 0)
			impsound.SetSound (SoundName)
			impsound.MinDistance=5000
			impsound.MaxDistance=60000
			me.Link(impsound)
			impsound.PlaySound(0)

			if self.Defence==0:
				self.CurrentName=self.Name+"Breaking"
				r=255
				g=64
				b=16
				nv=60
				rv=20
				pps=600
				fadeTime=1.0
				inv= owner.GetInventory()
				inv.RemoveMagicShield(self.Name)
				owner.Data.MagicShieldDestroyed(self.Name, owner.Name)
				self.MaxDefence= self.Defence= Reference.EntitiesObjectData[self.Name][2]= 0.0
				Bladex.AddScheduledFunc(Bladex.GetTime()+4.0, me.RemoveFromWorld, ())
				Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, me.SubscribeToList, ("Pin",))
				self.loopsound.StopSound()
				print"magic shield gone"
			elif self.Defence<self.IntDefence:
				self.CurrentName=self.Name+"Phase3"
				n=self.Defence/self.IntDefence
				r=255
				g=min(255, max(0, 75+155*n))
				b=0
				nv=4
				rv=2
				pps=100
				fadeTime=0.5
			elif self.Defence<(2.0*self.IntDefence):
				self.CurrentName=self.Name+"Phase2"
				n=(self.Defence-self.IntDefence)/self.IntDefence
				r=min(255, max(0, 255-255*n))
				g=min(255, max(0, 230+25*n))
				b=min(255, max(0, 128*n))
				nv=4
				rv=2
				pps=100
				fadeTime=0.5
			else:
				n=(self.Defence-2.0*self.IntDefence)/self.IntDefence
				r=0
				g=min(255, max(0, 255-127*n))
				b=min(255, max(0, 128+127*n))
				nv=4
				rv=2
				pps=100
				fadeTime=0.5
			self.FadeOut (self.CurrentName, r, g, b, nv, rv, pps, fadeTime)
			
			
			
def MakeMagicShieldX(EntityName, owner):
	shield= Bladex.CreateEntity(EntityName,"MagicShield",0,0,0,"Weapon")
	shield.SelfIlum=1.0
	Sparks.MakeShield(EntityName)	
	shield.Data= MagicShieldX(shield, owner)
	
	return shield
			
			
			
class MagicGem:
	def __init__ (self, me):
		me.UseFunc= self.UseStart
		self.Age_num= 0
		self.UsedBy= "Player1"
		self.UseTime= 15.0
		self.OldFDefense = 0.0
		self.OldFAttack	= 0.0
		self.FDefense = 4.0
		self.FAttack = 4.0
		self.nUses= 1
		
		self.ObjId=ObjStore.GetNewId() # Para identificarlo al grabar/guardar
		ObjStore.ObjectsStore[self.ObjId]=self

	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		# Tiene que devolver c䮯 poder guardar el estado de la clase
		return (1,
					self.ObjId, # De GameStateAux.PersistentObject
					self.Age_num,
					self.UsedBy,
					self.UseTime,
					self.OldFDefense,
					self.OldFAttack,
					self.FDefense,
					self.FAttack,
					self.nUses
				)


	def __setstate__(self,parm):
		# Toma como par⮥tro lo que devuelve __getstate__() y debe recrear la clase
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Age_num=parm[2]
			self.UsedBy=parm[3]
			self.UseTime=parm[4]
			self.OldFDefense=parm[5]
			self.OldFAttack=parm[6]
			self.FDefense=parm[7]
			self.FAttack=parm[8]
			self.nUses=parm[9]

		else:
			print "ItemOfProtection.__setstate__() -> Version mismatch"
			# Valores por si valen para algo.
			self.UsedBy= "Player1"
			self.UseTime= 15.0
			self.OldFDefense = 0.0
			self.OldFAttack	= 0.0
			self.FDefense = 4.0
			self.FAttack = 4.0
			self.nUses= 2
			self.ObjId=ObjStore.GetNewId() # Para identificarlo al grabar/guardar
			ObjStore.ObjectsStore[self.ObjId]=self
		
		
	def UseStart (self, ObjectName, use_from):
		if use_from==Actions.USE_FROM_INV:
			object= Bladex.GetEntity(ObjectName)
			if object: object.UseFunc= 0
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.UseTime, self.UseEnd,(ObjectName,self.UsedBy), ObjectName+"_UseEnd")
			#GenFX.AddPersonItemFX(self.UsedBy, ObjectName, self.UseTime)

	def UseEnd (self,ObjectName, UserName):
		
		self.nUses= self.nUses-1
		if self.nUses<1:
			user= Bladex.GetEntity(UserName)
			if user:
				inv= user.GetInventory()
				if inv:
					inv.RemoveObject(ObjectName)
					object= Bladex.GetEntity(ObjectName)
					if object: object.SubscribeToList("Pin")
					return
		
			# In case of any problems obtaining handles etc...
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.UseTime, self.UseEnd,(ObjectName, UserName), ObjectName+"_UseEnd")
		else:
			object= Bladex.GetEntity(ObjectName)
			if object: object.UseFunc=self.UseStart
			
			
			
class BlueGem (MagicGem):
	def __init__ (self, me):
		MagicGem.__init__(self, me)
		self.UsedBy= "Player1"
		self.UseTime= 20.0
		self.OldFDefense = 0.0
		self.OldFAttack	= 0.0
		self.FDefense = 4.0
		self.FAttack = 4.0
		self.nUses= 5
		

	def UseStart (self, ObjectName, use_from):
		MagicGem.UseStart (self, ObjectName, use_from)
		me=Bladex.GetEntity(self.UsedBy)
		self.OldFAttack = 1.0
		me.Data.FAttack = self.FAttack
		AddPersonGemFX(self.UsedBy, ObjectName, self.UseTime)
		print"power on"

	def UseEnd (self,ObjectName, UserName):
		me=Bladex.GetEntity(UserName)
		me.Data.FAttack = self.OldFAttack
		MagicGem.UseEnd (self, ObjectName, UserName)
		print"power off"
			
			
			
class PurpleGem (MagicGem):
	def __init__ (self, me):
		MagicGem.__init__(self, me)
		#id=Bladex.GetEntity(self.Name)
		self.UsedBy= "Player1"
		self.Age_num=0
		self.UseTime= 1.0
		self.nUses= 1
		

	def UseStart (self, ObjectName, use_from):
		MagicGem.UseStart (self, ObjectName, use_from)
		me=Bladex.GetEntity(self.UsedBy)
		magsh=MakeMagicShieldX(ObjectName+"_MagicShield_"+`self.Age_num`, me)
		self.Age_num=self.Age_num+1
		print"MagicShield on"
		Actions.ReportMsg("Magic Sheild Activated")
		
		

	def UseEnd (self,ObjectName, UserName):
		me=Bladex.GetEntity(UserName)
		MagicGem.UseEnd (self, ObjectName, UserName)
		
		
		
		
class CoronaX (ItemTypes.ItemOfProtection):
	def __init__ (self, me):
		ItemTypes.ItemOfProtection.__init__(self, me)
		self.UsedBy= "Player1"
		self.UseTime= 120.0
		self.Resistances= {}
		self.nUses= 3

	def UseStart (self, ObjectName, use_from):
		ItemTypes.ItemOfProtection.UseStart (self, ObjectName, use_from)
		self.Resistances['Fire']= 0.95
		# Manuel, quieres poner algun efecto magico aqui

	def UseEnd (self,ObjectName, UserName):
		# Manuel, termina el efecto magico aqui
		ItemTypes.ItemOfProtection.UseEnd (self, ObjectName, UserName)
			
#############################################################################################################################

class CKBlade(ItemTypes.PersistantItemType):
	Name=""
	OwnerName=""
	TrailName=""
	LightName=""
	Speed= 18000.0
	Axis=(1.0,0.0,0.0)
	Spin=0.15
	WeaponActive=0
	CreationTime=0.0
	MissileShootSound=""
	MissileWhileSound=""
	MissileImpactSound=""
	AuxFuncsData= None
	sp=None
	tp=None
	v=None
	TimeWeaponStarted=0.0
	Weapon=None
	ThrownBy=None

	def __init__(self, me, ownerName):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon=1
		me.Alpha= 0.0
		me.SelfIlum=1.0
		me.RasterMode="AdditiveAlpha"

		self.Name= me.Name
		self.OwnerName= ownerName
		self.TrailName=self.Name+"_Trail"
		self.LightName=self.Name+"_Light"
		self.Speed= 18000.0
		self.Axis=B3DLib.Normalize((0.05,1.0,0.0))
		self.Spin= 0.15
		self.WeaponActive= 0
		me.InflictHitFunc= self.DalBladeInflictHitFunc
		self.CreationTime= 0.85 #seconds
		#######
		concdisk=Bladex.CreateEntity(me.Name+"_Conc","Entity Particle System Dobj", 0, 0, 0)
		concdisk.ObjectName=me.Name
		concdisk.ParticleType="CKBladeEnergyConc" #################
		concdisk.PPS=800
		concdisk.YGravity=0.0
		concdisk.Friction=0.0
		concdisk.RandomVelocity=-6.0
		concdisk.NormalVelocity=-6.0
		concdisk.Time2Live=30
		concdisk.FollowFactor=0.0
		concdisk.DeathTime=Bladex.GetTime()+1.0

		disklight= Bladex.CreateEntity(self.LightName, "Entity Spot", 0, 0, 0)
		disklight.Color=60, 100, 200
		disklight.Intensity=0.0
		disklight.Precission=0.01
		disklight.CastShadows=0
		disklight.Flick=1
		disklight.Visible=0
		me.Link(disklight)
		AuxFuncs.SpotIntensityVariation(self.LightName, 0.0, 6.0, 1.0)

		concsound=Bladex.CreateEntity(me.Name+"_ConcSound", "Entity Sound", 0, 0, 0)
		concsound.SetSound("..\\..\\Sounds\\energy-ball-conc.wav")
		concsound.MinDistance=5000
		concsound.MaxDistance=30000
		me.Link(concsound)
		concsound.PlaySound(0)

		self.MissileShootSound=""
		self.MissileWhileSound=""
		self.MissileImpactSound=""
		self.SetMissileSound("shoot", "..\\..\\Sounds\\Fireball-Fire.wav")
		self.SetMissileSound("while", "..\\..\\Sounds\\energy-ball.wav")
		self.SetMissileSound("impact", "..\\..\\Sounds\\energy-ball-impact.wav")

		time= Bladex.GetTime()
		Bladex.AddScheduledFunc(time, self.FadeIn, (me.Name,), me.Name+" FadeIn")
		CheckOwnerTime= 4.0
		Bladex.AddScheduledFunc(time+CheckOwnerTime, self.CheckOwner, (me.Name,), me.Name+" CheckOwner")

	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		MissileShootSoundName= ""
		MissileWhileSoundName= ""
		MissileImpactSoundName= ""
		ThrownByName=""
		WeaponName=""
		if self.MissileShootSound: MissileShootSoundName= self.MissileShootSound.Name
		if self.MissileWhileSound: MissileWhileSoundName= self.MissileWhileSound.Name
		if self.MissileImpactSound: MissileImpactSoundName= self.MissileImpactSound.Name
		if self.Weapon: WeaponName=self.Weapon.Name
		if self.ThrownBy: ThrownByName=self.ThrownBy.Name
		
		state[1]["CKBlade"]=(self.Name,
								self.OwnerName,
								self.TrailName,
								self.LightName,
								self.Speed,
								self.Axis,
								self.Spin,
								self.WeaponActive,
								self.CreationTime,
								MissileShootSoundName,
								MissileWhileSoundName,
								MissileImpactSoundName,
								self.AuxFuncsData,
								self.sp,
								self.tp,
								self.v,
								WeaponName,
								ThrownByName
								)

		return state

	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["CKBlade"]
			MissileShootSoundName= ""
			MissileWhileSoundName= ""
			MissileImpactSoundName= ""
			ThrownByName=""
			WeaponName=""
			
			(self.Name,
			self.OwnerName,
			self.TrailName,
			self.LightName,
			self.Speed,
			self.Axis,
			self.Spin,
			self.WeaponActive,
			self.CreationTime,
			MissileShootSoundName,
			MissileWhileSoundName,
			MissileImpactSoundName,
			self.AuxFuncsData,
			self.sp,
			self.tp,
			self.v,
			WeaponName,
			ThrownByName)= parms
			
			if MissileShootSoundName: self.MissileShootSound= Bladex.GetEntity(MissileShootSoundName)
			if MissileWhileSoundName: self.MissileWhileSound= Bladex.GetEntity(MissileWhileSoundName)
			if MissileImpactSoundName: self.MissileImpactSound= Bladex.GetEntity(MissileImpactSoundName)
			if WeaponName: self.Weapon=Bladex.GetEntity(WeaponName)
			if ThrownByName: self.ThrownBy=Bladex.GetEntity(ThrownByName)
			
			me= Bladex.GetEntity(self.Name)
			if me: me.InflictHitFunc= self.DalBladeInflictHitFunc
		else:
			self.Name="Unnamed"

	def SetMissileSound(self, kind, wavfile):
		missile=Bladex.GetEntity(self.Name)
		if missile:
			if kind=="shoot":
				missilesound=Bladex.CreateEntity(self.Name+"_ShootSound", "Entity Sound", 0, 0, 0)
				self.MissileShootSound=missilesound
			elif kind=="while":
				missilesound=Bladex.CreateEntity(self.Name+"_WhileSound", "Entity Sound", 0, 0, 0)
				self.MissileWhileSound=missilesound
			elif kind=="impact":
				missilesound=Bladex.CreateEntity(self.Name+"_ImpactSound", "Entity Sound", 0, 0, 0)
				self.MissileImpactSound=missilesound
			missilesound.SetSound(wavfile)
			missilesound.Volume=1.0
			missilesound.MinDistance=5000
			missilesound.MaxDistance=30000
			missile.Link(missilesound)

	def DestroyMe (self):
		me=Bladex.GetEntity(self.Name)
		if me:
			if self.MissileWhileSound: self.MissileWhileSound.StopSound()
			if self.MissileImpactSound: self.MissileImpactSound.PlaySound(0)
			self.FadeOut(self.Name)
			self.WeaponActive= 0
			self.MissileShootSound=""
			self.MissileWhileSound=""
			self.MissileImpactSound=""

	def CheckOwner (self,EntityName):
		# Has the owner thrown us yet???
		me= Bladex.GetEntity(EntityName)
		if me and not self.WeaponActive:
			self.DestroyMe()

	def FadeIn(self,EntityName):
		me= Bladex.GetEntity(EntityName)
		if me:
			fadeTime=self.CreationTime
			AuxFuncs.FadeObject(me.Name, me.Alpha, 0.9, fadeTime)

	def FadeOut(self,EntityName):
		me= Bladex.GetEntity(EntityName)
		if me:
			fadeTime= 1.0
			trailps=Bladex.GetEntity(self.TrailName)
			if trailps:
				trailps.Friction=0.01
				trailps.NormalVelocity=2.0
				trailps.RandomVelocity=10.0
				trailps.DeathTime=Bladex.GetTime()+0.5
			AuxFuncs.SpotIntensityVariation(self.LightName, 6.0, 0.0, fadeTime)
			AuxFuncs.FadeAndScale(me.Name, me.Position, 0.9, 0.0, -1, 1.0, 3.0, -1, fadeTime, 1.0, 1, (0, 1, 0))
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.9, me.MessageEvent, (Reference.MESSAGE_STOP_WEAPON,0,0))
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.9, me.MessageEvent, (Reference.MESSAGE_STOP_TRAIL,0,0))

	def DalBladeInflictHitFunc(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		print "DalBlade hitting "+VictimName
		pass

	def ThrowReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(EntityName)
		if not weapon:
			return
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner:
			return

		weapon.ExcludeHitFor(owner)

		traildisk=Bladex.CreateEntity(self.TrailName,"Entity Particle System Dobj", 0, 0, 0)
		traildisk.ObjectName=EntityName
		traildisk.ParticleType="CKBladeMagicMissile" #############
		traildisk.PPS=1000
		traildisk.YGravity=0.0
		traildisk.Friction=0.0
		traildisk.RandomVelocity=-1.0
		traildisk.NormalVelocity=-2.0
		traildisk.Time2Live=30
		traildisk.FollowFactor=0.0

		sp= weapon.Position
		if owner.ActiveEnemy:
			enemy= Bladex.GetEntity(owner.ActiveEnemy)
			tp= enemy.GraspPos ("ViewPoint")
		else:
			#print "No enemy to throw DalBlade at!!!"
			tp=owner.Rel2AbsPoint(0,-100000.0,0.0)
		v= B3DLib.Normalize((tp[0]-sp[0], tp[1]-sp[1], tp[2]-sp[2]))
		self.sp= sp
		self.tp= tp
		self.v= v
		self.TimeWeaponStarted= Bladex.GetTime()
		self.WeaponActive= 0
		self.Weapon= weapon
		self.ThrownBy= owner  # this pointer may not be valid
		weapon.TimerFunc=self.MoveWeapon
		weapon.SubscribeToList("Timer60")
		self.MissileShootSound.PlaySound(0)
		self.MissileWhileSound.PlaySound(-1)

	def MoveWeapon (self, ent_name, time):
		t= time-self.TimeWeaponStarted
		ax, ay, az= B3DLib.Scale(self.v,t*self.Speed)
		self.Weapon.Position= self.sp[0]+ax, self.sp[1]+ay, self.sp[2]+az
		if self.WeaponActive:
			if self.Weapon.TestHit:
				self.Weapon.RemoveFromList("Timer60")
				self.Weapon.TimerFunc=""
				self.DestroyMe()
				#print "Has Hit"
		elif t>0.1:
			self.Weapon.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
			self.Weapon.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
			self.WeaponActive= 1
		# Angular velocity
		self.Weapon.RotateRel(0.0, 0.0, 0.0 ,self.Axis[0],self.Axis[1],self.Axis[2],self.Spin,1)



def MakeCKBlade (name, x,y,z, ownerName=""):
	missile= Bladex.CreateEntity(name, "DalBlade", x, y, z)
	missile.Weapon=1
	missile.Data= CKBlade (missile, ownerName)
	return missile
			
			
#############################################################################################################################

class SkelFX:

	def __init__(self, SkelName, prtldata):
		self.ObjId= ObjStore.GetNewId()
		ObjStore.ObjectsStore[self.ObjId]= self
		pers=Bladex.GetEntity(SkelName)
		self.SkelName=SkelName
		self.Vapour=None
		
		if prtldata:
			pt, pps, v, nv, rv, g, fr, ff, t2l=prtldata
			self.Vapour=Bladex.CreateEntity(SkelName+"Vapour", "Entity Particle System Dperson", 0, 0, 0)
			self.Vapour.PersonName=SkelName
			self.Vapour.ParticleType=pt
			self.Vapour.PPS=pps
			self.Vapour.Velocity=v
			self.Vapour.NormalVelocity=nv
			self.Vapour.RandomVelocity=rv
			self.Vapour.YGravity=g
			self.Vapour.Friction=fr
			self.Vapour.FollowFactor=ff
			self.Vapour.Time2Live=t2l
		

	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.SkelName,
				GameStateAux.SaveEntityAux(self.Vapour)
			)


	def __setstate__(self,parm):
		print "SkelFX.__setstate__()",parm
		if parm[0]==1:
			self.ObjId= parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.SkelName=parm[2]
			self.Vapour=GameStateAux.LoadEntityAux(parm[3])
		else:
			print "SkelFX.__setstate__() -> Version mismatch"
			self.SkelName=""
			self.Vapour=""
			self.ObjId= ObjStore.GetNewId()
			ObjStore.ObjectsStore[self.ObjId]=self
			
			
			
			
def AddSkelFX(SkelName, data):
	pers=Bladex.GetEntity(SkelName)
	if not pers:
		print "El skel especificada no existe!"
		return
	if pers.Kind in ("Skeleton","Knight_Zombie","Vamp"):
		prtldata=("GreenVapour", 48, (0.0, -100.0, 0.0), 2.0, 1.0, 0.0, 0.0, 0.0, 64) # (PrtlType, PPS, Vel=(v1, v2, v3), NormalVel, RndVel, YGrav, Friction, FollowFactor, Time2Live)
	else:
		prtldata=()
	data.SkelFX=SkelFX(SkelName, prtldata)	
			
#############################################################################################################################

def AssignData (item):
	exec_string = 'item.Data=' + item.Kind + '(item)'
	exec (exec_string)
		
		
	