import Bladex
import FireCheck



B_PARTICLE_GTYPE_ADD=2


### Definicion de sistemas de particulas

Bladex.AddParticleGType("Flame","FireParticle",B_PARTICLE_GTYPE_ADD,21)

for i in range(21):
	if i>=14:
		aux=1.0/3.0+2*(21.0-i)/21.0 #va de 1/3 a 1
		caux=(21.0-i)/21.0 #va de 0 a 1/3
		saux=3.0*(21.0-i)/21.0 #va de 0 a 1
	elif i>7 and i<14:
		aux=1.0
		caux=1.0/3.0
		saux=1.0
	else:
		aux=1.0-((7.0-i)/7.0) #va de 1 a 0
		caux=1.0/3.0
		saux=1.0-2*((7.0-i)/7.0) #va de 1 a -1
	r=155.0*3.0*caux
	g=155.0*3.0*caux
	b=min(255*(1.0-2.0*caux), 255.0)
	a=100.0*aux
	size=300.0+200.0*saux
	Bladex.SetParticleGVal("Flame",i,r,g,b,a,size)





sonidollamarada1=Bladex.CreateSound('..\\..\\Sounds\\fuego-boo.wav', 'SonidoLlamarada1')
sonidollamarada1.Volume=3.7
sonidollamarada1.MinDistance=1000
sonidollamarada1.MaxDistance=40000
sonidollamarada1.SendNotify=1

sonidollamarada2=Bladex.CreateSound('..\\..\\Sounds\\fuego-ascende.wav', 'SonidoLlamarada2')
sonidollamarada2.Volume=3.7
sonidollamarada2.MinDistance=1000
sonidollamarada2.MaxDistance=40000
sonidollamarada2.SendNotify=1

sonidollamarada3=Bladex.CreateSound('..\\..\\Sounds\\fuego.wav', 'SonidoLlamarada3')
sonidollamarada3.Volume=1
sonidollamarada3.MinDistance=1000
sonidollamarada3.MaxDistance=30000
sonidollamarada3.SendNotify=1



# cave flames only. Lava flames are inaccessible
chllama1=FireCheck.createPSysChecker()
chllama1.precission=2
chllama1.onHitFunc=CaveFlameDamage


