####################################################################################

global ModName
global ModDesc
global ModVersion
global ModAuthor
global ModAuthorInfo
global NewFiles
global RepFiles
global MakeDirs

####################################################################################
# Mod Info
####################################################################################

# Mod Name
ModName          = "FugitiveIII"
# Mod Description
import Language
if Language.Current == 'Spanish':
	ModDesc = (
		"""El malvado nunca duerme."""
		)
else:
	ModDesc = (
		"""The Evil one never sleeps."""
		)


# Mod Version
ModVersion       = "1.0"
# Author name
ModAuthor        = "ProsperoProductions"
# Author info: email, url,...
ModAuthorInfo    = "peterrobinsonfineart@btinternet.com"

####################################################################################
# Mod Data
####################################################################################

# Make new directories

import os

#MakeDirs=[]

if os.path.exists ("../../FugSkins/glof.bmp"):
	
	MakeDirs = ['../FugitiveIII',
	    	    '../FugitiveIII/Spanish',
                    '../FugitiveIII/TS',
                    '../FugitiveIII/TS/Spanish',
                    '../FugitiveIII/pak',
                    '../../FugSkins/F3skins']
else:
	MakeDirs = ['../FugitiveIII',
	    	    '../FugitiveIII/Spanish',
                    '../FugitiveIII/TS',
                    '../FugitiveIII/TS/Spanish',
                    '../FugitiveIII/pak']
	

# New Files added by Mod and destination directory


NewFiles[ 0]      = {'File': 'FugitiveIII/pj.py'                                       ,	'Dest': '../FugitiveIII'}
NewFiles[ 1]      = {'File': 'FugitiveIII/objs.py'                                     ,	'Dest': '../FugitiveIII'}
NewFiles[ 2]      = {'File': 'FugitiveIII/ActorsInit.py'                               ,        'Dest': '../FugitiveIII'}
NewFiles[ 3]      = {'File': 'FugitiveIII/def_class.py'                                , 	'Dest': '../FugitiveIII'}
NewFiles[ 4]      = {'File': 'FugitiveIII/DefFuncs.py'                                 ,	'Dest': '../FugitiveIII'}
NewFiles[ 5]      = {'File': 'FugitiveIII/agua.py'                                     ,        'Dest': '../FugitiveIII'}
NewFiles[ 6]      = {'File': 'FugitiveIII/Wyvern.py'                                   ,	'Dest': '../FugitiveIII'}
NewFiles[ 7]      = {'File': 'FugitiveIII/cfg.py'                                      ,	'Dest': '../FugitiveIII'}
NewFiles[ 8]      = {'File': 'FugitiveIII/TextureMaterials.py'                         ,	'Dest': '../FugitiveIII'}
NewFiles[ 9]      = {'File': 'FugitiveIII/TScustom.py'                                 ,	'Dest': '../FugitiveIII'}
NewFiles[10]      = {'File': 'FugitiveIII/TriggSect.py'                                ,        'Dest': '../FugitiveIII'}
NewFiles[11]      = {'File': 'FugitiveIII/Tr.py'                                       ,	'Dest': '../FugitiveIII'}
NewFiles[12]      = {'File': 'FugitiveIII/weapons.py'                                  ,	'Dest': '../FugitiveIII'}
NewFiles[13]      = {'File': 'FugitiveIII/wind.py'                                     ,        'Dest': '../FugitiveIII'}
NewFiles[14]      = {'File': 'FugitiveIII/sonidos.py'                                  ,        'Dest': '../FugitiveIII'}
NewFiles[15]      = {'File': 'FugitiveIII/rocks.py'                                    ,	'Dest': '../FugitiveIII'}
NewFiles[16]      = {'File': 'FugitiveIII/lavapools.py'                                ,        'Dest': '../FugitiveIII'}
NewFiles[17]      = {'File': 'FugitiveIII/positions.py'                                ,        'Dest': '../FugitiveIII'}
NewFiles[18]      = {'File': 'FugitiveIII/puertas.py'                                  ,        'Dest': '../FugitiveIII'}
NewFiles[19]      = {'File': 'FugitiveIII/enemy.py'                                    ,        'Dest': '../FugitiveIII'}
NewFiles[20]      = {'File': 'FugitiveIII/F3Types.py'                                  ,	'Dest': '../FugitiveIII'}
NewFiles[21]      = {'File': 'FugitiveIII/MusicEvents.py'                              ,	'Dest': '../FugitiveIII'}
NewFiles[22]      = {'File': 'FugitiveIII/inn.py'                                      ,	'Dest': '../FugitiveIII'}
NewFiles[23]      = {'File': 'FugitiveIII/innD.py'                                     ,	'Dest': '../FugitiveIII'}
NewFiles[24]      = {'File': 'FugitiveIII/food.py'                                     ,	'Dest': '../FugitiveIII'}
NewFiles[25]      = {'File': 'FugitiveIII/fires.py'                                    ,	'Dest': '../FugitiveIII'}
NewFiles[26]      = {'File': 'FugitiveIII/flame.py'                                    ,	'Dest': '../FugitiveIII'}
NewFiles[27]      = {'File': 'FugitiveIII/DefAnims.py'                                 ,	'Dest': '../FugitiveIII'}
NewFiles[28]      = {'File': 'FugitiveIII/cuervos.py'                                  ,	'Dest': '../FugitiveIII'}
NewFiles[29]      = {'File': 'FugitiveIII/corpses.py'                                  ,	'Dest': '../FugitiveIII'}
NewFiles[30]      = {'File': 'FugitiveIII/collapse.py'                                 ,	'Dest': '../FugitiveIII'}
NewFiles[31]      = {'File': 'FugitiveIII/cascada.py'                                  ,	'Dest': '../FugitiveIII'}
NewFiles[32]      = {'File': 'FugitiveIII/cam.py'                                      ,	'Dest': '../FugitiveIII'}
NewFiles[33]      = {'File': 'FugitiveIII/Ghosect.py'                                  ,	'Dest': '../FugitiveIII'}
NewFiles[34]      = {'File': 'FugitiveIII/zomgen.py'                                   ,	'Dest': '../FugitiveIII'}
NewFiles[35]      = {'File': 'FugitiveIII/chime.wav'                                   ,	'Dest': '../FugitiveIII'}
NewFiles[36]      = {'File': 'FugitiveIII/mistymountains.mmp'                          ,	'Dest': '../FugitiveIII'}
NewFiles[37]      = {'File': 'FugitiveIII/mountains.mmp'                               ,	'Dest': '../FugitiveIII'}
NewFiles[38]      = {'File': 'FugitiveIII/nuobjs.mmp'                                  ,	'Dest': '../FugitiveIII'}
NewFiles[39]      = {'File': 'FugitiveIII/f3wps.mmp'                                   ,	'Dest': '../FugitiveIII'}
NewFiles[40]      = {'File': 'FugitiveIII/statw.mmp'                                   ,	'Dest': '../FugitiveIII'}
NewFiles[41]      = {'File': 'FugitiveIII/mountains.bw'                                ,	'Dest': '../FugitiveIII'}
NewFiles[42]      = {'File': 'FugitiveIII/demon.sf'                                    ,	'Dest': '../FugitiveIII'}
NewFiles[43]      = {'File': 'FugitiveIII/Wyv.sf'                                      ,	'Dest': '../FugitiveIII'}
NewFiles[44]      = {'File': 'FugitiveIII/mino.sf'                                     ,	'Dest': '../FugitiveIII'}
NewFiles[45]      = {'File': 'FugitiveIII/roccy.sf'                                    ,	'Dest': '../FugitiveIII'}
NewFiles[46]      = {'File': 'FugitiveIII/rocks.sf'                                    ,	'Dest': '../FugitiveIII'}
NewFiles[47]      = {'File': 'FugitiveIII/sndFX.sf'                                    ,	'Dest': '../FugitiveIII'}
NewFiles[48]      = {'File': 'FugitiveIII/Mountains.lvl'                               ,	'Dest': '../FugitiveIII'}
NewFiles[49]      = {'File': 'FugitiveIII/Blade_progress.jpg'                          ,	'Dest': '../FugitiveIII'}
NewFiles[50]      = {'File': 'FugitiveIII/Blade_progress2.jpg'                         ,	'Dest': '../FugitiveIII'}
NewFiles[51]      = {'File': 'FugitiveIII/Spanish/Blade_progress.jpg'                  ,	'Dest': '../FugitiveIII/Spanish'}
NewFiles[52]      = {'File': 'FugitiveIII/Spanish/Blade_progress2.jpg'                 ,	'Dest': '../FugitiveIII/Spanish'}
NewFiles[53]      = {'File': 'FugitiveIII/FIIIMenu/FIIIMenu.py'                        ,        'Dest': '../../Scripts'}
NewFiles[54]      = {'File': 'FugitiveIII/FIIIMenu/FIIIMenu.bmp'                       ,        'Dest': '../FugitiveIII'}
NewFiles[55]      = {'File': 'FugitiveIII/TS/Dialogue.py'                              ,	'Dest': '../FugitiveIII/TS'}
NewFiles[56]      = {'File': 'FugitiveIII/TS/Spanish/Dialogue.py'                      ,	'Dest': '../FugitiveIII/TS/Spanish'}
NewFiles[57]      = {'File': 'FugitiveIII/F3widgets.py'                                ,	'Dest': '../../Scripts'}
NewFiles[58]      = {'File': 'FugitiveIII/QuiverTypes.py'                              ,	'Dest': '../FugitiveIII'}

if os.path.exists ("../../FugSkins/glof.bmp"):
	NewFiles[59]      = {'File': 'FugitiveIII/F3skins/dkskl.mmp'                   ,	'Dest': '../../FugSkins/F3skins'}
	NewFiles[60]      = {'File': 'FugitiveIII/F3skins/greendemon.mmp'              ,	'Dest': '../../FugSkins/F3skins'}
        NewFiles[61]      = {'File': 'FugitiveIII/F3skins/grwyv.mmp'                   ,	'Dest': '../../FugSkins/F3skins'}
	NewFiles[62]      = {'File': 'FugitiveIII/F3skins/henry.mmp'                   ,	'Dest': '../../FugSkins/F3skins'}   
        NewFiles[63]      = {'File': 'FugitiveIII/F3skins/sprite.mmp'                  ,	'Dest': '../../FugSkins/F3skins'}
	NewFiles[64]      = {'File': 'FugitiveIII/F3skins/stoneknt.mmp'                ,	'Dest': '../../FugSkins/F3skins'}
	NewFiles[65]      = {'File': 'FugitiveIII/F3skins/yeti.mmp'                    ,	'Dest': '../../FugSkins/F3skins'}
	NewFiles[66]      = {'File': 'FugitiveIII/F3skins/fsprite.bmp'                 ,	'Dest': '../../FugSkins/F3skins'}
	NewFiles[67]      = {'File': 'FugitiveIII/F3skins/henry.bmp'                   ,	'Dest': '../../FugSkins/F3skins'}
	NewFiles[68]      = {'File': 'FugitiveIII/F3skins/spook1.bmp'                  ,	'Dest': '../../FugSkins/F3skins'}
	NewFiles[69]      = {'File': 'FugitiveIII/F3skins/spook2.bmp'                  ,	'Dest': '../../FugSkins/F3skins'}