import Bladex
import Breakings                                                               
import Torchs
import AuxFuncs
import darfuncs

#######################################################################################################################
####### Custom PSys

Bladex.AddParticleGType("GreySmoke","SmokeParticle",B_PARTICLE_GTYPE_BLEND,50)

for i in range(50):
	aux=(50.0-i)/50.0
	r=110
	g=110
	b=110
	a=250
	size=1000.0*math.sqrt(1.0-aux)
	Bladex.SetParticleGVal("GreySmoke",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("ChimneySmoke","SmokeParticle",B_PARTICLE_GTYPE_BLEND,50)

for i in range(50):
	aux=(50.0-i)/50.0
	r=70
	g=70
	b=70
	a=250
	size=1000.0*math.sqrt(1.0-aux)
	Bladex.SetParticleGVal("ChimneySmoke",i,r,g,b,a,size)
	
		

Bladex.AddParticleGType("GreenVapour","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)
	
for i in range(64):
	aux=(64.0-i)/64.0
	r=120
	g=160
	b=100
	a=255.0*math.sqrt(1.0-aux)
	size=40.0+aux*200.0
	Bladex.SetParticleGVal("GreenVapour",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("GreenSmoke1","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)

for i in range(68):
	r=120.0
	g=150.0
	b=100.0
	a    = 255*i/64.0
	size = 128*(64-i)/64.0+16
	

	Bladex.SetParticleGVal("GreenSmoke1",i,r,g,b,a,size)
	
	
	
################## fire for burning rocks


Bladex.AddParticleGType("LavaFire","FireParticle",Reference.B_PARTICLE_GTYPE_ADD,31)

for i in range(32):
	if(i>16):
		aux=0.0
	else:
		aux=(16.0-i)/16.0
	r=255
	g=min(100.0*(1.0-aux*aux)+35,255.0)
	b=min( 50.0*(1.0-aux),255.0)
	a=min(200.0*(1.0-aux),255.0)
	size=130.0+math.sqrt(1.0-aux)*110.0
	Bladex.SetParticleGVal("LavaFire",i,r,g,b,a,size)
	
############### DoorDust

Bladex.AddParticleGType("DoorDust","SmokeParticle",B_PARTICLE_GTYPE_BLEND,40)

for i in range(40):
	if i>20:
		traux=0.0
	else:
		traux=((20.0-i)/20.0)**0.5
	aux=((40.0-i)/40.0)**0.5
	r=255
	g=255
	b=255
	a=60.0*(1.0-traux)
	size=7.0+aux*700.0
	Bladex.SetParticleGVal("DoorDust",i,r,g,b,a,size)
	
	
################ Little Demon 

Bladex.AddParticleGType("GreenDeath","GenericParticle",Reference.B_PARTICLE_GTYPE_ADD,80)

for i in range(80):
	if i>60:
		traux=1-((i-60.0)/20.0) #va de 0 a 1
	elif i<20:
		traux=i/20.0 #va de 1 a 0
	else:
		traux=1.0
	r=80
	g=200
	b=100
	a=255.0*traux
	size=20.0
	Bladex.SetParticleGVal("GreenDeath",i,r,g,b,a,size)
		
		
Bladex.AddParticleGType("GreenDeathBall","FireParticle",Reference.B_PARTICLE_GTYPE_ADD,120)

for i in range(120):
	if i<40:
		traux=i/40.0 #va de 1 a 0
	else:
		traux=1.0
	r=40
	g=150
	b=45
	a=255.0*traux
	size=400.0
	Bladex.SetParticleGVal("GreenDeathBall",i,r,g,b,a,size)
	
	
######## Golem Death Smoke

Bladex.AddParticleGType("GolemDeathCloud","SmokePart3",Reference.B_PARTICLE_GTYPE_MUL,64)
	
	
for i in range(64):
	aux=(64.0-i)/64
	r=128
	g=100
	b=100
	a=0
	if aux < 0.5:
		size = aux*512
	else:
		size = (1-aux)*512
	Bladex.SetParticleGVal("GolemDeathCloud",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("PurpleIncense","SmokeParticle",B_PARTICLE_GTYPE_BLEND,50)

for i in range(50):
	aux=(50.0-i)/50.0
	r=180
	g=30
	b=180
	a=250
	size=1000.0*math.sqrt(1.0-aux)
	Bladex.SetParticleGVal("PurpleIncense",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("PurpleVapour","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)
	
for i in range(64):
	aux=(64.0-i)/64.0
	r=160
	g=30
	b=230
	a=255.0*math.sqrt(1.0-aux)
	size=40.0+aux*200.0
	Bladex.SetParticleGVal("PurpleVapour",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("PurpleFlame","FireParticle",B_PARTICLE_GTYPE_ADD,21)

for i in range(21):
	if i>=14:
		aux=1.0/3.0+2*(21.0-i)/21.0 #va de 1/3 a 1
		caux=(21.0-i)/21.0 #va de 0 a 1/3
		saux=3.0*(21.0-i)/21.0 #va de 0 a 1
	elif i>7 and i<14:
		aux=1.0
		caux=1.0/3.0
		saux=1.0
	else:
		aux=1.0-((7.0-i)/7.0) #va de 1 a 0
		caux=1.0/3.0
		saux=1.0-2*((7.0-i)/7.0) #va de 1 a -1
	r=150.0*3.0*caux
	g=20.0*3.0*caux
	b=150.0*3.0*caux
	a=240.0*aux
	size=300.0+200.0*saux
	Bladex.SetParticleGVal("PurpleFlame",i,r,g,b,a,size)
	
	
######## little stars

Bladex.AddParticleGType("BlueEstrellitas","Estrellita",B_PARTICLE_GTYPE_BLEND,64)
for i in range(64):
	r=128.0
	g=128.0
	b=255.0
	a   = (i*255)/64
	size= (64-i)*2
	Bladex.SetParticleGVal("BlueEstrellitas",i,r,g,b,a,size)
	
	
#########

Bladex.AddParticleGType("YellowEnergyDissip","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,60)

for i in range(60):
	if i>50:
		traux=(60.0-i)/10.0 #va de 0 a 1
	else:
		traux=i/50.0 #va de 1 a 0
	r=240
	g=180
	b=20
	a=255.0*traux
	size=20.0+250.0*(1-(1-i/60.0)**0.5)
	Bladex.SetParticleGVal("YellowEnergyDissip",i,r,g,b,a,size)
	
########

Bladex.AddParticleGType("FuegoBlueInvocacion","FireParticle",Reference.B_PARTICLE_GTYPE_ADD,120)

for i in range(120):
	if i<40:
		traux=i/40.0 #va de 1 a 0
	else:
		traux=1.0
	r=180
	g=60
	b=255
	a=180.0*traux
	size=400.0
	Bladex.SetParticleGVal("FuegoBlueInvocacion",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("EnergiaBlue","GenericParticle",B_PARTICLE_GTYPE_ADD,80)

for i in range(80):
	if i>60:
		traux=1-((i-60.0)/20.0) #va de 0 a 1
	elif i<20:
		traux=i/20.0 #va de 1 a 0
	else:
		traux=1.0
	r=180
	g=100
	b=180
	a=255.0*traux
	size=20.0
	Bladex.SetParticleGVal("EnergiaBlue",i,r,g,b,a,size)
	
	
	
Bladex.ReadBitMap("..\\..\\Data\\SmokePrtl3.bmp","SmokePart3")
Bladex.AddParticleGType("BlueDeathCloud","SmokePart3",Reference.B_PARTICLE_GTYPE_MUL,16)


for i in range(16):
	aux=(16.0-i)/16
	r=180
	g=200
	b=255
	a=0
	if aux < 0.5:
		size = aux*512
	else:
		size = (1-aux)*512
	Bladex.SetParticleGVal("BlueDeathCloud",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("DemonFlame","FireParticle",Reference.B_PARTICLE_GTYPE_ADD,21)

for i in range(21):
	if i>=14:
		aux=1.0/3.0+2*(21.0-i)/21.0 #va de 1/3 a 1
		caux=(21.0-i)/21.0 #va de 0 a 1/3
		saux=3.0*(21.0-i)/21.0 #va de 0 a 1
	elif i>7 and i<14:
		aux=1.0
		caux=1.0/3.0
		saux=1.0
	else:
		aux=1.0-((7.0-i)/7.0) #va de 1 a 0
		caux=1.0/3.0
		saux=1.0-2*((7.0-i)/7.0) #va de 1 a -1
	r=55.0*3.0*caux
	g=155.0*3.0*caux
	b=min(255*(1.0-2.0*caux), 255.0)
	a=100.0*aux
	size=300.0+200.0*saux
	Bladex.SetParticleGVal("DemonFlame",i,r,g,b,a,size)
	
	
	
	
Bladex.AddParticleGType("DemonLargeFire","FireParticle",Reference.B_PARTICLE_GTYPE_ADD,31)

for i in range(32):
	if(i>16):
		aux=0.0
	else:
		aux=(16.0-i)/16.0
	g=255
	r=min(300.0*(1.0-aux*aux)+35,255.0)
	b=min(255.0*(1.0-aux)+20,255.0) 
	a=min(200.0*(1.0-aux),255.0)
	size=130.0+math.sqrt(1.0-aux)*110.0
	Bladex.SetParticleGVal("DemonLargeFire",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("LittleCKMagicMissile","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,20)

for i in range(20):
	if i>17:
		traux=(20.0-i)/3.0 #va de 0 a 1
		aux=traux**0.5
	else:
		traux=i/17.0 #va de 1 a 0
		aux=traux**2.0
	b=255
	g=100.0*(i/20.0)
	r=20+80*(1.0-i/20.0)
	a=200.0*traux
	size=250.0*aux
	Bladex.SetParticleGVal("LittleCKMagicMissile",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("DarkSpell","GenericParticle2",B_PARTICLE_GTYPE_ADD,60)

for i in range(60):
	if i>50:
		traux=(60.0-i)/50.0 
	else:
		traux=i/10.0 
	r=120
	g=30
	b=120
	a=255.0*traux
	size=225.0*(1-i/60.0)**2.0
	Bladex.SetParticleGVal("DarkSpell",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("SpiritSmoke","SmokeParticle",B_PARTICLE_GTYPE_ADD,64)

for i in range(64):
	if i>50:
		traux=(i-50.0)/14.0 #va de 1 a 0
	else:
		traux=(50.0-i)/50.0 #va de 0 a 1
	aux=(64.0-i)/64.0
	r=120
	g=20 
	b=120 
	a=75.0*(1.0-traux)
	size=400.0+aux*400.0
	Bladex.SetParticleGVal("SpiritSmoke",i,r,g,b,a,size)

	
darksoul=Bladex.CreateEntity("DarkSoul","Entity Spot", 0,10000,0)       
darksoul.Color=60,10,60
darksoul.Intensity=0.1
darksoul.Precission=0.1
darksoul.CastShadows=0
darksoul.Flick=0   
darksoul.GlowTexture="GlowSpirit"
	
	
	
Bladex.AddParticleGType("CKBladeEnergyConc","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>5:
		traux=1.0
		saux=((30.0-i)/25.0)**2.0 #va de 0 a 1
	else:
		saux=traux=i/5.0 #va de 1 a 0
	b=255
	g=100.0*(1.0-i/30.0)
	r=20+80*(i/30.0)
	a=200.0*traux
	size=300.0*saux
	Bladex.SetParticleGVal("CKBladeEnergyConc",i,r,g,b,a,size)
	
	
	


Bladex.AddParticleGType("CKBladeMagicMissile","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 #va de 0 a 1
		aux=traux**0.5
	else:
		traux=i/25.0 #va de 1 a 0
		aux=traux**2.0
	b=255
	g=100.0*(i/30.0)
	r=20+80*(1.0-i/30.0)
	a=200.0*traux
	size=400.0*aux
	Bladex.SetParticleGVal("CKBladeMagicMissile",i,r,g,b,a,size)
	
##########################################################################################################################
	
	
smoke1=Bladex.CreateEntity("Smoke1", "Entity Particle System D1", 0,-1000,-10582)
smoke1.ParticleType="GreySmoke"
smoke1.YGravity=-3000.0
smoke1.Friction=0.12
smoke1.PPS=30  
smoke1.Velocity= -1000.0, -500.0, 0.0
smoke1.Time2Live=50
smoke1.RandomVelocity=40

############ central fireD
smoke2=Bladex.CreateEntity("Smoke2", "Entity Particle System D1", 590500,17800,-68500)
smoke2.ParticleType="GreySmoke"
smoke2.YGravity=-3000.0
smoke2.Friction=0.12
smoke2.PPS=30  
smoke2.Velocity= -1000.0, -800.0, 0.0
smoke2.Time2Live=50
smoke2.RandomVelocity=40

############ central chimney
smoke3=Bladex.CreateEntity("Smoke3", "Entity Particle System D1", 590500,0,-68500)
smoke3.ParticleType="ChimneySmoke"
smoke3.YGravity=-3000.0
smoke3.Friction=0.12
smoke3.PPS=30  
smoke3.Velocity= -1500.0, -500.0, 0.0
smoke3.Time2Live=50
smoke3.RandomVelocity=40

############ end chimney
smoke4=Bladex.CreateEntity("Smoke4", "Entity Particle System D1", 564500,1000,-77000)
smoke4.ParticleType="ChimneySmoke"
smoke4.YGravity=-3000.0
smoke4.Friction=0.12
smoke4.PPS=30  
smoke4.Velocity= -1000.0, -500.0, 0.0
smoke4.Time2Live=50
smoke4.RandomVelocity=40

############# main fireplace

smoke5=Bladex.CreateEntity("Smoke5", "Entity Particle System D1", 564500,17500,-77000)
smoke5.ParticleType="GreySmoke"
smoke5.YGravity=-3000.0
smoke5.Friction=0.12
smoke5.PPS=30  
smoke5.Velocity= -1000.0, -600.0, 0.0
smoke5.Time2Live=50
smoke5.RandomVelocity=40

############# funeral pyre

smoke6=Bladex.CreateEntity("Smoke6", "Entity Particle System D1", 609799,18200,24823)
smoke6.ParticleType="GreySmoke"
smoke6.YGravity=-3000.0
smoke6.Friction=0.12
smoke6.PPS=30  
smoke6.Velocity= -2000.0, -800.0, 0.0
smoke6.Time2Live=50
smoke6.RandomVelocity=40

############# incense

smoke7=Bladex.CreateEntity("Smoke7", "Entity Particle System D1", -3550,-10000,-42923)
smoke7.ParticleType="PurpleIncense"
smoke7.YGravity=-3000.0
smoke7.Friction=0.12
smoke7.PPS=20  
smoke7.Velocity= 0.0, -500.0, 0.0
smoke7.Time2Live=50
smoke7.RandomVelocity=20

###########################################################################################################################

pflame=Bladex.CreateEntity("AltarFlame", "Entity Particle System D1", -3550,-8600,-42923)
pflame.ParticleType="PurpleFlame"
pflame.YGravity=-4000.0
pflame.Friction=0.12
pflame.PPS=200
pflame.Velocity=0.0, -2000.0, 0.0
pflame.RandomVelocity=45.0
pflame.Time2Live=14

###########################################################################################################################

object_kind="Cajon"
particle_type="LargeFire"
min_d=600.0
max_d=400.0
flame_h=4.0
flame_s=1.0
speed=1.5
time2live=1000000			

Bladex.AddCombustionDataFor(object_kind, particle_type, min_d, max_d, flame_h, flame_s, speed, time2live)


o=Bladex.CreateEntity("Hoguera_2178","Hoguera",143.132650546,-765.616966,-10582.8616482, Reference.ObjType("Hoguera"))
o.Scale=1.8
o.Orientation=(0.621196806431,0.652725219727,0.335515409708,-0.274761229753)
o.FiresIntensity=[ 46.0 ]
o.Lights = [(8.0, 0.03125, (245, 126, 58))]


o=Bladex.CreateEntity("Hoguera_2179","Hoguera",943.132650546,-765.616966,-10982.8616482, Reference.ObjType("Hoguera"))
o.Scale=1.8
o.Orientation=(0.442824423313,0.406571418047,0.607133626938,-0.519610404968)
o.FiresIntensity=[ 46.0 ]
o.Lights = [(8.0, 0.03125, (245, 126, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

#### dwarf camp
o=Bladex.CreateEntity("Hoguera_2814","Hoguera",320376.674001,13733.3405116,41653.4170923, Reference.ObjType("Hoguera"))
o.Scale=1.2
o.Orientation=(0.695771932602,0.708418428898,0.110857516527,-0.041897315532)
o.FiresIntensity=[ 2.0 ]
o.Lights = [(1.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

#################caves

firelite1=Bladex.CreateEntity("FireLite1","Entity Spot", 257166,-1907,-21133)
firelite1.Color=245,126,28
firelite1.Intensity=30
firelite1.Precission=0.125
firelite1.CastShadows=0
firelite1.Visible=0
firelite1.Flick=1 
firelite1.SizeFactor = 0.2
firelite1.AngVel=0.1
firelite1.GlowTexture="SunFlare"


firebox2=Bladex.CreateEntity("Cajon_2425","Cajon",256797.513389,-814,-22229.8318882, Reference.ObjType("Cajon"))
firebox2.Scale=1.2
firebox2.Orientation=(0.853553414345,-0.35355335474,-0.146446600556,0.353553414345)
firebox2.CatchOnFire (0,0,0)
firebox2.CastShadows=0
SetRadialFireDamageObjectX(firebox2.Name,3000)


firebox3=Bladex.CreateEntity("Cajon_2426","Cajon",256042,-704,-20676, Reference.ObjType("Cajon"))
firebox3.Scale=0.8
firebox3.Orientation=(0.598963141441,0.393985927105,0.395733505487,-0.573945343494)
firebox3.CatchOnFire (0,0,0)
firebox3.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2423","Antorchaenpared",265929,-2088,-72382, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(9.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2427","Antorchaenpared",238515,1810,-113237, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.560985565186,0.560985565186,-0.430459290743,0.430459320545)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(7.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2422","Antorchaenpared",217566.732553,2044.34830965,271.608457972, Reference.ObjType("Antorchaenpared"))
o.Scale=1.2
o.Orientation=(0.544139146805,0.470915913582,0.518283009529,-0.462096840143)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(8.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Hoguera_2424","Hoguera",255881.221913,-261.087715521,-21410.5337362, Reference.ObjType("Hoguera"))
o.Scale=1.6
o.Orientation=(0.705687761307,0.70706820488,0.0353049710393,0.0285109151155)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Hoguera_2882","Hoguera",265918.922357,4592.90255479,-115707.233644, Reference.ObjType("Hoguera"))
o.Scale=1.6
o.Orientation=(0.695894837379,0.711103081703,-0.0566036328673,0.0828180164099)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(8.0, 0.550000011921, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Hoguera_2883","Hoguera",238350.045922,-416.407051478,-54834.0728561, Reference.ObjType("Hoguera"))
o.Scale=1.6
o.Orientation=(0.692132890224,0.714125037193,-0.0601436533034,0.0857919827104)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(28.0, 0.550000011921, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Hoguera_2884","Hoguera",227747.666704,-253.541247894,-90283.2759789, Reference.ObjType("Hoguera"))
o.Scale=1.6
o.Orientation=(0.697989523411,0.715039253235,-0.0254427082837,0.0297013837844)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(18.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2927","Antorchaenpared",236605.002725,-2298.59719547,-70926.1528128, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.643723666668,0.75168633461,-0.136865049601,0.0430755540729)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(13.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2923","Antorchaenpared",274454.435491,-884.001788035,-89821.9271159, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.0353197902441,0.256235986948,-0.621836423874,0.739198982716)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(12.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2924","Antorchaenpared",258988.979297,1938.29608567,-98921.1570999, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.530330002308,0.659739673138,0.306186258793,-0.435595691204)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(13.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2925","Antorchaenpared",254962.831736,2691.39799063,-118523.84603, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.560985565186,0.560985565186,-0.430459290743,0.430459320545)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(15.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2878","Antorchaenpared",250822.794626,-2493.46906858,-76592.1921477, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.7902084589,0.611906290054,0.0238879490644,-0.0238879732788)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2890","Antorchaenpared",255904.46606,-2307.00939827,-87599.7803321, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.560985505581,0.560985565186,-0.430459290743,0.430459350348)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(8.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Hoguera_2891","Hoguera",261201.183367,-166.726462087,-75073.3297895, Reference.ObjType("Hoguera"))
o.Scale=1.4
o.Orientation=(0.0118972491473,-0.0148614365608,-0.698551058769,0.715306937695)
o.FiresIntensity=[ 2.0 ]
o.Lights = [(22.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Farol2_2917","Farol2",234742.909005,-2453.83853655,-79460.4165331, Reference.ObjType("Farol2"))
o.Scale=1.0
o.Orientation=(0.707061946392,0.704649567604,-0.0429698377848,0.0410612002015)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(8.0, 0.03125, (155, 196, 128))]


o=Bladex.CreateEntity("Antorchaenpared_2931","Antorchaenpared",252519.333361,-2525.41010903,-41346.4097099, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.757544636726,0.645290493965,-0.0416075885296,0.0894155427814)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(11.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2947","Antorchaenpared",254200,-2807,-50784, Reference.ObjType("Antorchaenpared"))
o.Scale=1.4
o.Orientation=(0.685,0.7255,-0.06,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(7.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_2959","Antorchaenpared",255591,-1806,-66681, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.541,0.5,-0.5,0.454)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (245, 156, 58))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

################# main stairs

o=Bladex.CreateEntity("Antorchaenpared_3038","Antorchaenpared",15169,7678,-71299, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.2973,0.501,-0.4227,0.694)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_3039","Antorchaenpared",14564,7873,-52405, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.6123,0.6123,0.25,-0.433)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

############# dugeons

o=Bladex.CreateEntity("Farol2_3173","Farol2",55961,17731,-24250, Reference.ObjType("Farol2"))
o.Scale=1.0
o.Orientation=(0.27,0.27,0.653,-0.653)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(8.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("LamparaKongo_3075","LamparaKongo",86535.2212318,16603.0699719,-39429.6631032, Reference.ObjType("LamparaKongo"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,1.4018183947e-007,0.707106769085,-0.707106769085)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(14.0, 0.03125, (245, 126, 28))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

o=Bladex.CreateEntity("LamparaKongo_3076","LamparaKongo",79411.4986892,16715.4454427,-39437.9365067, Reference.ObjType("LamparaKongo"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,1.05367119474e-008,0.707,-0.707)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(14.0, 0.03125, (245, 126, 28))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaKongo_3077","LamparaKongo",72011,16706,-39396, Reference.ObjType("LamparaKongo"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,2.74763834796e-007,0.707,-0.707)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(14.0, 0.03125, (245, 126, 28))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaKongo_3078","LamparaKongo",64745.7763289,16709.7157741,-39391.3371945, Reference.ObjType("LamparaKongo"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,1.27967922481e-007,0.70710670948,-0.70710682869)
o.FiresIntensity=[ 3.0 ]
o.Lights = [(14.0, 0.03125, (245, 126, 28))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaKongo_3079","LamparaKongo",57454,16714,-39424, Reference.ObjType("LamparaKongo"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,1.65597427326e-007,0.707,-0.707)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(14.0, 0.03125, (245, 126, 28))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaKongo_3081","LamparaKongo",43178,16692,-39442, Reference.ObjType("LamparaKongo"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,1.65597427326e-007,0.707,-0.707)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(14.0, 0.03125, (245, 126, 28))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorcha2_3103","Antorcha2",93927,15273,-17370, Reference.ObjType("Antorcha2"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.56,0.56,-0.43,0.43)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(7.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorcha2_3136","Antorcha2",93908,15269,-23061, Reference.ObjType("Antorcha2"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(7.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaKongo_3144","LamparaKongo",100661,16625,-30104, Reference.ObjType("LamparaKongo"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(14.0, 0.03125, (245, 126, 28))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaKongo_3145","LamparaKongo",100700,16673,-35935, Reference.ObjType("LamparaKongo"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(14.0, 0.03125, (245, 126, 28))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Carburo_4765","Carburo",56259,27728,-21160, Reference.ObjType("Carburo"))
o.Scale=1.0
o.Orientation=(0.273,0.261,0.677,-0.631)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(4.0, 0.03125, (155, 126, 198))]


o=Bladex.CreateEntity("Carburo_4942","Carburo",41773,21548,-19579, Reference.ObjType("Carburo"))
o.Scale=1.0
o.Orientation=(0.43,0.43,-0.56,0.56)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(6.0, 0.03125, (155, 126, 198))]


o=Bladex.CreateEntity("Farol2_4943","Farol2",50169,17711,-22266, Reference.ObjType("Farol2"))
o.Scale=1.0
o.Orientation=(0.7428,0.666,0.0,0.066)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]


############################################################################################################################
###### Throne Room

o=Bladex.CreateEntity("Lampcolg_3147","Lampcolg",-45125.2687674,8277.07745404,-29945.5384688, Reference.ObjType("Lampcolg"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(8.0, 0.03125, (155, 126, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Lampcolg_3150","Lampcolg",-53391.7914726,8322.42718846,-29929.5548059, Reference.ObjType("Lampcolg"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(8.0, 0.03125, (155, 126, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Candelabro_3153","Candelabro",-58922.1922356,9943.88537966,-34773.2587585, Reference.ObjType("Candelabro"))
o.Scale=1.0
o.Orientation=(0.270598113537,0.270598173141,0.653281509876,-0.653281390667)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Candelabro_3154","Candelabro",-39958.3252676,9943.53321319,-34770.0377275, Reference.ObjType("Candelabro"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Lamparaegipto_3167","Lamparaegipto",-39498.2949786,9297.66704445,-69218.1265963, Reference.ObjType("Lamparaegipto"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(7.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lamparaegipto_3168","Lamparaegipto",-58606.3601714,9304.97066147,-68911.5882793, Reference.ObjType("Lamparaegipto"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(3.0, 0.03125, (255, 196, 128))]

############ side chamber (atrium)

o=Bladex.CreateEntity("Lampared_3209","Lampared",31705,7623,-55308, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(7.0, 0.5, (205, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaNegra_3210","LamparaNegra",-32660.1326089,8364.8366052,-18560.8301364, Reference.ObjType("LamparaNegra"))
o.Scale=1.0
o.Orientation=(0.0268022231758,0.0205656867474,0.703578233719,-0.709814310074)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("LamparaNegra_3211","LamparaNegra",-41746.7597831,8272.71721003,-18458.7107895, Reference.ObjType("LamparaNegra"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Candil2_3213","Candil2",-28929.8164471,6525.24572867,-6813.00655486, Reference.ObjType("Candil2"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Antorcha2_3215","Antorcha2",-31387.5458253,4678.00354994,-25541.4126524, Reference.ObjType("Antorcha2"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]

############

o=Bladex.CreateEntity("LamparaMiguelSinPeana_3219","LamparaMiguelSinPeana",-60235.3279915,9882.95716872,-21184.6790739, Reference.ObjType("LamparaMiguelSinPeana"))
o.Scale=1.0
o.Orientation=(0.701057434082,0.701057374477,0.0922959372401,-0.0922959446907)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("LamparaMiguelSinPeana_3220","LamparaMiguelSinPeana",-60319.3804548,9866.23940815,-31953.1150291, Reference.ObjType("LamparaMiguelSinPeana"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]

##
o=Bladex.CreateEntity("Lamparatecho_3221","Lamparatecho",-49175,3003,-52500, Reference.ObjType("Lamparatecho"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(20.0, 0.55, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Varilla_3222","Varilla",-49975,2403,-52500, "Weapon")
o.Scale=2.6
o.Orientation=(1.0,0.0,0.0,0.0)

##
o=Bladex.CreateEntity("Lamparatecho_32212","Lamparatecho",-49175,3003,-61000, Reference.ObjType("Lamparatecho"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(20.0, 0.55, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Varilla_32222","Varilla",-49975,2403,-61000, "Weapon")
o.Scale=2.6
o.Orientation=(1.0,0.0,0.0,0.0)


statlite1=Bladex.CreateEntity("StatLite1","Entity Spot", -48861,3989,-67663)
statlite1.Color=145,186,128
statlite1.Intensity=11
statlite1.Precission=0.125
statlite1.CastShadows=0
statlite1.Visible=0
statlite1.Flick=0 
statlite1.SizeFactor = 0.2
statlite1.AngVel=0.1
statlite1.GlowTexture="SunFlare"


####################################################
##### Main building

o=Bladex.CreateEntity("Antorcha2_3247","Antorcha2",-8354.26505603,-2758.48133576,-13431.2201524, Reference.ObjType("Antorcha2"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.430459409952,0.43045938015,-0.560985445976,0.560985505581)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(9.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Antorcha2_3248","Antorcha2",10889.908811,4253.10033481,-31486.901906, Reference.ObjType("Antorcha2"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(8.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Antorcha2_3249","Antorcha2",-8615.4738868,4256.84218227,-31393.5203736, Reference.ObjType("Antorcha2"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.430459320545,0.430459409952,-0.560985505581,0.560985505581)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Farol2_3251","Farol2",3464.58132907,5863.21052756,-21592.5360949, Reference.ObjType("Farol2"))
o.Scale=1.0
o.Orientation=(0.612372457981,0.612372457981,-0.35355335474,0.353553384542)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(7.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Cirio_3267","Cirio",9232.93633844,-1290.52423783,-1649.99859489, Reference.ObjType("Cirio"))
o.Scale=0.8
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Lampared_3271","Lampared",-2719.01227361,-1796.38459543,-21347.9840798, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.560985505581,0.560985565186,-0.430459290743,0.430459290743)
o.FiresIntensity=[ 8.0 ]
o.Lights = [(7.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

#######

o=Bladex.CreateEntity("Lampared_3272","Lampared",4194.15610958,-1834.93961084,-21285.7663213, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(6.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Lampared_3284","Lampared",-3658,-1791,-37263, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(8.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Lampared_3285","Lampared",5136.34933299,-1791.32555847,-37419.6615209, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(7.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Farol2_3288","Farol2",4142,-924,-46670, Reference.ObjType("Farol2"))
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(7.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorchaenpared_3292","Antorchaenpared",6651.17502613,2213.00409541,-53485.3311343, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 11.0 ]
o.Lights = [(3.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Antorchaenpared_3293","Antorchaenpared",4488.44489669,9213.04138847,-52924.3469039, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.0,2.74864845551e-007,0.608761429787,-0.793353319168)
o.FiresIntensity=[ 9.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Antorchaenpared_3294","Antorchaenpared",-6737.18382742,15500,-55682.1631441, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
Torchs.SetUsable(o.Name,9,8,-1)

##########

o=Bladex.CreateEntity("Antorcha_3296","Antorcha",-2583.89505516,16933.2426706,-56347.1648034, "Weapon")
o.Scale=1.0
o.Orientation=(0.799818992615,-0.0240209028125,-0.594413101673,0.0799098014832)
o.FiresIntensity=[ 46.0 ]
o.Lights = [(0.0, 0.07, (245, 126, 28))]
Torchs.SetUsable("Antorcha_3296",7,5,180)


o=Bladex.CreateEntity("Antorcha_3297","Antorcha",-1807.04094549,16941.5947365,-56337.0173572, "Weapon")
o.Scale=1.0
o.Orientation=(0.849852979183,0.11138471961,-0.139991685748,-0.495727479458)
o.FiresIntensity=[ 46.0 ]
o.Lights = [(0.0, 0.07, (245, 126, 28))]
Torchs.SetUsable("Antorcha_3297",7,5,180)

############

o=Bladex.CreateEntity("Lamparaegipto_3300","Lamparaegipto",-3203.22692039,-8604.75143203,-22023.3060589, Reference.ObjType("Lamparaegipto"))
o.Scale=1.0
o.Orientation=(0.701057314873,0.701057434082,0.0922959297895,-0.0922959297895)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(6.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Lamparaegipto_3301","Lamparaegipto",4746.77307961,-8604.75143203,-22023.3060589, Reference.ObjType("Lamparaegipto"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(6.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaNegra_3303","LamparaNegra",-8216.81714075,-10241.4270129,-34665.3530804, Reference.ObjType("LamparaNegra"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaNegra_3304","LamparaNegra",9749.56770316,-10097.6029853,-34996.2570081, Reference.ObjType("LamparaNegra"))
o.Scale=1.0
o.Orientation=(0.0,1.46570172888e-007,0.70710682869,-0.707106769085)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

#####

o=Bladex.CreateEntity("Antorcha2_3309","Antorcha2",18864.5934774,-8144.22555525,-63221.08414, Reference.ObjType("Antorcha2"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(5.0, 0.03125, (255, 196, 128))]
#lo=AuxFuncs.GetSpot(o) 
#lo.CastShadows=0


o=Bladex.CreateEntity("Antorcha2_3310","Antorcha2",18885.936035,-8090.67828544,-68924.7619234, Reference.ObjType("Antorcha2"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.43,0.43,-0.56,0.56)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(7.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Cirio_3311","Cirio",33125.6443467,-6295.52385357,-67226.1753871, Reference.ObjType("Cirio"))
o.Scale=1.0
o.Orientation=(0.70491528511,0.709109544754,-0.0105634108186,0.0121051557362)
o.FiresIntensity=[ 10.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]

############

o=Bladex.CreateEntity("Candelpeque_3313","Candelpeque",22415,-6320,-64397, Reference.ObjType("Candelpeque"))
o.Scale=1.0
o.Orientation=(0.18301281333,0.183012783527,-0.683012664318,0.683012664318)
o.FiresIntensity=[ 14.0 ]
o.Lights = [(1.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Lampared_3325","Lampared",12273,2619,-25282, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 3.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lampared_3326","Lampared",36919.5268405,1699.6849494,-22787.3664457, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.70710682869,0.707106769085,5.65593438751e-008,-1.26314310123e-008)
o.FiresIntensity=[ 3.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lampared_3327","Lampared",-3732.7353609,-1997.3812729,-29479.3068419, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 19.0 ]
o.Lights = [(3.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lampared_3328","Lampared",10191.7801394,-1983.65756,-43438.4244503, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(6.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lampared_3329","Lampared",-8685.30796585,-1897.04716291,-43659.2132927, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.560985565186,0.560985565186,-0.430459290743,0.430459290743)
o.FiresIntensity=[ 16.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("LamparaMiguelSinPeana_3336","LamparaMiguelSinPeana",882.678746792,-8856.29781588,-16723.6063667, Reference.ObjType("LamparaMiguelSinPeana"))
o.Scale=1.6
o.Orientation=(0.710756123066,0.700805842876,0.051408752799,-0.0324651151896)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(6.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Lampared_3355","Lampared",12295,1293,-35399, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lampared_3356","Lampared",12927.6304109,-1353.99622712,-56795.0467975, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.270598143339,0.270598113537,-0.653281450272,0.653281450272)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lampared_3357","Lampared",27721.7979715,-341.796601959,-57199.76998, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,1.73616115262e-007,0.707106769085,-0.70710682869)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lampared_3369","Lampared",12300,-10889,-34418, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lampared_3370","Lampared",15957,-9630,-53628, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Brasero1_4721","Brasero1",-3550,-8286,-42923, Reference.ObjType("Brasero1"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 46.0 ]
o.Lights = [(5.0, 0.03125, (155, 66, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

##### swimming pool

o=Bladex.CreateEntity("LamparaNegra_3375","LamparaNegra",18789,-3285,-20483, Reference.ObjType("LamparaNegra"))
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

o=Bladex.CreateEntity("LamparaNegra_3376","LamparaNegra",26946,-3285,-20483, Reference.ObjType("LamparaNegra"))
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaNegra_3377","LamparaNegra",35208,-3285,-20483, Reference.ObjType("LamparaNegra"))
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Brasero1_3378","Brasero1",42440,-80,-18957, Reference.ObjType("Brasero1"))
o.Scale=1.0
o.Orientation=(0.6955960989,0.69472694397,0.1300598979,-0.128782719374)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(8.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Brasero1_3379","Brasero1",42392.005897,-79.7088862257,-9276.77303125, Reference.ObjType("Brasero1"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(8.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Lampared_3381","Lampared",31299,-1973,-4994, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0922960788012,0.0922960340977,-0.701057374477,0.701057374477)
o.FiresIntensity=[ 8.0 ]
o.Lights = [(6.0, 0.03125, (155, 196, 128))]


o=Bladex.CreateEntity("Lampared_3382","Lampared",22940,-1976,-4964, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,0.0,0.70710682869,-0.707106769085)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(7.0, 0.03125, (155, 196, 128))]


o=Bladex.CreateEntity("Lampared_3421","Lampared",37762,918,-54341, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.270597994328,0.270598143339,0.653281509876,-0.653281450272)
o.FiresIntensity=[ 6.0 ]
o.Lights = [(8.0, 0.03125, (255, 196, 128))]

###### side door to throne room

o=Bladex.CreateEntity("Lampared_3388","Lampared",-34696.382332,8459.26959001,-42692.8005191, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,2.62890438307e-007,0.70710682869,-0.70710670948)
o.FiresIntensity=[ 10.0 ]
o.Lights = [(3.0, 0.03125, (255, 196, 128))]

######## to catacombs

o=Bladex.CreateEntity("Palangana_3392","Palangana",5724.61775986,17851.3431934,-22621.7926447, Reference.ObjType("Palangana"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(12.0, 0.03125, (245, 126, 28))]
Torchs.SetUsable(o.Name,7,6,-1)


o=Bladex.CreateEntity("Palangana_3545","Palangana",20890.8689752,16853.8215736,-20093.9125885, Reference.ObjType("Palangana"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 8.0 ]
o.Lights = [(8.0, 0.03125, (245, 126, 28))]
Torchs.SetUsable(o.Name,7,6,-1)

##### stairs to vaults

o=Bladex.CreateEntity("Antorchaenpared_3405","Antorchaenpared",-8732.17618361,7462.49017155,-10607.8547844, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.653281450272,0.653281509876,0.270598053932,-0.270598053932)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]

######## near lift gate

o=Bladex.CreateEntity("Antorchaenpared_3395","Antorchaenpared",11071.1024798,16718.1765147,-32199.1859309, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.560985505581,0.560985565186,0.430459320545,-0.430459350348)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(6.0, 0.03125, (255, 196, 128))]
Torchs.SetUsable(o.Name,9,8,-1)
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorcha_3398","Antorcha",5357,17932,-20642, "Weapon")
o.Scale=1.0
o.Orientation=(0.857626199722,0.132000789046,-0.190267264843,-0.459185659885)
o.FiresIntensity=[ 46.0 ]
o.Lights = [(0.0, 0.07, (245, 126, 28))]
Torchs.SetUsable("Antorcha_3398",7,6,180)
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("Antorcha_3399","Antorcha",5707,17932,-19392, "Weapon")
o.Scale=1.0
o.Orientation=(0.430459320545,0.560985505581,-0.560985505581,-0.430459409952)
o.FiresIntensity=[ 46.0 ]
o.Lights = [(0.0, 0.07, (245, 126, 28))]
Torchs.SetUsable("Antorcha_3399",7,6,180)
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

########## golems den

o=Bladex.CreateEntity("Farol2_3426","Farol2",82567,11727,-41482, Reference.ObjType("Farol2"))
o.Scale=1.0
o.Orientation=(0.683012723923,0.683012723923,-0.18301269412,0.183012709022)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]

############ Shrine

o=Bladex.CreateEntity("LamparaMiguelSinPeana_3434","LamparaMiguelSinPeana",-49245,-9005,-36767, Reference.ObjType("LamparaMiguelSinPeana"))
o.Scale=1.0
o.Orientation=(0.697830617428,0.715962290764,0.00755725707859,-0.0193213671446)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaMiguelSinPeana_3435","LamparaMiguelSinPeana",-49244,-9010,-48011, Reference.ObjType("LamparaMiguelSinPeana"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


o=Bladex.CreateEntity("LamparaMiguelSinPeana_3436","LamparaMiguelSinPeana",-54861.9142631,-9011.1775544,-42438.8689758, Reference.ObjType("LamparaMiguelSinPeana"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,-2.12116901821e-006,2.1211751573e-006)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

######################

o=Bladex.CreateEntity("Lampared_3486","Lampared",-62690,-5270,-25572, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.56,0.56,-0.43,0.43)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Lampared_3487","Lampared",-46074,-9170,-26054, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
o.FiresIntensity=[ 4.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]

####### nu pos for golem stair lamp

o=Bladex.CreateEntity("Lampared_3517","Lampared",96703,14206,-47232, Reference.ObjType("Lampared"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0922959521413,0.0922961086035,0.701057434082,-0.701057314873)
o.FiresIntensity=[ 8.0 ]
o.Lights = [(5.0, 0.03125, (245, 126, 28))]

###

o=Bladex.CreateEntity("CandilAurelio_3501","CandilAurelio",-40039,830,-25441, Reference.ObjType("CandilAurelio"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 10.0 ]
o.Lights = [(6.0, 0.03125, (225, 196, 158))]
#lo=AuxFuncs.GetSpot(o) 
#lo.CastShadows=0


o=Bladex.CreateEntity("CandilAurelio_3502","CandilAurelio",-35039,830,-25441, Reference.ObjType("CandilAurelio"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 10.0 ]
o.Lights = [(6.0, 0.03125, (225, 196, 158))]
#lo=AuxFuncs.GetSpot(o) 
#lo.CastShadows=0

#### Bridge Door

o=Bladex.CreateEntity("LamparaMiguel_4713","LamparaMiguel",-8920,-6635,-46769, Reference.ObjType("LamparaMiguel"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.270,0.270,-0.653,0.653)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(3.0, 0.03125, (245, 66, 148))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

##### 

o=Bladex.CreateEntity("Antorchaenpared_3508","Antorchaenpared",18442,-10769,16219, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.512046933174,0.482962936163,-0.52086609602,0.482962936163)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]

######

o=Bladex.CreateEntity("Antorchaenpared_3515","Antorchaenpared",8249,10213,-12195, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.0922959595919,0.0922960937023,0.701057434082,-0.701057314873)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]

###### underground passage

o=Bladex.CreateEntity("Antorchaenpared_3646","Antorchaenpared",56905,3282,-7989, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]

o=Bladex.CreateEntity("Antorchaenpared_3646x","Antorchaenpared",56905,3282,-7989+150000, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Palangana_3659","Palangana",58776,11852,-7131, Reference.ObjType("Palangana"))
o.Scale=1.0
o.Orientation=(0.68,0.725,0.055,-0.041)
o.FiresIntensity=[ 29 ]
o.Lights=[ (0.000000,0.060000,(255,173,83)) ]
Torchs.SetUsable(o.Name,3,3,-1)


o=Bladex.CreateEntity("Palangana_3660","Palangana",77327,16352,3899, Reference.ObjType("Palangana"))
o.Scale=1.0
o.Orientation=(0.707,0.707,0.0,0.0)
o.FiresIntensity=[ 29 ]
o.Lights=[ (0.000000,0.060000,(255,173,83)) ]
Torchs.SetUsable(o.Name,3,3,-1)


o=Bladex.CreateEntity("Palangana_3668","Palangana",64208,24348,-10024, Reference.ObjType("Palangana"))
o.Scale=1.0
o.Orientation=(0.7,0.7,0.05,-0.06)
o.FiresIntensity=[ 29 ]
o.Lights=[ (0.000000,0.060000,(255,173,83)) ]
Torchs.SetUsable(o.Name,3,3,-1)


o=Bladex.CreateEntity("Palangana_3669","Palangana",70995,27847,-27787, Reference.ObjType("Palangana"))
o.Scale=1.0
o.Orientation=(0.707,0.707,0.0,0.0)
o.FiresIntensity=[ 29 ]
o.Lights=[ (0.0,0.06,(255,173,83)) ]
Torchs.SetUsable(o.Name,3,3,-1)


o=Bladex.CreateEntity("Palangana_4871","Palangana",56070,10850,13344, Reference.ObjType("Palangana"))
o.Scale=1.0
o.Orientation=(0.707,0.707,0.0,0.0)
o.FiresIntensity=[ 29 ]
o.Lights = [(0.0, 0.06, (255, 173, 83))]
Torchs.SetUsable(o.Name,2,6,-1)

o=Bladex.CreateEntity("Antorcha_3670","Antorcha",99976,31828,-43435, "Weapon")
o.Scale=1.0
o.Orientation=(0.92,0.38,0.0,0.0)
o.FiresIntensity=[ 3 ]
o.Lights = [(8.0, 0.03125, (245, 126, 28))]
Torchs.SetUsable(o.Name,8,0.09,-1)


o=Bladex.CreateEntity("Antorcha_3671","Antorcha",107253,32865,-34034, "Weapon")
o.Scale=1.0
o.Orientation=(0.518,0.568,-0.335,0.544)
o.FiresIntensity=[ 3 ]
o.Lights = [(8.0, 0.03125, (245, 126, 28))]
Torchs.SetUsable(o.Name,10,0.09,-1)


o=Bladex.CreateEntity("Palangana_3676","Palangana",80833,16357,-129, Reference.ObjType("Palangana"))
o.Scale=1.0
o.Orientation=(0.707,0.707,0.0,0.0)
o.FiresIntensity=[ 29 ]
o.Lights=[ (0.000000,0.060000,(255,173,83)) ]
Torchs.SetUsable(o.Name,3,3,-1)


o=Bladex.CreateEntity("Antorchaenpared_4963","Antorchaenpared",1974,5791,6295, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 8.0 ]
o.Lights = [(6.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Antorchaenpared_4964","Antorchaenpared",2149,5811,-8992, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(7.0, 0.03125, (255, 196, 128))]


##################

o=Bladex.CreateEntity("Antorchaenpared_3685","Antorchaenpared",-38297,-15667,-74561, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.557,0.523,-0.466,0.445)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Antorchaenpared_3681","Antorchaenpared",-10281,3332,-68963, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(10.0, 0.03125, (255, 196, 128))]


o=Bladex.CreateEntity("Antorchaenpared_4646","Antorchaenpared",27255.3131041,8692.00625757,8403.16607739, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.70710682869,0.707106769085,-1.26314310123e-008,-5.65593438751e-008)
o.FiresIntensity=[ 10.0 ]
o.Lights = [(4.0, 0.03125, (245, 126, 28))]

##### stove

o=Bladex.CreateEntity("Hoguera_4731","Hoguera",-3622.69877547,-70.4083644011,-18842.502858, Reference.ObjType("Hoguera"))
o.Scale=1.2
o.Orientation=(0.701057374477,0.701057374477,-0.0922959521413,-0.0922959521413)
o.FiresIntensity=[ 8.0 ]
o.Lights = [(4.0, 0.03125, (255, 126, 28))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0


##### guardpost

o=Bladex.CreateEntity("Antorchaenpared_4876","Antorchaenpared",24132,7028,-116624, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.629,0.4829,0.37,-0.4829)
o.FiresIntensity=[ 7.0 ]
o.Lights = [(8.0, 0.03125, (245, 126, 48))]


###### secret tunnel

o=Bladex.CreateEntity("Antorchaenpared_4744","Antorchaenpared",43846,-1256,3236, Reference.ObjType("Antorchaenpared"))
o.Scale=1.0
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 8.0 ]
o.Lights = [(4.0, 0.03125, (255, 196, 128))]
Torchs.SetUsable(o.Name,3,3,-1)

o=Bladex.CreateEntity("Antorcha_4748","Antorcha",43249.9781754,436.303418653,3631.6251675, "Weapon")
o.Scale=1.0
o.Orientation=(0.999607682228,0.0274846944958,-0.00529231410474,-0.00101571076084)
o.FiresIntensity=[ 46.0 ]
o.Lights = [(0.0, 0.03125, (255, 196, 128))]
Torchs.SetUsable("Antorcha_4748",6,7,100)


o=Bladex.CreateEntity("Palangana_4792","Palangana",25865,7457,-14353, Reference.ObjType("Palangana"))
o.Scale=1.0
o.Orientation=(0.707,0.707,0.0,0.0)
o.FiresIntensity=[ 5.0 ]
o.Lights = [(8.0, 0.03125, (245, 126, 28))]

##### cellar

cluz1= Bladex.CreateEntity("Cellarlite1","Entity Spot",11000,14000,-39500)
cluz1.Color       = 70,90,60
cluz1.Intensity   = 7
cluz1.Precission  = 0.1
cluz1.CastShadows = 0
cluz1.Visible     = 0

cluz2= Bladex.CreateEntity("Cellarlite2","Entity Spot",11000,14000,-43500)
cluz2.Color       = 70,90,60
cluz2.Intensity   = 7
cluz2.Precission  = 0.1
cluz2.CastShadows = 0
cluz2.Visible     = 0



dlite1= Bladex.CreateEntity("DemonBacklite","Entity Spot",130500,39000,22000)
dlite1.Color       = 85,38,6
dlite1.Intensity   = 0.01
dlite1.Precission  = 0.5
dlite1.CastShadows = 1
dlite1.Visible     = 0


###### watchtower

o=Bladex.CreateEntity("LamparaKongo_4970","LamparaKongo",347081,4212,274240, Reference.ObjType("LamparaKongo"))
o.Static=1
o.Scale=1.4
o.Orientation=(0.5,0.5,-0.5,0.5)
o.FiresIntensity=[ 0.0 ]
o.Lights = [(8.0, 0.03125, (255, 196, 128))]
lo=AuxFuncs.GetSpot(o) 
lo.CastShadows=0

