import Doors
import Levers
import Locks
import Objects
import Sounds
import Sparks
import Button
import AuxFuncs
import darfuncs
import Stars



sdoor1d=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-madera-deslizando.wav","StoneDesliz")
sdoor1d.MaxDistance=20000
sdoor1d.MinDistance=1000
sdoor1d.Volume=1

sdoor1g=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-madera-golpe.wav","StoneGolpe")
sdoor1g.MaxDistance=20000
sdoor1g.MinDistance=2000
sdoor1g.Volume=1

sdoor2d=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-piedra-deslizando.wav","StoneDesliz2")
sdoor2d.MaxDistance=20000
sdoor2d.MinDistance=1000
sdoor2d.Volume=1

sdoor2g=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-madera-golpe2.wav","StoneGolpe2")
sdoor2g.MaxDistance=20000
sdoor2g.MinDistance=2000
sdoor2g.Volume=1

sdoor3d=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-metal .wav","StoneDesliz3")
sdoor3d.MaxDistance=30000
sdoor3d.MinDistance=1000
sdoor3d.Volume=1

sdoor4g=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-piedra-golpe2.wav","StoneGolpe2")
sdoor4g.MaxDistance=20000
sdoor4g.MinDistance=2000
sdoor4g.Volume=1

deslizrasanexo=Sounds.CreateEntitySound("..\\..\\Sounds\\rastrillo.wav", "DeslizRasanexo")
deslizrasanexo.Volume=0.8
deslizrasanexo.MinDistance=5000
deslizrasanexo.MaxDistance=20000

golperasanexo=Sounds.CreateEntitySound("..\\..\\Sounds\\golpe-metal-mediano.wav", "GolpeRasanexo")
golperasanexo.Volume=0.8
golperasanexo.MinDistance=5000
golperasanexo.MaxDistance=20000

elevtravelsnd=Sounds.CreateEntitySound("..\\..\\Sounds\\drawbridge-loop.wav", "ElevatorTravelSnd")
elevtravelsnd.Volume=0.8
elevtravelsnd.MinDistance=5000
elevtravelsnd.MaxDistance=20000

elevarrivesnd=Sounds.CreateEntitySound("..\\..\\Sounds\\dist-dungeon-door2.wav", "ElevatorArriveSnd")
elevarrivesnd.Volume=0.8
elevarrivesnd.MinDistance=5000
elevarrivesnd.MaxDistance=20000
########################################################################################################################
##lever orientation
#0.5,0.5,0.5,-0.5########west#####
#0.5,0.5,-0.5,0.5#######east######*
#0.0,0.0,0.5,-0.5#######north######*
#0.707,0.707,0.0,0.0#####south#######


########################################################################################################################
win1=Doors.CreateDoor("Win1", (-6250,-2000,3875), (0,1,0), 0, 4000, Doors.CLOSED)

win2=Doors.CreateDoor("Win2", (-1000,-2000,3875), (0,1,0), 0, 4000, Doors.CLOSED)

win3=Doors.CreateDoor("Win3", (2000,-2000,3875), (0,1,0), 0, 4000, Doors.CLOSED)

win4=Doors.CreateDoor("Win4", (7250,-2000,3875), (0,1,0), 0, 4000, Doors.CLOSED)


######## Throne room

win5=Doors.CreateDoor("Win5", (-66125,0,-48500), (0,1,0), 0, 12000, Doors.CLOSED)

win6=Doors.CreateDoor("Win6", (-66125,0,-56750), (0,1,0), 0, 12000, Doors.CLOSED)

win7=Doors.CreateDoor("Win7", (-66125,0,-65500), (0,1,0), 0, 12000, Doors.CLOSED)


####### Skylights
windhite=-19625

win8=Doors.CreateDoor("Win8", (20000,windhite,-31000), (0,0,1), 0, 5750, Doors.CLOSED)

win9=Doors.CreateDoor("Win9", (25000,windhite,-31000), (0,0,1), 0, 5750, Doors.CLOSED)

win10=Doors.CreateDoor("Win10", (30000,windhite,-31000), (0,0,1), 0, 5750, Doors.CLOSED)

win11=Doors.CreateDoor("Win11", (20000,windhite,-37000), (0,0,1), 0, 5750, Doors.CLOSED)

win12=Doors.CreateDoor("Win12", (25000,windhite,-37000), (0,0,1), 0, 5750, Doors.CLOSED)

win13=Doors.CreateDoor("Win13", (30000,windhite,-37000), (0,0,1), 0, 5750, Doors.CLOSED)

win14=Doors.CreateDoor("Win14", (20000,windhite,-43000), (0,0,1), 0, 5750, Doors.CLOSED)

win15=Doors.CreateDoor("Win15", (25000,windhite,-43000), (0,0,1), 0, 5750, Doors.CLOSED)

win16=Doors.CreateDoor("Win16", (30000,windhite,-43000), (0,0,1), 0, 5750, Doors.CLOSED)

#########################################################################################################################
##### Inn upper floor 

door1=Doors.CreateDoor("Door1", (564125,10000,64500), (0,0,1), 300, 2500, Doors.CLOSED)
door1.opentype=Doors.UNIF
door1.o_med_vel=-500
door1.o_med_displ=2200
door1.closetype=Doors.AC
door1.c_init_displ=2200
door1.c_med_vel=1000

door1.SetWhileOpenSound(sdoor1d)
door1.SetEndOpenSound(sdoor1g)
door1.SetWhileCloseSound(sdoor1d)
door1.SetEndCloseSound(sdoor1g)

door1vr=Levers.PlaceLever("Door1lever",Levers.LeverType2,(565046,10807,66489),(0.707,0.0,0.707,0.0),0.8)
door1vr.mode=1
door1vr.OnTurnOnFunc=AbreDoor1
door1vr.OnTurnOnArgs=()
door1vr.OnTurnOffFunc=CierraDoor1
door1vr.OnTurnOffArgs=()



o=Bladex.CreateEntity("PlataformaRail_7047","PlataformaRail",564039,10012,64585, Reference.ObjType("PlataformaRail"))
o.Scale=1.2
o.Orientation=(0.707106769085,0.0,-0.707106769085,0.0)
o.Alpha=0


#####dark

door1D=Doors.CreateDoor("Door1D", (564125,10000,-65500), (0,0,1), 300, 2500, Doors.CLOSED)
door1D.opentype=Doors.UNIF
door1D.o_med_vel=-500
door1D.o_med_displ=2200
door1D.closetype=Doors.AC
door1D.c_init_displ=2200
door1D.c_med_vel=1000

door1D.SetWhileOpenSound(sdoor1d)
door1D.SetEndOpenSound(sdoor1g)
door1D.SetWhileCloseSound(sdoor1d)
door1D.SetEndCloseSound(sdoor1g)

door1vrD=Levers.PlaceLever("Door1leverD",Levers.LeverType2,(565046,10807,-63511),(0.707,0.0,0.707,0.0),0.8)
door1vrD.mode=1
door1vrD.OnTurnOnFunc=AbreDoor1D
door1vrD.OnTurnOnArgs=()
door1vrD.OnTurnOffFunc=CierraDoor1D
door1vrD.OnTurnOffArgs=()

########################################################################################################################
######### Inn side door

door2=Doors.CreateDoor("Door2", (559625,18000,65000), (0,0,1), 300, 2500, Doors.CLOSED)
door2.opentype=Doors.UNIF
door2.o_med_vel=-500
door2.o_med_displ=2200
door2.closetype=Doors.AC
door2.c_init_displ=2200
door2.c_med_vel=1000

door2.SetWhileOpenSound(sdoor1d)
door2.SetEndOpenSound(sdoor1g)
door2.SetWhileCloseSound(sdoor1d)
door2.SetEndCloseSound(sdoor1g)

door2vr=Levers.PlaceLever("Door2lever",Levers.LeverType2,(561250,18000,67000),(0.707,0.0,0.707,0.0),0.8)
door2vr.mode=1
door2vr.OnTurnOnFunc=AbreDoor2
door2vr.OnTurnOnArgs=()
door2vr.OnTurnOffFunc=CierraDoor1
door2vr.OnTurnOffArgs=()

#####dark

door2D=Doors.CreateDoor("Door2D", (559625,18000,-65000), (0,0,1), 300, 2500, Doors.CLOSED)
door2D.opentype=Doors.UNIF
door2D.o_med_vel=-500
door2D.o_med_displ=2200
door2D.closetype=Doors.AC
door2D.c_init_displ=2200
door2D.c_med_vel=1000

door2D.SetWhileOpenSound(sdoor1d)
door2D.SetEndOpenSound(sdoor1g)
door2D.SetWhileCloseSound(sdoor1d)
door2D.SetEndCloseSound(sdoor1g)

door2vrD=Levers.PlaceLever("Door2leverD",Levers.LeverType2,(561250,18000,-63000),(0.707,0.0,0.707,0.0),0.8)
door2vrD.mode=1
door2vrD.OnTurnOnFunc=AbreDoor2D
door2vrD.OnTurnOnArgs=()
door2vrD.OnTurnOffFunc=CierraDoor2D
door2vrD.OnTurnOffArgs=()

#####################################################################################################################
#######Inn backdoor

door3=Doors.CreateDoor("Door3", (575750,18000,72625), (1,0,0), 100, 2000, Doors.CLOSED)
door3.opentype=Doors.UNIF
door3.o_med_vel=-500
door3.o_med_displ=1900
door3.closetype=Doors.AC
door3.c_init_displ=1900
door3.c_med_vel=1000

door3.SetWhileOpenSound(sdoor1d)
door3.SetEndOpenSound(sdoor1g)
door3.SetWhileCloseSound(sdoor1d)
door3.SetEndCloseSound(sdoor1g)

door3vr=Levers.PlaceLever("Door3lever",Levers.LeverType1,(577561,18000.0,72216),(0.701,0.701,-0.0922,0.0922),0.8)
door3vr.mode=1
door3vr.OnTurnOnFunc=AbreDoor3
door3vr.OnTurnOnArgs=()
door3vr.OnTurnOffFunc=CierraDoor3
door3vr.OnTurnOffArgs=()

o=Bladex.CreateEntity("PlataformaRail_7048","PlataformaRail",575968,17611,72769, Reference.ObjType("PlataformaRail"))
o.Scale=1.2
o.Orientation=(0.0,1.05367119474e-008,1.0,1.05367119474e-008)
o.Alpha=0

#####dark

door3D=Doors.CreateDoor("Door3D", (575750,18000,-57375), (1,0,0), 100, 2000, Doors.CLOSED)
door3D.opentype=Doors.UNIF
door3D.o_med_vel=-500
door3D.o_med_displ=1900
door3D.closetype=Doors.AC
door3D.c_init_displ=1900
door3D.c_med_vel=1000

door3D.SetWhileOpenSound(sdoor1d)
door3D.SetEndOpenSound(sdoor1g)
door3D.SetWhileCloseSound(sdoor1d)
door3D.SetEndCloseSound(sdoor1g)

door3vrD=Levers.PlaceLever("Door3leverD",Levers.LeverType1,(577561,18000,-57784),(0.701,0.701,-0.0922,0.0922),0.8)
door3vrD.mode=1
door3vrD.OnTurnOnFunc=AbreDoor3D
door3vrD.OnTurnOnArgs=()
door3vrD.OnTurnOffFunc=CierraDoor3D
door3vrD.OnTurnOffArgs=()

##########################################################################################################################
#####Cellar Door (only operational in day) 

door4=Doors.CreateDoor("Door4", (579000,24000,71000), (0,0,-1), 100, 3000, Doors.CLOSED)
door4.opentype=Doors.UNIF
door4.o_med_vel=-500
door4.o_med_displ=2900
door4.closetype=Doors.AC
door4.c_init_displ=2900
door4.c_med_vel=4000

door4.SetWhileOpenSound(sdoor1d)
door4.SetEndOpenSound(sdoor1g)
door4.SetWhileCloseSound(sdoor1d)
door4.SetEndCloseSound(sdoor1g)


door4vr=Levers.PlaceLever("Door4lever",Levers.LeverType1,(579809,25800,72800),(0.5,0.5,-0.5,0.5),0.8)
door4vr.mode=1
door4vr.OnTurnOnFunc=AbreDoor4
door4vr.OnTurnOnArgs=()
door4vr.OnTurnOffFunc=AbreDoor4
door4vr.OnTurnOffArgs=()


door4vrD=Levers.PlaceLever("Door4leverD",Levers.LeverType1,(579809,25800,-57200),(0.5,0.5,-0.5,0.5),0.8)
door4vrD.mode=1
door4vrD.OnTurnOnFunc=None
door4vrD.OnTurnOnArgs=()
door4vrD.OnTurnOffFunc=None
door4vrD.OnTurnOffArgs=()

########################################################################################################################
####### Inn Second Front Door

door5=Doors.CreateDoor("Door5", (601875,16500,48250), (0,0,1), 100, 2000, Doors.CLOSED)
door5.opentype=Doors.UNIF
door5.o_med_vel=-500
door5.o_med_displ=1900
door5.closetype=Doors.AC
door5.c_init_displ=1900
door5.c_med_vel=1000

door5.SetWhileOpenSound(sdoor1d)
door5.SetEndOpenSound(sdoor1g)
door5.SetWhileCloseSound(sdoor1d)
door5.SetEndCloseSound(sdoor1g)

door5vr=Levers.PlaceLever("Door5lever",Levers.LeverType1,(602255,17693,49774),(0.5,0.5,-0.5,0.5),0.8)
door5vr.mode=1
door5vr.OnTurnOnFunc=AbreDoor5
door5vr.OnTurnOnArgs=()
door5vr.OnTurnOffFunc=CierraDoor5
door5vr.OnTurnOffArgs=()

#####dark

door5D=Doors.CreateDoor("Door5D", (601875,16500,-81750), (0,0,1), 100, 2000, Doors.CLOSED)
door5D.opentype=Doors.UNIF
door5D.o_med_vel=-500
door5D.o_med_displ=1900
door5D.closetype=Doors.AC
door5D.c_init_displ=1900
door5D.c_med_vel=1000

door5D.SetWhileOpenSound(sdoor1d)
door5D.SetEndOpenSound(sdoor1g)
door5D.SetWhileCloseSound(sdoor1d)
door5D.SetEndCloseSound(sdoor1g)

door5vrD=Levers.PlaceLever("Door5leverD",Levers.LeverType1,(602255,17693,-80226),(0.5,0.5,-0.5,0.5),0.8)
door5vrD.mode=1
door5vrD.OnTurnOnFunc=AbreDoor5D
door5vrD.OnTurnOnArgs=()
door5vrD.OnTurnOffFunc=CierraDoor5D
door5vrD.OnTurnOffArgs=()

##########################################################################################################################
##### Dragon Gate

o=Bladex.CreateEntity("DragonGateKey","Llavedor",558460,27710,82537, Reference.ObjType("Llavedor"))
o.Scale=1.0
o.Orientation=(0.9,0.003,-0.4,0.0)
Stars.Twinkle("DragonGateKey")
darfuncs.SetHint(o,Tr("Dragon Gate Key"))
Ontake.AddOnTakeEvent(o.Name, SpidersComeOut)


door6=Doors.CreateDoor("Door6", (495500,12000,36750), (0,1,0), 4000, 9000, Doors.CLOSED)
door6.opentype=Doors.UNIF
door6.o_med_vel=-500
door6.o_med_displ=5000
door6.closetype=Doors.AC
door6.c_init_displ=5000
door6.c_med_vel=1000

door6.SetWhileOpenSound(sdoor2d)
door6.SetEndOpenSound(sdoor2g)
door6.SetWhileCloseSound(sdoor2d)
door6.SetEndCloseSound(sdoor2g)

door6loc=Locks.PlaceLock("DragonGateLock","Cerraduracutre",(496952,18200,32757),(0.5,-0.5,-0.5,-0.5),2.5)
door6loc.Scale=2.6
door6loc.Frozen=1
door6loc.key="DragonGateKey"
darfuncs.SetHint(door6loc.obj,Tr("Dragon Gate Lock"))
door6loc.OnUnLockFunc=AbreDoor6
door6loc.OnUnLockArgs=()


o=Bladex.CreateEntity("PlataformaRail_7046","PlataformaRail",493459,14411,36677, Reference.ObjType("PlataformaRail"))
o.Scale=3.6
o.Orientation=(0.707106769085,0.0,-0.707106769085,0.0)
o.Alpha=0


#######################################################################################################################
###### Tunnel door to back of Inn

door7D=Doors.CreateDoor("Door7D", (613750,20000,-61375), (0,1,0), 300, 2600, Doors.CLOSED)
door7D.opentype=Doors.UNIF
door7D.o_med_vel=-500
door7D.o_med_displ=2300
door7D.closetype=Doors.AC
door7D.c_init_displ=2300
door7D.c_med_vel=1000

door7D.SetWhileOpenSound(sdoor1d)
door7D.SetEndOpenSound(sdoor1g)
door7D.SetWhileCloseSound(sdoor1d)
door7D.SetEndCloseSound(sdoor1g)

#######################################################################################################################
###### Cave Gate

o=Bladex.CreateEntity("RustyKey","Llavecutre",0,0,0,"Physic")    # held by GreatOrk1
o.Scale=1.0
o.Orientation=0.5,0.25,-0.825,0.031
darfuncs.SetHint(o,Tr("Rusty Key"))
Stars.Twinkle("RustyKey")


gate1=Bladex.CreateEntity("Gate1","Rastrillo",253226,-3034,-34948,"Physic")
gate1.Scale=1
gate1.Orientation=0.677987754345,0.677988052368,-0.200829297304,0.200829252601
gate1=Sparks.SetMetalSparkling("Gate1")
gate1.Frozen=1
gate1din=Objects.CreateDinamicObject("Gate1")


gate1loc=Locks.PlaceLock("RustyLock","Cerraduracutre",(250672,-1039,-35856),(0.3227,-0.31,-0.6248,-0.6396),2.5)
gate1loc.key="RustyKey"
darfuncs.SetHint(gate1loc.obj,Tr("Rusty Lock"))
gate1loc.OnUnLockFunc=AbreGate1
gate1loc.OnUnLockArgs=()
gate1loc.OnLockFunc=CierraGate1
gate1loc.OnLockArgs=()

#######################################################################################################################
###### Side cave

gate2=Bladex.CreateEntity("Gate2","Rastrillo",234194,-2105,-81845,"Physic")
gate2.Scale=1
gate2.Orientation=0.653281569481,0.653281450272,-0.270598083735,0.270597904921
gate2=Sparks.SetMetalSparkling("Gate2")
gate2.Frozen=1
gate2din=Objects.CreateDinamicObject("Gate2")


gate2lever=Levers.PlaceLever("Gate2lever",Levers.LeverType3,(253210,-1491,-72507),(0.683,0.683,-0.183,0.183),0.8)
gate2lever.mode=0
gate2lever.OnTurnOnFunc=AbreGate2
gate2lever.OnTurnOnArgs=()
gate2lever.OnTurnOffFunc=CierraGate2
gate2lever.OnTurnOffArgs=()

######################################################################################################################
####### Dungeons

dunggate1=Bladex.CreateEntity("DungeonGate1","Rastrillo10",50280,15000,-25546,"Physic")
dunggate1.Scale=1
dunggate1.Orientation=0.0,1.27967922481e-007,0.707106769085,-0.707106769085
dunggate1=Sparks.SetMetalSparkling("DungeonGate1")
dunggate1.Frozen=1
dunggate1din=Objects.CreateDinamicObject("DungeonGate1")


dunggate1lever=Levers.PlaceLever("DungGate1lever",Levers.LeverType3,(93877,16473,-24250),(0.5,0.5,-0.5,0.5),0.8)
dunggate1lever.mode=0
dunggate1lever.OnTurnOnFunc=AbreDungGate1
dunggate1lever.OnTurnOnArgs=()


dunggate2=Bladex.CreateEntity("DungeonGate2","Rastrillo10",57480,15000,-25546,"Physic")
dunggate2.Scale=1
dunggate2.Orientation=0.0,1.27967922481e-007,0.707106769085,-0.707106769085
dunggate2=Sparks.SetMetalSparkling("DungeonGate2")
dunggate2.Frozen=1
dunggate2din=Objects.CreateDinamicObject("DungeonGate2")


dunggate2lever=Levers.PlaceLever("DungGate2lever",Levers.LeverType3,(93877,16473,-23000),(0.5,0.5,-0.5,0.5),0.8)
dunggate2lever.mode=0
dunggate2lever.OnTurnOnFunc=AbreDungGate2
dunggate2lever.OnTurnOnArgs=()


dunggate3=Bladex.CreateEntity("DungeonGate3","Rastrillo10",64780,15000,-25546,"Physic")
dunggate3.Scale=1
dunggate3.Orientation=0.0,1.27967922481e-007,0.707106769085,-0.707106769085
dunggate3=Sparks.SetMetalSparkling("DungeonGate3")
dunggate3.Frozen=1
dunggate3din=Objects.CreateDinamicObject("DungeonGate3")


dunggate3lever=Levers.PlaceLever("DungGate3lever",Levers.LeverType3,(93877,16473,-21750),(0.5,0.5,-0.5,0.5),0.8)
dunggate3lever.mode=0
dunggate3lever.OnTurnOnFunc=AbreDungGate3
dunggate3lever.OnTurnOnArgs=()


dunggate4=Bladex.CreateEntity("DungeonGate4","Rastrillo10",71980,15000,-25546,"Physic")
dunggate4.Scale=1
dunggate4.Orientation=0.0,1.27967922481e-007,0.707106769085,-0.707106769085
dunggate4=Sparks.SetMetalSparkling("DungeonGate4")
dunggate4.Frozen=1
dunggate4din=Objects.CreateDinamicObject("DungeonGate4")

dunggate4lever=Levers.PlaceLever("DungGate4lever",Levers.LeverType3,(93877,16473,-18500),(0.5,0.5,-0.5,0.5),0.8)
dunggate4lever.mode=0
dunggate4lever.OnTurnOnFunc=AbreDungGate4
dunggate4lever.OnTurnOnArgs=()


dunggate5=Bladex.CreateEntity("DungeonGate5","Rastrillo10",79280,15000,-25546,"Physic")
dunggate5.Scale=1
dunggate5.Orientation=0.0,1.27967922481e-007,0.707106769085,-0.707106769085
dunggate5=Sparks.SetMetalSparkling("DungeonGate5")
dunggate5.Frozen=1
dunggate5din=Objects.CreateDinamicObject("DungeonGate5")


dunggate5lever=Levers.PlaceLever("DungGate5lever",Levers.LeverType3,(93877,16473,-17250),(0.5,0.5,-0.5,0.5),0.8)
dunggate5lever.mode=0
dunggate5lever.OnTurnOnFunc=AbreDungGate5
dunggate5lever.OnTurnOnArgs=()


dunggate6=Bladex.CreateEntity("DungeonGate6","Rastrillo10",86480,15000,-25546,"Physic")
dunggate6.Scale=1
dunggate6.Orientation=0.0,1.27967922481e-007,0.707106769085,-0.707106769085
dunggate6=Sparks.SetMetalSparkling("DungeonGate6")
dunggate6.Frozen=1
dunggate6din=Objects.CreateDinamicObject("DungeonGate6")


dunggate6lever=Levers.PlaceLever("DungGate6lever",Levers.LeverType3,(93877,16473,-16000),(0.5,0.5,-0.5,0.5),0.8)
dunggate6lever.mode=0
dunggate6lever.OnTurnOnFunc=AbreDungGate6
dunggate6lever.OnTurnOnArgs=()

#######################################################################################################################
######## Jailer Golem door

o=Bladex.CreateEntity("DungeonKey","Llavedor",84385,11082,-41957,"Physic")    
o.Scale=1.0
o.Orientation=0.56,0.43,-0.43,-0.560
darfuncs.SetHint(o,Tr("Dungeon Key"))
Stars.Twinkle("DungeonKey")
Ontake.AddOnTakeEvent(o.Name, CheckWhosOut)


door8=Doors.CreateDoor("Door8", (91500,10000,-32750), (0,1,0), 4000, 10500, Doors.CLOSED)
door8.opentype=Doors.UNIF
door8.o_med_vel=-380
door8.o_med_displ=6500
door8.closetype=Doors.AC
door8.c_init_displ=6500
door8.c_med_vel=1000

door8.SetWhileOpenSound(sdoor3d)
door8.SetEndOpenSound(sdoor2g)
door8.SetWhileCloseSound(sdoor3d)
door8.SetEndCloseSound(sdoor2g)

########################
####### Dungeon Exit

door9=Doors.CreateDoor("Door9", (37750,10000,-33000), (0,1,0), 4000, 9800, Doors.CLOSED)
door9.opentype=Doors.UNIF
door9.o_med_vel=-380
door9.o_med_displ=5800
door9.closetype=Doors.AC
door9.c_init_displ=5800
door9.c_med_vel=1000

door9.SetWhileOpenSound(sdoor3d)
door9.SetEndOpenSound(sdoor2g)
door9.SetWhileCloseSound(sdoor3d)
door9.SetEndCloseSound(sdoor2g)


door9loc=Locks.PlaceLock("DungeonDoorLock","Cerraduracutre",(39835,16628,-37583),(0.65,0.65,-0.27,0.27),2.5)
door9loc.Scale=2.6
door9loc.Frozen=1
door9loc.key="DungeonKey"
darfuncs.SetHint(door9loc.obj,Tr("Dungeon Lock"))
door9loc.OnUnLockFunc=AbreDoor9
door9loc.OnUnLockArgs=()

######################################
######## Throne room entrance

door10=Doors.CreateDoor("Door10", (-49250,9000,-21250), (0,1,0), 2000, 5500, Doors.CLOSED)
door10.opentype=Doors.UNIF
door10.o_med_vel=-480
door10.o_med_displ=3500
door10.closetype=Doors.AC
door10.c_init_displ=3500
door10.c_med_vel=5000

door10.SetWhileOpenSound(sdoor2d)
door10.SetEndOpenSound(sdoor2g)
door10.SetWhileCloseSound(sdoor2d)
door10.SetEndCloseSound(sdoor4g)

door10.OnEndCloseFunc=PutUpShade51


o=Bladex.CreateEntity("PlataformaRail_7051","PlataformaRail",-49074,8608,-19858, Reference.ObjType("PlataformaRail"))
o.Scale=2.0
o.Orientation=(1.0,0.0,0.0,0.0)
o.Alpha=0

########################################
####### Side Tomb

door11=Doors.CreateDoor("Door11", (-55750,9000,-26500), (0,1,0), 1500, 5500, Doors.CLOSED)
door11.opentype=Doors.UNIF
door11.o_med_vel=-380
door11.o_med_displ=4000
door11.closetype=Doors.AC
door11.c_init_displ=4000
door11.c_med_vel=5000

door11.SetWhileOpenSound(sdoor2d)
door11.SetEndOpenSound(sdoor2g)
door11.SetWhileCloseSound(sdoor2d)
door11.SetEndCloseSound(sdoor2g)


######## Door Opposite Side Tomb

door12=Doors.CreateDoor("Door12", (-42750,9000,-26500), (0,1,0), 1500, 5500, Doors.CLOSED)
door12.opentype=Doors.UNIF
door12.o_med_vel=-380
door12.o_med_displ=4000
door12.closetype=Doors.AC
door12.c_init_displ=4000
door12.c_med_vel=5000

door12.SetWhileOpenSound(sdoor2d)
door12.SetEndOpenSound(sdoor2g)
door12.SetWhileCloseSound(sdoor2d)
door12.SetEndCloseSound(sdoor2g)

################################ small door on low bridge leading out

door13=Doors.CreateDoor("Door13", (-26250,4000,-25000), (0,0,1), 500, 4250, Doors.CLOSED)
door13.opentype=Doors.UNIF
door13.o_med_vel=-500
door13.o_med_displ=3750
door13.closetype=Doors.AC
door13.c_init_displ=3750
door13.c_med_vel=1000

door13.SetWhileOpenSound(sdoor1d)
door13.SetEndOpenSound(sdoor1g)
door13.SetWhileCloseSound(sdoor1d)
door13.SetEndCloseSound(sdoor1g)


door13lever=Levers.PlaceLever("Door13lever",Levers.LeverType1,(-27011,5817,-27208),(0.5,0.5,0.5,-0.5),0.8)
door13lever.mode=0
door13lever.OnTurnOnFunc=AbreDoor13
door13lever.OnTurnOnArgs=()
door13lever.OnTurnOffFunc=CierraDoor13
door13lever.OnTurnOffArgs=()

################################# small door on low bridge leading in

o=Bladex.CreateEntity("BronzeKey","Llavecobox",-58191,9970,-31731, Reference.ObjType("Llavecobox"))
o.Scale=1.0
o.Orientation=(0.79,0.0,-0.6,0.0)
Stars.Twinkle("BronzeKey")
darfuncs.SetHint(o,Tr("Bronze Key"))

door14=Doors.CreateDoor("Door14", (-12000,4000,-25000), (0,0,-1), 500, 4250, Doors.CLOSED)
door14.opentype=Doors.UNIF
door14.o_med_vel=-500
door14.o_med_displ=3750
door14.closetype=Doors.AC
door14.c_init_displ=3750
door14.c_med_vel=1000

door14.SetWhileOpenSound(sdoor1d)
door14.SetEndOpenSound(sdoor1g)
door14.SetWhileCloseSound(sdoor1d)
door14.SetEndCloseSound(sdoor1g)


door14loc=Locks.PlaceLock("Door14Lock","Cerraduracutre",(-13549,5770,-23013),(0.5,0.5,0.5,-0.5),2.5)
door14loc.Scale=2.0
door14loc.Frozen=1
door14loc.key="BronzeKey"
darfuncs.SetHint(door14loc.obj,Tr("Bronze Lock"))
door14loc.OnUnLockFunc=AbreDoor14
door14loc.OnUnLockArgs=()

############################################ Side door in street between the bridges

door15=Doors.CreateDoor("Door15", (-27500,9000,-35250), (0,1,0), 3400, 8400, Doors.CLOSED)
door15.opentype=Doors.UNIF
door15.o_med_vel=-380
door15.o_med_displ=5000
door15.closetype=Doors.AC
door15.c_init_displ=5000
door15.c_med_vel=5000

door15.SetWhileOpenSound(sdoor3d)
door15.SetEndOpenSound(sdoor2g)
door15.SetWhileCloseSound(sdoor3d)
door15.SetEndCloseSound(sdoor2g)

###################################### east side throne room small door

door16=Doors.CreateDoor("Door16", (-37250,9000,-39750), (0,1,0), 100, 4000, Doors.CLOSED)
door16.opentype=Doors.UNIF
door16.o_med_vel=-380
door16.o_med_displ=3900
door16.closetype=Doors.AC
door16.c_init_displ=3900
door16.c_med_vel=5000

door16.SetWhileOpenSound(sdoor2d)
door16.SetEndOpenSound(sdoor2g)
door16.SetWhileCloseSound(sdoor2d)
door16.SetEndCloseSound(sdoor2g)


door16lever=Levers.PlaceLever("Door16lever",Levers.LeverType1,(-33272,9631,-41097),(0.5,0.5,0.5,-0.5),0.8)
door16lever.mode=0
door16lever.OnTurnOnFunc=AbreDoor16
door16lever.OnTurnOnArgs=()
door16lever.OnTurnOffFunc=CierraDoor16
door16lever.OnTurnOffArgs=()

########################################## Scriptorium

door17=Doors.CreateDoor("Door17", (14000,-9000,-58500), (1,0,0), 200, 4500, Doors.CLOSED)
door17.opentype=Doors.UNIF
door17.o_med_vel=-280
door17.o_med_displ=4200
door17.closetype=Doors.AC
door17.c_init_displ=4200
door17.c_med_vel=3000

door17.SetWhileOpenSound(sdoor1d)
door17.SetEndOpenSound(sdoor1g)
door17.SetWhileCloseSound(sdoor1d)
door17.SetEndCloseSound(sdoor1g)

### this lock is a dummy

o=Bladex.CreateEntity("Door17Lock","Cerraduracutre",15737,-8063,-57610,"Physic")   
o.Scale=1.6
o.Orientation=0.0,1.46000971313e-007,0.707,-0.707
darfuncs.SetHint(o,Tr("Scriptorium Lock"))


o=Bladex.CreateEntity("Bent Key","LlaveDoblada",15973,-7024,-55325, Reference.ObjType("LlaveDoblada"))
o.Scale=1.2
o.Orientation=(1.0,0.0,0.0,0.0)

kp=Bladex.CreateEntity("KeyPointer","GhostPointer", 15973,-7224,-55325)
kp.Static=1
kp.Scale=1
kp.Orientation=0.707,0.707,0.0,0.0
kp.UseFunc= ThisKeyIsBent
darfuncs.SetHint(kp,Tr("Scriptorium Key"))

########################################################################################################################
######## Door to high bridge

o=Bladex.CreateEntity("Key18","Llavecutre",0,33000,0,"Physic")   
o.Scale=1.0
o.Orientation=1.0,0.0,0.0,0.0
darfuncs.SetHint(o,Tr("Shrine Key"))
Stars.Twinkle("Key18")
o.Impulse(0,0,0)


door18=Doors.CreateDoor("Door18", (-11500,-7000,-43000), (0,1,0), 1500, 5000, Doors.OPENED)
door18.opentype=Doors.UNIF
door18.o_med_vel=-480
door18.o_med_displ=3500
door18.closetype=Doors.AC
door18.c_init_displ=3500
door18.c_med_vel=5000

door18.SetWhileOpenSound(sdoor2d)
door18.SetEndOpenSound(sdoor2g)
door18.SetWhileCloseSound(sdoor2d)
door18.SetEndCloseSound(sdoor2g)

door18.OnEndCloseFunc=PutUpShade52

door18loc=Locks.PlaceLock("Door18Lock","Cerradurdor",(-10296,-6211,-45314),(0.63,0.63,-0.32,0.32),2.5)
door18loc.Scale=2.6
door18loc.Frozen=1
door18loc.key="Key18"
darfuncs.SetHint(door18loc.obj,Tr("Shrine Lock"))
door18loc.OnUnLockFunc=AbreDoor18
door18loc.OnUnLockArgs=()


o=Bladex.CreateEntity("PlataformaRail_7052","PlataformaRail",-11350,-7083,-42757, Reference.ObjType("PlataformaRail"))
o.Scale=1.8
o.Orientation=(0.707106769085,0.0,-0.707106769085,0.0)
o.Alpha=0



########################################################################################################################
####### South Tower Elev

selev1=Bladex.CreateEntity("SouthTowerElevator1","Plataforma",-11252,-726,-69018,"Physic")
selev1.Scale=3.4
selev1.Orientation=0.707106769085,-0.707106769085,0.0,0.0
selev1.Frozen=1
selev1din=Objects.CreateDinamicObject("SouthTowerElevator1")


selev1lever1=Levers.PlaceLever("SouthElevUplever",Levers.LeverType3,(-11517,-2092,-66625),(0.707,0.707,0.0,0.0),0.8)
selev1lever1.mode=1
selev1lever1.OnTurnOnFunc=SouthElevUP
selev1lever1.OnTurnOnArgs=()


selev1lever1call=Levers.PlaceLever("SouthElevCalldownlever",Levers.LeverType3,(-8507,-1907,-66827),(0.707,0.707,0.0,0.0),0.8)
selev1lever1call.mode=1
selev1lever1call.OnTurnOnFunc=LowerSouthElevCall
selev1lever1call.OnTurnOnArgs=()


selev1lever2=Levers.PlaceLever("SouthElevDownlever",Levers.LeverType3,(-11396,-16406,-66566),(0.707,0.707,0.0,0.0),0.8)
selev1lever2.mode=1
selev1lever2.OnTurnOnFunc=SouthElevDOWN
selev1lever2.OnTurnOnArgs=()

selev2lever1call=Levers.PlaceLever("SouthElevCalluplever",Levers.LeverType3,(-8507,-16406,-66827),(0.707,0.707,0.0,0.0),0.8)
selev2lever1call.mode=1
selev2lever1call.OnTurnOnFunc=UpperSouthElevCall
selev2lever1call.OnTurnOnArgs=()

##################### trap deactlever in dormitory

o=Bladex.CreateEntity("Zocalo3_3259","Zocalo3",-1903.5816578,5672.94185444,-27958.7070756, Reference.ObjType("Zocalo3"))
o.Scale=1.0
o.Orientation=(0.707106769085,-0.707106769085,0.0,0.0)

#######################################################################################################################
######## Central Elevator

#### Init Pos> Lower gallery

centelev1=Bladex.CreateEntity("CentralElevator1","Plataforma",14220,5508,-29670,"Physic")
centelev1.Scale=3.2
centelev1.Orientation=0.5,-0.5,-0.5,-0.5
centelev1.Frozen=1
centelev1din=Objects.CreateDinamicObject("CentralElevator1")

################
#### Levers ####
################

##### Lower Gallery

galleryleverup=Levers.PlaceLever("GalleryLeverUp",Levers.LeverType3,(12106,3685,-30540),(0.5,0.5,-0.5,0.5),0.8)
galleryleverup.mode=1
galleryleverup.OnTurnOnFunc=GalleryLeverUP
galleryleverup.OnTurnOnArgs=()

galleryleverdown=Levers.PlaceLever("GalleryLeverDown",Levers.LeverType3,(12106,3685,-28752),(0.5,0.5,-0.5,0.5),0.8)
galleryleverdown.mode=1
galleryleverdown.OnTurnOnFunc=GalleryLeverDOWN
galleryleverdown.OnTurnOnArgs=()

gallerylevercall=Levers.PlaceLever("GalleryLeverCall",Levers.LeverType3,(12069,3675,-32452),(0.5,0.5,-0.5,0.5),0.8)
gallerylevercall.mode=1
gallerylevercall.OnTurnOnFunc=GalleryLeverCALL
gallerylevercall.OnTurnOnArgs=()


###### Hall Level

hallleverup=Levers.PlaceLever("HallLeverUp",Levers.LeverType3,(12111,-8025,-30503),(0.5,0.5,-0.5,0.5),0.8)
hallleverup.mode=1
hallleverup.OnTurnOnFunc=HallLeverUP
hallleverup.OnTurnOnArgs=()

hallleverdown=Levers.PlaceLever("HallLeverDown",Levers.LeverType3,(12111,-8025,-28803),(0.5,0.5,-0.5,0.5),0.8)
hallleverdown.mode=1
hallleverdown.OnTurnOnFunc=HallLeverDOWN
hallleverdown.OnTurnOnArgs=()

halllevercall=Levers.PlaceLever("HallLeverCall",Levers.LeverType3,(12081,-8297,-32818),(0.5,0.5,-0.5,0.5),0.8)
halllevercall.mode=1
halllevercall.OnTurnOnFunc=HallLeverCALL
halllevercall.OnTurnOnArgs=()

##### Basement

baseleverup=Levers.PlaceLever("BasementLeverUp",Levers.LeverType3,(16357,16800,-30590),(0.5,0.5,0.5,-0.5),0.8)
baseleverup.mode=1
baseleverup.OnTurnOnFunc=BasementLeverUP
baseleverup.OnTurnOnArgs=()

baselevercall=Levers.PlaceLever("BasementLeverCall",Levers.LeverType3,(12142,17493,-32088),(0.707,0.707,0.0,0.0),0.8)
baselevercall.mode=1
baselevercall.OnTurnOnFunc=BasementLeverCALL
baselevercall.OnTurnOnArgs=()


####### Roof

roofleverdown=Levers.PlaceLever("RoofLeverDown",Levers.LeverType3,(16377,-24426,-28609),(0.5,0.5,0.5,-0.5),0.8)
roofleverdown.mode=1
roofleverdown.OnTurnOnFunc=RoofLeverDOWN
roofleverdown.OnTurnOnArgs=()

rooflevercall=Levers.PlaceLever("RoofLeverCall",Levers.LeverTypeFloor,(9612,-23132,-30712),(0.5,0.5,-0.5,0.5),0.8)
rooflevercall.mode=1
rooflevercall.OnTurnOnFunc=RoofLeverCALL
rooflevercall.OnTurnOnArgs=()


######## Basement Grill

basementgrill=Bladex.CreateEntity("BasementGrill","Rastrillo10",14142,16000,-31588,"Physic")
basementgrill.Scale=0.7
basementgrill.Orientation=0.707,0.707,0.0,0.0
basementgrill=Sparks.SetMetalSparkling("BasementGrill")
basementgrill.Frozen=1
basementgrilldin=Objects.CreateDinamicObject("BasementGrill")

#######################################################################################################################
######## Pool

poolgate=Bladex.CreateEntity("PoolGate","Reja",13198,-1936,-13997,"Physic")
poolgate.Scale=2.6
poolgate.Orientation=0.5,-0.5,0.5,0.5
poolgate.Frozen=1
poolgatedin=Objects.CreateDinamicObject("PoolGate")

poolgaterail=Bladex.CreateEntity("PoolGateRail","Rail2",13198,40,-13997,"Physic")
poolgaterail.Scale=0.25
poolgaterail.Orientation=0.13,0.0,0.0,0.99
poolgaterail.Frozen=1
poolgateraildin=Objects.CreateDinamicObject("PoolGateRail")

#######################################################################################################################
####### Golems Den       

####dummy gate

o=Bladex.CreateEntity("Rastrillo10_3427","Rastrillo10",85867,6750,-44532, Reference.ObjType("Rastrillo10"))
o.Scale=0.95
o.Orientation=(0.5,0.5,-0.5,0.5)

o=Bladex.CreateEntity("Zocalo3_3428","Zocalo3",87112.8345727,10994,-41564.8799474, Reference.ObjType("Zocalo3"))
o.Scale=1.0
o.Orientation=(0.707,0.707,0.0,0.0)

####### 'real' gate

golgate1=Bladex.CreateEntity("GolemGate1","Rastrillo10",96984,15311,-40069,"Physic")
golgate1.Scale=0.8
golgate1.Orientation=0.707,0.707,0.0,0.0
golgate1=Sparks.SetMetalSparkling("GolemGate1")
golgate1.Frozen=1
golgate1din=Objects.CreateDinamicObject("GolemGate1")

#########################################################################################################################
######## Shrine Door

door19=Doors.CreateDoor("Door19", (-33250,-8000,-42500), (0,1,0), 2000, 7000, Doors.CLOSED)
door19.opentype=Doors.UNIF
door19.o_med_vel=-480
door19.o_med_displ=5000
door19.closetype=Doors.AC
door19.c_init_displ=5000
door19.c_med_vel=5000

door19.SetWhileOpenSound(deslizrasanexo)
door19.SetEndOpenSound(sdoor2g)
door19.SetWhileCloseSound(deslizrasanexo)
door19.SetEndCloseSound(sdoor2g)


o1=Bladex.CreateEntity("PinchoMiguel_3452a","PinchoMiguel",-33250,-4168,-40500, "Physic")
o1.Scale=1.0
o1.Frozen=1
o1.Orientation=(0.5,-0.5,0.5,0.5)
o1din=Objects.CreateDinamicObject(o1.Name)

o2=Bladex.CreateEntity("PinchoMiguel_3452b","PinchoMiguel",-33250,-4168,-41500, "Physic")
o2.Scale=1.0
o2.Frozen=1
o2.Orientation=(0.5,-0.5,0.5,0.5)
o2din=Objects.CreateDinamicObject(o2.Name)

o3=Bladex.CreateEntity("PinchoMiguel_3452c","PinchoMiguel",-33250,-4168,-42500, "Physic")
o3.Scale=1.0
o3.Frozen=1
o3.Orientation=(0.5,-0.5,0.5,0.5)
o3din=Objects.CreateDinamicObject(o3.Name)

o4=Bladex.CreateEntity("PinchoMiguel_3452d","PinchoMiguel",-33250,-4168,-43500, "Physic")
o4.Scale=1.0
o4.Frozen=1
o4.Orientation=(0.5,-0.5,0.5,0.5)
o4din=Objects.CreateDinamicObject(o4.Name)

o5=Bladex.CreateEntity("PinchoMiguel_3452e","PinchoMiguel",-33250,-4168,-44500, "Physic")
o5.Scale=1.0
o5.Frozen=1
o5.Orientation=(0.5,-0.5,0.5,0.5)
o5din=Objects.CreateDinamicObject(o5.Name)

############# spikes

pinchosgolpeando1=Sounds.CreateEntitySound("..\\..\\Sounds\\golpe-metal-mediano.wav", "PinchosGolpeando1")

s1=Bladex.CreateEntity("PinchoManuel_3455","PinchoManuel",-41012.0,-6168.0,-46599.0, "Physic") #mL
s1.Scale=1.2
s1.Orientation=(0.0,0.707,0.0,-0.707)
s1.Frozen=1
s1din = Objects.CreateDinamicObject(s1.Name)

s2=Bladex.CreateEntity("PinchoManuel_3456","PinchoManuel",-40812.0,-6168.0,-38399.0, "Physic") #mR
s2.Scale=1.2
s2.Orientation=(0.707,0.0,-0.707,0.0)
s2.Frozen=1
s2din = Objects.CreateDinamicObject(s2.Name)

s3=Bladex.CreateEntity("PinchoManuel_3457","PinchoManuel",-40812.0,-7568.0,-38399.0, "Physic") #mR
s3.Scale=1.2
s3.Orientation=(0.707,0.0,-0.707,0.0)
s3.Frozen=1
s3din = Objects.CreateDinamicObject(s3.Name)

s4=Bladex.CreateEntity("PinchoManuel_3458","PinchoManuel",-40812.0,-8968.0,-38399.0, "Physic") #mR
s4.Scale=1.2
s4.Orientation=(0.707,0.0,-0.707,0.0)
s4.Frozen=1
s4din = Objects.CreateDinamicObject(s4.Name)

s5=Bladex.CreateEntity("PinchoManuel_3459","PinchoManuel",-41012.0,-8968.0,-46599.0, "Physic") #mL
s5.Scale=1.2
s5.Orientation=(0.0,0.707,0.0,-0.707)
s5.Frozen=1
s5din = Objects.CreateDinamicObject(s5.Name)

s6=Bladex.CreateEntity("PinchoManuel_3460","PinchoManuel",-41012.0,-7568.0,-46599.0, "Physic") #mL
s6.Scale=1.2
s6.Orientation=(0.0,0.707,0.0,-0.707)
s6.Frozen=1
s6din = Objects.CreateDinamicObject(s6.Name)

##########################################################################################################################
######## First gate to lower gallery  ****

gallerygate1=Bladex.CreateEntity("GalleryGate1","Reja",8786,4228,-33902,"Physic")
gallerygate1.Scale=3.0
gallerygate1.Orientation=0.707,-0.707,0.0,0.0
gallerygate1.Frozen=1
gallerygate1din=Objects.CreateDinamicObject("GalleryGate1")


gallerygate1rail=Bladex.CreateEntity("GalleryGate1Rail","Rail2",8833,6394,-33930,"Physic")
gallerygate1rail.Scale=0.3
gallerygate1rail.Orientation=0.5,-0.5,-0.5,0.5
gallerygate1rail.Frozen=1
gallerygate1raildin=Objects.CreateDinamicObject("GalleryGate1Rail")


gallerygate1lever=Levers.PlaceLever("GalleryGateLever",Levers.LeverType3,(6346,4715,-35905),(0.5,0.5,-0.5,0.5),0.8)
gallerygate1lever.mode=0
gallerygate1lever.OnTurnOnFunc=AbreGalleryGate1
gallerygate1lever.OnTurnOnArgs=()


#gallerygate1lever.OnTurnOffFunc=CierraGalleryGate1
#gallerygate1lever.OnTurnOffArgs=()

##########################################################################################################################
#### Observatory Gate

o=Bladex.CreateEntity("ObservatoryKey","Llavecutre",-40244,3534,-21927,"Physic")   
o.Scale=1.2
o.Orientation=0.5,0.25,-0.825,0.031
darfuncs.SetHint(o,Tr("Observatory Key"))
Stars.Twinkle("ObservatoryKey")
o.Impulse(0,0,0)

obsgate=Bladex.CreateEntity("ObservatoryGate","Rastrillo10",-43542,830,-23395,"Physic")
obsgate.Scale=0.7
obsgate.Orientation=0.5,0.5,-0.5,0.5
obsgate.Frozen=1
obsgatedin=Objects.CreateDinamicObject("ObservatoryGate")

obsgateloc=Locks.PlaceLock("ObservatoryLock","Cerraduracutre",(-43244,1534,-21927),(0.707,0.707,0.0,0.0),2.5)
obsgateloc.Scale=1.2
obsgateloc.Frozen=1
obsgateloc.key="ObservatoryKey"
darfuncs.SetHint(obsgateloc.obj,Tr("Observatory Lock"))
obsgateloc.OnUnLockFunc=AbreObsGate
obsgateloc.OnUnLockArgs=()

##########################################################################################################################
###### cellar gate

cellgate=Bladex.CreateEntity("CellarGate","Rastrillo10",8707,15736,-48355,"Physic")
cellgate.Scale=0.8
cellgate.Orientation=0.5,0.5,-0.5,0.5
cellgate.Frozen=1
cellgatedin=Objects.CreateDinamicObject("CellarGate")

cellgatelever=Levers.PlaceLever("CellarGateLever",Levers.LeverType3,(5637,17331,-50000),(0.0,1.27967922481e-007,0.707,-0.707),0.8)
cellgatelever.mode=1
cellgatelever.OnTurnOnFunc=OpenCellarGate
cellgatelever.OnTurnOnArgs=()
cellgatelever.OnTurnOffFunc=None
cellgatelever.OnTurnOffArgs=()

##########################################################################################################################
###### Store

door20=Doors.CreateDoor("Door20", (17250,-8000,9500), (0,1,0), 1500, 4200, Doors.CLOSED)
door20.opentype=Doors.UNIF
door20.o_med_vel=-480
door20.o_med_displ=2700
door20.closetype=Doors.AC
door20.c_init_displ=2700
door20.c_med_vel=5000

door20.SetWhileOpenSound(sdoor2d)
door20.SetEndOpenSound(sdoor2g)
door20.SetWhileCloseSound(sdoor2d)
door20.SetEndCloseSound(sdoor2g)


door20lever=Levers.PlaceLever("Door20Lever",Levers.LeverType3,(15116,-8368,7960),(0.5,0.5,-0.5,0.5),0.8)
door20lever.mode=1
door20lever.OnTurnOnFunc=OpenStoreDoor
door20lever.OnTurnOnArgs=()
door20lever.OnTurnOffFunc=None
door20lever.OnTurnOffArgs=()

##########################################################################################################################
######### Stairs down to basement from low bridge door

basementgate=Bladex.CreateEntity("BasementGate","Rastrillo10",-3086,7191,-12281,"Physic")
basementgate.Scale=0.8
basementgate.Orientation=0.5,0.5,0.5,-0.5
basementgate.Frozen=1
basementgatedin=Objects.CreateDinamicObject("BasementGate")


basementgate1vr=Levers.PlaceLever("BasementGateLever",Levers.LeverType3,(-932,9315,-14190),(0.0,1.27967922481e-007,0.707,-0.707),0.8)
basementgate1vr.mode=0
basementgate1vr.OnTurnOnFunc=AbreBasementGate
basementgate1vr.OnTurnOnArgs=()
basementgate1vr.OnTurnOffFunc=CierraBasementGate
basementgate1vr.OnTurnOffArgs=()

##########################################################################################################################
########## Kitchen Grill

## static
o=Bladex.CreateEntity("Rail2_3526","Rail2",914,353,-16661, Reference.ObjType("Rail2"))
o.Scale=0.4
o.Orientation=(0.653281450272,0.270598053932,-0.653281509876,-0.270598053932)

o=Bladex.CreateEntity("Rail2_3525","Rail2",798,-2703,-16688, Reference.ObjType("Rail2"))
o.Scale=0.4
o.Orientation=(0.707,0.0,-0.707,0.0)

o=Bladex.CreateEntity("Reja_3529","Reja",-451,-1153,-16688, Reference.ObjType("Reja"))
o.Static=1
o.Scale=2.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)

o=Bladex.CreateEntity("Rail2_3530","Rail2",716,-761,-16723, Reference.ObjType("Rail2"))
o.Scale=0.3
o.Orientation=(0.707,-0.707,0.0,0.0)

########### moving

slidehalfgrill=Bladex.CreateEntity("KitchenGrill","Reja",2020,-1153,-16688,"Physic")
slidehalfgrill.Scale=2.0
slidehalfgrill.Orientation=0.707,0.707,0.0,0.0
slidehalfgrill.Frozen=1
slidehalfgrilldin=Objects.CreateDinamicObject("KitchenGrill")

slidehalfgrillrail=Bladex.CreateEntity("KitchenGrillRail","Rail2",866.0,-47.0,-16723.0,"Physic")
slidehalfgrillrail.Scale=0.4
slidehalfgrillrail.Orientation=0.0,0.0,0.707,-0.707
slidehalfgrillrail.Frozen=1
slidehalfgrillraildin=Objects.CreateDinamicObject("KitchenGrillRail")

slidehalfgrill1vr=Levers.PlaceLever("KitchenGrillLever",Levers.LeverType2,(3890,-816,-17024),(0.5,0.5,0.5,-0.5),0.8)
slidehalfgrill1vr.mode=0

slidehalfgrill1vr.OnTurnOnFunc=AbreKitchenGrill
slidehalfgrill1vr.OnTurnOnArgs=()

slidehalfgrill1vr.OnTurnOffFunc=CierraKitchenGrill
slidehalfgrill1vr.OnTurnOffArgs=()

##########################################################################################################################
########### Hall Gate

o=Bladex.CreateEntity("Rail2_3537","Rail2",11500,-11097,-43341, Reference.ObjType("Rail2"))
o.Scale=0.6
o.Orientation=(1.0,0.0,0.0,0.0)


o=Bladex.CreateEntity("Rail2_3538","Rail2",11500,-6897,-43341, Reference.ObjType("Rail2"))
o.Scale=1.0
o.Orientation=(0.707,0.0,0.0,0.707)

#############
o=Bladex.CreateEntity("Rail2_3572","Rail2",11500,-8627,-41754, Reference.ObjType("Rail2"))
o.Scale=0.4
o.Orientation=(0.707,-0.707,0.0,0.0)


o=Bladex.CreateEntity("Rail2_3540","Rail2",11500,-8497,-43941, Reference.ObjType("Rail2"))
o.Scale=0.4
o.Orientation=(0.5,-0.5,0.5,0.5)
###########


o=Bladex.CreateEntity("Rastrillo10_3541","Rastrillo10",11500,-8697,-45341, Reference.ObjType("Rastrillo10"))
o.Scale=0.6
o.Orientation=(0.5,-0.5,-0.5,-0.5)


o=Bladex.CreateEntity("Rastrillo10_3542","Rastrillo10",11500,-8697,-40341, Reference.ObjType("Rastrillo10"))
o.Scale=0.6
o.Orientation=(0.5,-0.5,-0.5,-0.5)

#######opening

OpenDoorsTime=15.0
OpenDoorsPrec=0.025

swg1=Bladex.CreateEntity("Rastrillo10_3573","Rastrillo10",11521,-8667,-42854, Reference.ObjType("Rastrillo10"))
swg1.Scale=0.5
swg1.Orientation=(0.5,-0.5,-0.5,-0.5)

Bladex.CreateTimer("doortimer",OpenDoorsPrec)
OpenDoorsStartTime=0.0


#hp1=Bladex.CreateEntity("HandlePointer1","GhostPointer", 11641,-8100,-41414)
#hp1.Static=1
#hp1.Scale=1
#hp1.Orientation=0.707106769085,0.707106769085,0.0,0.0
#hp1.UseFunc=  OpenHallGate
#darfuncs.SetHint(hp1,Tr("Handle"))


#handle=Bladex.CreateEntity("Argolla_3574","Argolla",11641,-8067,-41414, Reference.ObjType("Argolla"))
#handle.Scale=1.0
#handle.Orientation=(0.5,0.5,-0.5,0.5)

##########################################################################################################################
######## Entrance to Caverns

caverngate=Bladex.CreateEntity("CavernGate","Rastrillo10",12899,15044,-20543,"Physic")
caverngate.Scale=1.0
caverngate.Orientation=0.5,0.5,-0.5,0.5
caverngate.Frozen=1
caverngatedin=Objects.CreateDinamicObject("CavernGate")


caverngatelever=Levers.PlaceLever("CavernGateLever",Levers.LeverType3,(8750,16900,-17750),(0.707,0.707,0.0,0.0),0.8)
caverngatelever.mode=0
caverngatelever.OnTurnOnFunc=AbreCavernGate
caverngatelever.OnTurnOnArgs=()
caverngatelever.OnTurnOffFunc=CierraCavernGate
caverngatelever.OnTurnOffArgs=()

##########################################################################################################################
########### Observatory Return Elevator

obselev=Bladex.CreateEntity("ObsReturnElev","Plataforma",-33687,-12500,-72325,"Physic")
obselev.Scale=4.6
obselev.Orientation=0.5,-0.5,-0.5,-0.5
obselev.Frozen=1
obselevdin=Objects.CreateDinamicObject("ObsReturnElev")


o=Bladex.CreateEntity("Zocalo3_3679","Zocalo3",-29424,4421,-69387, Reference.ObjType("Zocalo3"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
darfuncs.SetHint(o,Tr("Broken Lever"))


obselev1vrup=Levers.PlaceLever("ObsElevLeverUp",Levers.LeverType3,(-33614,4123,-69326),(0.707,0.707,0.0,0.0),0.8)
obselev1vrup.mode=1
obselev1vrup.OnTurnOnFunc=UpElevObs
obselev1vrup.OnTurnOnArgs=()


obselev1vrdown=Levers.PlaceLever("ObsElevLeverDown",Levers.LeverType3,(-33763,-14268,-69413),(0.707,0.707,0.0,0.0),0.8)
obselev1vrdown.mode=1
obselev1vrdown.OnTurnOnFunc=DownElevObs
obselev1vrdown.OnTurnOnArgs=()


obselev1vrcallup=Levers.PlaceLever("ObsElevLeverCallUp",Levers.LeverType3,(-38297,-14267,-74661),(0.0,0.0,0.707,-0.707),0.8)
obselev1vrcallup.mode=1
obselev1vrcallup.OnTurnOnFunc=UpElevObs
obselev1vrcallup.OnTurnOnArgs=()


obselgate=Bladex.CreateEntity("ObsReturnElevGate","Rastrillo10",-30773,3038,-72294,"Physic")
obselgate.Scale=0.8
obselgate.Orientation=0.5,0.5,-0.5,0.5
obselgate.Frozen=1
obselgatedin=Objects.CreateDinamicObject("ObsReturnElevGate")

##########################################################################################################################
###### Final Exit gate     

door21=Doors.CreateDoor("Door21", (98750,-3000,2750), (0,1,0), 4000, 9000, Doors.CLOSED)
door21.opentype=Doors.UNIF
door21.o_med_vel=-280
door21.o_med_displ=5000
door21.closetype=Doors.AC
door21.c_init_displ=5000
door21.c_med_vel=3000

door21.SetWhileOpenSound(sdoor1d)
door21.SetEndOpenSound(sdoor1g)
door21.SetWhileCloseSound(sdoor1d)
door21.SetEndCloseSound(sdoor1g)

##### these locks are dummies

o=Bladex.CreateEntity("Cerradurcob_4867","Cerradurcob",100287,-1345,-676, Reference.ObjType("Cerradurcob"))
o.Scale=2.6
o.Orientation=(0.182,0.294,-0.66,0.666)

o=Bladex.CreateEntity("Cerradurcob_4867x","Cerradurcob",100287,-1345,-676+150000, Reference.ObjType("Cerradurcob"))
o.Scale=2.6
o.Orientation=(0.182,0.294,-0.66,0.666)

#########################################################################################################################
################ gate to parapet

officegate=Bladex.CreateEntity("OfficeGate","Rastrillo10",-9653,-2041,-1736,"Physic")
officegate.Scale=0.6
officegate.Orientation=0.5,0.5,-0.5,0.5
officegate.Frozen=1
officegatedin=Objects.CreateDinamicObject("OfficeGate")

############## Pool Back gate

poolbackgate=Bladex.CreateEntity("PoolBackGate","Rastrillo10",50827,-2193,-19285,"Physic")
poolbackgate.Scale=0.8
poolbackgate.Orientation=0.707,0.707,0.0,0.0
poolbackgate.Frozen=1
poolbackgatedin=Objects.CreateDinamicObject("PoolBackGate")

##########################################################################################################################
##### lower door in secret tunnel

door22=Doors.CreateDoor("Door22", (29000,9000,5625), (0,1,0), 300, 3000, Doors.CLOSED)
door22.opentype=Doors.UNIF
door22.o_med_vel=-500
door22.o_med_displ=2700
door22.closetype=Doors.AC
door22.c_init_displ=2200
door22.c_med_vel=1000

door22.SetWhileOpenSound(sdoor1d)
door22.SetEndOpenSound(sdoor1g)
door22.SetWhileCloseSound(sdoor1d)
door22.SetEndCloseSound(sdoor1g)

door221vr=Levers.PlaceLever("Door22lever",Levers.LeverType3,(26580,9145,3634),(0.5,0.5,-0.5,0.5),0.8)
door221vr.mode=0
door221vr.OnTurnOnFunc=AbreDoor22
door221vr.OnTurnOnArgs=()

##########################################################################################################################
###### upper door in secret tunnel

door23=Doors.CreateDoor("Door23", (35250,-2500,3750), (0,1,0), 1300, 5300, Doors.CLOSED)
door23.opentype=Doors.UNIF
door23.o_med_vel=-500
door23.o_med_displ=4000
door23.closetype=Doors.AC
door23.c_init_displ=4000
door23.c_med_vel=1000

door23.SetWhileOpenSound(sdoor2d)
door23.SetEndOpenSound(sdoor1g)
door23.SetWhileCloseSound(sdoor2d)
door23.SetEndCloseSound(sdoor1g)

##########################################################################################################################
###### Guard Post

door24=Doors.CreateDoor("Door24", (20250,8000,-124500), (0,1,0), 300, 3000, Doors.OPENED)
door24.opentype=Doors.UNIF
door24.o_med_vel=-500
door24.o_med_displ=2700
door24.closetype=Doors.AC
door24.c_init_displ=2700
door24.c_med_vel=1000

##########################################################################################################################

higate=Bladex.CreateEntity("Rastrillo10_4985","Rastrillo10",-6692,-18388,-57927, Reference.ObjType("Rastrillo10"))
higate.Scale=0.8
higate.Orientation=(0.707,0.707,0.0,0.0)

##########################################################################################################################

# Hole in the big door across bridge 
o=Bladex.CreateEntity("PlataformaRail_7045","PlataformaRail",306922,12710,43642, Reference.ObjType("PlataformaRail"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.0,-0.707106769085,0.0)
o.Alpha=0






